
(****************************************************************************
                                                                           
          Buchberger : the realization of the algorithm                    
                                                                           
          Laurent Thery April 98 (revised Mai 98)                          
                                                                           
****************************************************************************)
Section Buch.
Load "shyp_buch".
Load "mod_crit".
Hypothesis Reduce1a:
           (Q:(list poly)) (p:poly){q:poly | (reducestar Q (s2p p) (s2p q))}.

Mutual Inductive reducetopO: (list poly) -> (list Term) ->Prop :=
     reducetopO_top:
       (Q:(list poly)) (p:(list Term)) (reducestar Q p pO) ->(reducetopO Q p) .

Local red := [a:poly] [P:(list poly)](reducetopO P (s2p a)).

Definition addEnd: poly -> (list poly) ->(list poly).
Intros a H'0; Elim H'0.
Exact (cons a (nil ?)).
Intros b L1 Rec; Exact (cons b Rec).
Defined.

Theorem addEnd_cons:
  (a, b:poly) (aL:(list poly)) (In a (addEnd b aL)) ->a=b \/ (In a aL).
Intros a b aL; Elim aL; Simpl; Auto.
Intros H'; Case H'; [Intros H'0; Rewrite <- H'0 | Intros H'0; Clear H']; Auto.
Intros a0 l H' H'0; Case H'0;
 [Intros H'1; Rewrite <- H'1; Clear H'0 | Intros H'1; Clear H'0]; Auto.
Case (H' H'1); Auto.
Qed.

Theorem addEnd_id1: (a:poly) (aL:(list poly))(In a (addEnd a aL)).
Intros a aL; Elim aL; Simpl; Auto.
Qed.

Theorem addEnd_id2:
  (a, b:poly) (aL:(list poly)) (In a aL) ->(In a (addEnd b aL)).
Intros a b aL; Elim aL; Simpl; Auto.
Intros a0 l H' H'0; Case H'0; Auto.
Qed.

Definition spolyp: poly -> poly ->poly.
Intros p q; Case p; Case q.
Intros x Cpx x0 Cpx0; Exists (spolyf x x0 Cpx Cpx0); Auto.
Defined.

Theorem spolyf_com:
  (a, b:(list Term)) (Ca:(canonical a)) (Cb:(canonical b))
  (eqP (spolyf a b Ca Cb) (multm_lm (invTerm T1) (spolyf b a Cb Ca))).
Intros a b; Case a; Case b; Simpl; Auto.
Intros a0 l a1 l0 Cpxa0 Cpxa1.
Cut ~ (zeroP a0); [Intros nZa0 | Apply canonical_nzeroP with p := l; Auto].
Cut ~ (zeroP a1); [Intros nZa1 | Apply canonical_nzeroP with p := l0; Auto].
Change (eqP
          (minuspf
             (multm_lm
                (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0)
             (multm_lm (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l))
          (multm_lm
             (invTerm T1)
             (minuspf
                (multm_lm
                   (divTerm (ppc a0 a1) a0 (canonical_nzeroP a0 l Cpxa1)) l)
                (multm_lm
                   (divTerm (ppc a0 a1) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0)))).
Cut (canonical l); [Intros Op1 | EAuto].
Cut (canonical l0); [Intros Op2 | EAuto].
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm
                (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0)
             (multm_lm
                (invTerm T1)
                (multm_lm
                   (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l)));
 [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm
                T1
                (multm_lm
                   (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0))
             (multm_lm
                (invTerm T1)
                (multm_lm
                   (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l))).
Apply eqp_sym; Apply eqp_pluspf_com; Auto.
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm
                (invTerm (invTerm T1))
                (multm_lm
                   (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0))
             (multm_lm
                (invTerm T1)
                (multm_lm
                   (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l)));
 [Apply eqp_pluspf_com; Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm
                (invTerm (multTerm T1 (invTerm T1)))
                (multm_lm
                   (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0))
             (multm_lm
                (invTerm T1)
                (multm_lm
                   (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l)));
 [Apply eqp_pluspf_com; Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm
                (multTerm (invTerm T1) (invTerm T1))
                (multm_lm
                   (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0))
             (multm_lm
                (invTerm T1)
                (multm_lm
                   (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l)));
 [Apply eqp_pluspf_com; Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm
                (invTerm T1)
                (multm_lm
                   (invTerm T1)
                   (multm_lm
                      (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0)))
             (multm_lm
                (invTerm T1)
                (multm_lm
                   (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l)));
 [Apply eqp_pluspf_com; Auto | Idtac].
Apply canonical_multlm_lm; Auto.
Apply eqp_trans
     with y :=
          (multm_lm
             (invTerm T1)
             (pluspf
                (multm_lm
                   (invTerm T1)
                   (multm_lm
                      (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0))
                (multm_lm
                   (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l))).
Apply eqp_sym; Auto.
Apply multlm_lm_dist_pluspf; Auto.
Apply eqp_trans
     with y :=
          (multm_lm
             (invTerm T1)
             (pluspf
                (multm_lm
                   (divTerm (ppc a1 a0) a0 (canonical_nzeroP a0 l Cpxa1)) l)
                (multm_lm
                   (invTerm T1)
                   (multm_lm
                      (divTerm (ppc a1 a0) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0)))).
Apply multm_lm_comp; Auto.
Apply multm_lm_comp; Auto.
Apply eqp_sym; Auto.
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm (divTerm (ppc a0 a1) a0 (canonical_nzeroP a0 l Cpxa1)) l)
             (multm_lm
                (invTerm T1)
                (multm_lm
                   (divTerm (ppc a0 a1) a1 (canonical_nzeroP a1 l0 Cpxa0)) l0)));
 Auto.
Apply eqp_pluspf_com; Auto.
Qed.

Theorem red_com:
  (a, b:poly) (aL:(list poly)) (red (spolyp a b) aL) ->(red (spolyp b a) aL).
Intros a b; Case a; Case b; Simpl.
Unfold red; Simpl.
Intros x Cx x0 Cx0 aL H'1; Inversion H'1.
Cut (canonical (spolyf x x0 Cx Cx0)); [Intros Op1 | Apply spolyf_canonical];
 Auto.
Cut (canonical (spolyf x0 x Cx0 Cx)); [Intros Op2 | Apply spolyf_canonical];
 Auto.
Apply reducetopO_top; Auto.
Apply reducestar0; Auto.
Apply reduceplus_eqp_com
     with p := (multm_lm (invTerm T1) (spolyf x x0 Cx Cx0))
          q := (multm_lm (invTerm T1) pO); Auto.
Apply reduceplus_multm; Auto.
Inversion H; Auto.
Apply eqp_sym; Auto.
Apply spolyf_com; Auto.
Inversion H; Auto.
Qed.
Require Import LetP.

Theorem spolyf_pO:
  (a:(list Term)) (Ca:(canonical a))(eqP (spolyf a a Ca Ca) pO).
Intros a; Case a; Simpl; Unfold LetP; Auto.
Qed.

Theorem rstar_rtopO:
  (Q:(list poly)) (p:(list Term)) (canonical p) -> (reduceplus Q p pO) ->
  (reducetopO Q p).
Intros Q p H' H'0.
Elim (reduce0_reducestar Q pO); [Intros t E | Idtac]; Auto.
Apply reducetopO_top; Auto.
Apply reducestar0; Auto.
Apply pO_irreducible; Auto.
Qed.

Theorem In_inp_inPolySet:
  (Q:(list poly)) (p:poly) (In p Q) -> ~ (eqP (s2p p) pO) ->
  (inPolySet (s2p p) Q).
Intros Q; Elim Q; Simpl; Auto.
Intros p H'; Elim H'.
Intros a l H' p H'0; Elim H'0;
 [Intros H'1; Rewrite H'1; Clear H'0 | Intros H'1; Clear H'0]; Auto.
Case p; Simpl; Auto.
Intros x; Case x; Simpl; Auto.
Intros c H'0; Elim H'0; Auto.
Qed.

Theorem red_cons: (a:poly) (p:(list poly)) (In a p) ->(red a p).
Intros a; Case (seqp_dec a spO).
Case a; Unfold red spO seqP; Simpl.
Intros x c H' p H'0; Inversion H'; Auto.
Apply reducetopO_top; Auto.
Apply reducestar_pO_is_pO with p := x; Auto.
Case a; Unfold red spO seqP; Simpl.
Intros x c H' p H'0.
Apply rstar_rtopO; Auto.
Apply Rstar_n with y := pO; Auto.
Apply reduce_in_pO; Auto.
Generalize (In_inp_inPolySet
              p (exist (list Term) [l:(list Term)](canonical l) x c)); Simpl;
 Auto.
Intros H'1; Apply H'1; Auto.
Red; Intros H'2; Apply H'; Apply eqp_sym; Auto.
Qed.

Theorem red_id: (a:poly) (aL:(list poly))(red (spolyp a a) aL).
Intros a P; Case a.
Unfold red; Simpl; Auto.
Intros x H'.
Apply rstar_rtopO; Auto.
Apply Rstar_0; Auto.
Apply spolyf_pO; Auto.
Qed.

Theorem inP_reduce:
  (P, Q:(list poly)) ((a:(list Term)) (inPolySet a Q) ->(inPolySet a P)) ->
  (a, b:(list Term)) (reduce Q a b) ->(reduce P a b).
Intros P Q H' a b H'0; Elim H'0; Auto.
Intros a0 b0 nZb p q r H'1 H'2 H'3; Auto.
Apply reducetop with b := b0 nZb := nZb q := q; Auto.
Qed.

Theorem inP_reduceplus:
  (P, Q:(list poly)) ((a:(list Term)) (inPolySet a Q) ->(inPolySet a P)) ->
  (a, b:(list Term)) (reduceplus Q a b) ->(reduceplus P a b).
Intros P Q H' a b H'0; Elim H'0; Auto.
Intros x y z H'1 H'2 H'3.
Apply Rstar_n with y := y; Auto.
Apply inP_reduce with Q := Q; Auto.
Qed.

Theorem inP_reducestar:
  (P, Q:(list poly)) ((a:(list Term)) (inPolySet a Q) ->(inPolySet a P)) ->
  (a, b:(list Term)) (reducestar Q a b) ->(reduceplus P a b).
Intros P Q H' a b H'0; Inversion H'0; Auto.
Apply inP_reduceplus with Q := Q; Auto.
Qed.

Theorem in_inPolySet:
  (P:(list poly)) (p:poly) (In p P) -> ~ (eqP (s2p p) pO) ->
  (inPolySet (s2p p) P).
Intros P; Elim P; Auto.
Intros p H'; Inversion H'.
Simpl.
Intros a l H' p H'0; Elim H'0;
 [Intros H'1; Rewrite <- H'1; Clear H'0 | Intros H'1; Clear H'0]; Auto.
Case a; Simpl.
Intros x; Case x; Auto.
Intros c H'0; Elim H'0; Auto.
Qed.

Theorem inPolySet_inv0:
  (P:(list poly)) (p:(list Term)) (inPolySet p P) ->~ (eqP p pO).
Intros P p H'; Elim H'; Auto.
Intros a p0 H'0 H'1; Red; Intros H'2; Inversion H'2.
Qed.

Theorem inPolySet_inv1:
  (P:(list poly)) (p:(list Term)) (inPolySet p P) ->
  (Ex [q:poly] (In q P) /\ p=(s2p q)).
Intros P p H'; Elim H'; Auto.
Intros a p0 H P0.
Exists (exist (list Term) [l0:(list Term)](canonical l0) (cons a p0) H); Split;
 Simpl; Auto.
Intros a p0 P0 H'0 H'1; Elim H'1; Intros q E; Elim E; Intros H'2 H'3;
 Clear E H'1.
Exists q; Split; Simpl; Auto.
Qed.

Theorem Incl_inp_inPolySet:
  (P, Q:(list poly)) (incl P Q) ->
  (p:(list Term)) (inPolySet p P) ->(inPolySet p Q).
Intros P Q H' p H'0; Auto.
Elim (inPolySet_inv1 P p);
 [Intros q E; Elim E; Intros H'4 H'5; Clear E | Idtac]; Auto.
Rewrite H'5.
Apply in_inPolySet; Auto.
Rewrite <- H'5; Auto.
Apply inPolySet_inv0 with P := P; Auto.
Qed.

Theorem red_incl:
  (a:poly) (p, q:(list poly)) (incl p q) -> (red a p) ->(red a q).
Unfold red.
Intros a p q H' H'0.
Inversion H'0.
Apply rstar_rtopO; Auto.
Case a; Auto.
Apply inP_reducestar with Q := p; Auto.
Intros a0 H'1.
Apply Incl_inp_inPolySet with P := p; Auto.
Qed.

Definition zerop: poly ->Prop.
Intros H'; Case H'.
Intros x; Case x.
Intros H'0; Exact True.
Intros a l H'0; Exact False.
Defined.

Theorem zerop_dec: (a:poly){(zerop a)}+{~ (zerop a)}.
Intros H'; Case H'.
Intros x; Case x.
Intros c; Left; Simpl; Auto.
Intros a l c; Right; Red; Intros H'0; Inversion H'0.
Qed.

Definition divp: poly -> poly ->Prop.
Intros H'; Case H'.
Intros x; Case x.
Intros H'0 H'1; Exact False.
Intros a l H'0 H'1; Case H'1.
Intros x0; Case x0.
Intros H'2; Exact False.
Intros a0 l0 H'2.
Exact (divP a a0).
Defined.

Theorem divp_trans: (transitive poly divp).
Red.
Intros x y z; Case x; Case y; Case z.
Intros x0 c x1 c0 x2 c1; Generalize c c0 c1; Case x0; Case x1; Case x2; Simpl;
 Auto.
Intros a l a0 l0 H' H'0 H'1 H'2; Elim H'2.
Intros a l a0 l0 a1 l1 H' H'0 H'1 H'2 H'3.
Apply divP_trans with y := a0; Auto.
Qed.

Theorem divp_dec: (a, b:poly){(divp a b)}+{~ (divp a b)}.
Intros a b; Case a; Case b.
Intros x c x0 c0; Generalize c c0; Case x; Case x0; Simpl.
Intros H' H'0; Right; Red; Intros H'1; Elim H'1.
Intros a0 l H' H'0; Right; Red; Intros H'1; Elim H'1.
Intros a0 l H' H'0; Right; Red; Intros H'1; Elim H'1.
Intros a0 l a1 l0 H' H'0.
Apply divP_dec; Auto.
Apply canonical_nzeroP with p := l; Auto.
Apply canonical_nzeroP with p := l0; Auto.
Qed.

Definition ppcp: poly -> poly ->poly.
Intros H'; Case H'.
Intros x; Case x.
Intros H'0 H'1; Exists pO; Auto.
Intros a l H'0 H'1; Case H'1.
Intros x0; Case x0.
Intros H'2; Exists pO; Auto.
Intros a0 l0 H'2; Exists (cons (ppc a a0) pO).
Apply canonical1; Auto.
Apply ppc_nZ; Auto.
Apply canonical_nzeroP with p := l; Auto.
Apply canonical_nzeroP with p := l0; Auto.
Defined.

Theorem divp_ppc: (a, b, c:poly) (divp (ppcp a b) c) ->(divp (ppcp b a) c).
Intros a b c; (Case a; Case b; Case c).
Intros x c0 x0 c1 x1 c2; Generalize c0 c1 c2; Case x; Case x0; Case x1; Simpl;
 Auto.
Intros a0 l a1 l0 a2 l1 H' H'0 H'1 H'2.
Apply divP_eqTerm_comp with a := (ppc a0 a1); Auto.
Qed.

Theorem zerop_ddivp_ppc:
  (a, b:poly) ~ (zerop a) -> ~ (zerop b) ->(divp (ppcp a b) b).
Intros a b; (Case a; Case b).
Intros x c0 x0 c1; Generalize c0 c1; Case x; Case x0; Simpl; Auto.
Intros a0 l a1 l0 H' H'0 H'1 H'2.
Apply divP_pccr; Auto.
Apply canonical_nzeroP with p := l; Auto.
Apply canonical_nzeroP with p := l0; Auto.
Qed.

Theorem divp_nzeropl: (a, b:poly) (divp a b) ->~ (zerop a).
Intros a b; (Case a; Case b).
Intros x c0 x0 c1; Generalize c0 c1; Case x; Case x0; Simpl; Auto.
Qed.

Theorem divp_nzeropr: (a, b:poly) (divp a b) ->~ (zerop b).
Intros a b; (Case a; Case b).
Intros x c0 x0 c1; Generalize c0 c1; Case x; Case x0; Simpl; Auto.
Qed.
Hints Resolve pO_irreducible.

Theorem reducetopO_pO: (Q:(list poly))(reducetopO Q pO).
Intros Q; Apply reducetopO_top; Auto.
Apply reducestar0; Auto.
Qed.
Hints Resolve reducetopO_pO.

Theorem zerop_red_spoly_l:
  (a, b:poly) (zerop a) ->(Q:(list poly))(red (spolyp a b) Q).
Intros a b; (Case a; Case b).
Intros x c0 x0 c1; Generalize c0 c1; Case x; Case x0; Simpl; Auto.
Intros c2 c3 H' Q; Unfold red; Simpl; Auto.
Intros a0 l c2 c3 H'; Elim H'.
Intros a0 l c2 c3 H' Q; Unfold red; Simpl; Auto.
Intros a0 l a1 l0 c2 c3 H'; Elim H'.
Qed.

Theorem zerop_red_spoly_r:
  (a, b:poly) (zerop b) ->(Q:(list poly))(red (spolyp a b) Q).
Intros a b; (Case a; Case b).
Intros x c0 x0 c1; Generalize c0 c1; Case x; Case x0; Simpl; Auto.
Intros c2 c3 H' Q; Unfold red; Simpl; Auto.
Intros a0 l c2 c3 H' Q; Unfold red; Simpl; Auto.
Intros a0 l c2 c3 H'; Elim H'.
Intros a0 l a1 l0 c2 c3 H'; Elim H'.
Qed.

Theorem divP_ppc: (a, b, c:poly) (divp a b) -> (divp a c) ->(divp a (ppcp b c)).
Intros a b c; (Case a; Case b; Case c).
Intros x c0 x0 c1 x1 c2; Generalize c0 c1 c2; Case x; Case x0; Case x1; Simpl;
 Auto.
Intros a0 l a1 l0 a2 l1 H' H'0 H'1 H'2 H'3.
LApply (pcc_is_ppcm a1 a2);
 [Intros H'6; LApply H'6; [Intros H'7; Inversion H'7; Clear H'6 | Clear H'6] |
   Idtac]; Auto.
Apply H; Auto.
Apply canonical_nzeroP with p := l1; Auto.
Apply canonical_nzeroP with p := l0; Auto.
Qed.

Definition Cb: poly -> (list poly) ->Prop.
Intros H'; Case H'.
Intros x H'0 Q; Exact (CombLinear Q x).
Defined.

Theorem Cb_id: (a:poly) (Q:(list poly)) (In a Q) ->(Cb a Q).
Intros a; Case a; Simpl.
Intros x; Case x; Auto.
Intros c Q H'.
Apply CombLinear0; Auto.
Intros a0 l c Q H'.
Generalize H' c x;
 Generalize (in_inPolySet
               Q (exist (list Term) [l0:(list Term)](canonical l0) (pX a0 l) c));
 Simpl; Auto.
Intros H'0 H'1 H'2 H'3.
Apply CombLinear_id; Auto.
Apply H'0; Auto.
Red; Intros H'4; Inversion H'4.
Qed.

Theorem inPolySet_addEnd:
  (a:(list Term)) (p:poly) (l:(list poly)) (inPolySet a (addEnd p l)) ->
  a=(s2p p) \/ (inPolySet a l).
Intros a p l; Elim l; Simpl; Auto.
Intros H'; Inversion H'; Auto.
Intros a0 l0 H' H'0; Inversion H'0; Auto.
Case (H' H1); Auto.
Qed.

Remark CombLinear_trans1:
  (a:(list Term)) (R:(list poly)) (CombLinear R a) ->
  (b:poly) (Q:(list poly)) R=(addEnd b Q) -> (CombLinear Q (s2p b)) ->
  (CombLinear Q a).
Intros a R H'; Elim H'; Auto.
Intros b Q H'0 H'1.
Apply CombLinear0; Auto.
Intros a0 p q s H'0 H'1 H'2 H'3 H'4 b Q H'5 H'6.
Apply CombLinear_comp with p := (pluspf (multm_lm a0 q) p); Auto.
2:Apply eqp_imp_canonical with p := (pluspf (multm_lm a0 q) p); Auto.
2:Apply eqp_sym; Auto.
2:Apply canonical_pluspf; Auto.
2:Apply canonical_multlm_lm; Auto.
2:Apply inPolySet_imp_canonical with L := R; Auto.
2:Apply CombLinear_canonical with Q := R; Auto.
2:Apply eqp_sym; Auto.
Apply CombLinear_pluspf; Auto.
Apply CombLinear_multm_lm; Auto.
2:Apply H'3 with b := b; Auto.
Case (inPolySet_addEnd q b Q); Auto.
Rewrite <- H'5; Auto.
Intros H'7; Rewrite H'7; Auto.
Try Exact (CombLinear_id Q q).
Qed.

Theorem Cb_trans:
  (a, b:poly) (Q:(list poly)) (Cb a (addEnd b Q)) -> (Cb b Q) ->(Cb a Q).
Intros a b; Case a; Case b; Simpl; Auto.
Intros x c x0 H' Q H'0 H'1.
Apply CombLinear_trans1
     with R := (addEnd (exist (list Term) [l:(list Term)](canonical l) x c) Q)
          b := (exist (list Term) [l:(list Term)](canonical l) x c); Auto.
Qed.

Theorem CombLinear_incl:
  (a:(list Term))
  (P, Q:(list poly))
  ((a:(list Term)) (inPolySet a P) ->(inPolySet a Q)) -> (CombLinear P a) ->
  (CombLinear Q a).
Intros a P Q H' H'0; Elim H'0; Auto.
Apply CombLinear0; Auto.
Intros a0 p q s H'1 H'2 H'3 H'4 H'5.
Apply CombLinear_comp with p := (pluspf (multm_lm a0 q) p); Auto.
Apply CombLinear_pluspf; Auto.
Apply CombLinear_multm_lm; Auto.
Apply CombLinear_id; Auto.
Apply eqp_imp_canonical with p := (pluspf (multm_lm a0 q) p); Auto.
Apply eqp_sym; Auto.
Apply canonical_pluspf; Auto.
Apply canonical_multlm_lm; Auto.
Apply inPolySet_imp_canonical with L := P; Auto.
Apply CombLinear_canonical with Q := Q; Auto.
Apply eqp_sym; Auto.
Qed.

Theorem Cb_incl:
  (a:poly) (P, Q:(list poly)) ((a:poly) (In a P) ->(In a Q)) -> (Cb a P) ->
  (Cb a Q).
Intros a; Case a; Simpl; Auto.
Intros x H' P Q H'0 H'1.
Apply CombLinear_incl with P := P; Auto.
Intros a0 H'2.
Apply Incl_inp_inPolySet with P := P; Auto.
Qed.

Theorem Cb_in1: (a, b:poly) (Q:(list poly)) (Cb a Q) ->(Cb a (cons b Q)).
Intros a b Q H'.
Apply Cb_incl with P := Q; Simpl; Auto.
Qed.

Theorem Cb_in: (a, b:poly) (Q:(list poly)) (Cb a Q) ->(Cb a (addEnd b Q)).
Intros a b Q H'.
Apply Cb_incl with P := Q; Simpl; Auto.
Intros a0 H'0; Apply addEnd_id2; Auto.
Qed.

Theorem Cb_sp:
  (a, b:poly) (Q:(list poly)) (Cb a Q) -> (Cb b Q) ->(Cb (spolyp a b) Q).
Intros a b; Case a; Case b; Simpl; Auto.
Intros x; Case x; Auto.
Intros a0 l H' x0; Case x0; Auto.
Intros a1 l0 H'0 Q H'1 H'2.
Cut ~ (zeroP a0); [Intros Z0 | Apply canonical_nzeroP with p := l; Auto].
Cut ~ (zeroP a1); [Intros Z1 | Apply canonical_nzeroP with p := l0; Auto].
Apply CombLinear_comp
     with p :=
          (minuspf
             (multm_lm (divTerm (ppc a0 a1) a0 Z0) (pX a0 l))
             (multm_lm (divTerm (ppc a0 a1) a1 Z1) (pX a1 l0))); Auto.
Apply CombLinear_minuspf; Auto.
Apply CombLinear_multm_lm; Auto.
Apply CombLinear_multm_lm; Auto.
Apply eqp_sym; Auto.
Apply spoly_is_minus; Auto.
Qed.
Variable unit:poly ->Term.
Hypothesis unit_T1:(p:poly)(eqM (unit p) T1).
Hypothesis unit_nZ:(p:poly)~ (zeroP (unit p)).

Local mks: (p:(list Term)) (canonical p) ->poly.
Intros p H'; Exists p; Exact H'.
Defined.

Definition nf: poly -> (list poly) ->poly.
Intros p L.
Specialize 2 Reduce1a with Q := L p := p; Intros H'0; Case H'0.
Intros x H'.
Apply LetP with A := poly h := x.
Intros u H'1; Case u.
Intros x0 H'2; Exists (multm_lm (unit (mks x0 H'2)) x0); Auto.
Defined.

Theorem nf_irreducible:
  (p:poly) (aP:(list poly))(irreducible aP (s2p (nf p aP))).
Unfold nf.
Intros p aP; Case (Reduce1a aP p).
Intros x; Case x; Simpl; Auto.
Intros x0 c H'; Inversion H'.
Red in H0.
Red; Red.
Intros q0; Red; Intros H'0; Auto.
Cut ~ (zeroP (unit (mks x0 c))); [Intros nZd | Idtac]; Auto.
Specialize 1 H0 with q := (multm_lm (divTerm T1 (unit (mks x0 c)) nZd) q0);
 Intros H'1; Apply H'1; Clear H'1; Auto.
Apply reduce_multm_invf; Auto.
Qed.

Theorem nf_red:
  (a:poly) (aP, aQ:(list poly)) (incl aP aQ) -> (red (nf a aP) aQ) ->(red a aQ).
Intros a; Case a; Simpl.
Unfold red; Unfold nf; Simpl; Auto.
Intros x c aP aQ H';
 Case (Reduce1a aP (exist (list Term) [l:(list Term)](canonical l) x c)); Simpl;
 Auto.
Intros x0; Case x0; Simpl; Auto.
Intros x1 c0 H'0 H'1.
Apply rstar_rtopO; Auto.
Apply (reduceplus_trans aQ) with y := x1; Auto.
Inversion H'0; Auto.
Apply inP_reduceplus with Q := aP; Auto.
Intros a0 H'1.
Apply Incl_inp_inPolySet with P := aP; Auto.
Apply reduceplus_multm_inv with a := (unit (mks x1 c0)); Auto.
Simpl; Auto.
Inversion H'1; Inversion H; Auto.
Qed.

Theorem red_zerop: (a:poly) (P:(list poly)) (red (nf a P) P) ->(zerop (nf a P)).
Unfold nf.
Intros p aP; Case p; Simpl.
Intros x c.
Case (Reduce1a aP (exist (list Term) [l:(list Term)](canonical l) x c)); Simpl;
 Auto.
Unfold red; Simpl; Auto.
Intros x0; Case x0; Simpl.
Intros x1; Case x1; Simpl; Auto.
Intros a l c0 H' H'0; Inversion H'.
Red in H0.
Inversion H'0.
Inversion H3.
Inversion H6.
Inversion H10.
Cut ~ (zeroP (unit (mks (pX a l) c0))); [Intros nZd | Idtac]; Auto.
Specialize 1 H0 with q := (multm_lm (divTerm T1 (unit (mks (pX a l) c0)) nZd) y);
 Intros H'1; Apply H'1; Clear H'1; Auto.
Apply reduce_multm_invf; Auto.
Qed.

Theorem zerop_red: (a:poly) (aP:(list poly)) (zerop (nf a aP)) ->(red a aP).
Intros a aP H'.
Apply nf_red with aP := aP; Auto with datatypes.
Generalize H'; Case (nf a aP); Simpl; Auto.
Intros x; Case x; Simpl; Auto.
Intros c H'0; Red; Simpl; Auto.
Intros a0 l H'0 H'1; Elim H'1; Auto.
Qed.

Theorem reduce_minuspf:
  (a, b:(list Term)) (Q:(list poly)) (reduce Q a b) -> (canonical a) ->
  (Ex [c:(list Term)]
  (Ex [d:Term]
  (inPolySet c Q) /\
  ((canonical c) /\ (~ (zeroP d) /\ (eqP b (minuspf a (multm_lm d c))))))).
Intros a b Q H'; Elim H'; Auto.
Intros a0 b0 nZb0 p q r H'0 H'1 H'2 H'3; Cut (canonical (pX b0 q));
 [Intros Cb0q | Apply inPolySet_imp_canonical with L := Q; Auto];
 Exists (pX b0 q); Exists (divTerm a0 b0 nZb0); Split;
 [Idtac | Split; [Idtac | Split]]; Auto.
Apply eqp_trans with y := (spminusf a0 b0 nZb0 p q).
Apply eqp_sym; Auto.
Apply eqp_trans with y := (spminusf a0 b0 nZb0 (pX a0 p) (pX b0 q)); Auto.
Intros a0 b0 p q H'0 H'1 H'2 H'3.
Cut (canonical p); [Intros Op1 | EAuto].
Cut (canonical q); [Intros Op2 | Apply canonical_reduce with Q := Q p := p];
 Auto.
Cut ~ (zeroP a0); [Intros ZO | Apply canonical_nzeroP with p := p]; Auto.
Elim H'1;
 [Intros c E; Elim E; Intros d E0; Elim E0; Intros H'4 H'5; Elim H'5;
   Intros H'6 H'7; Elim H'7; Intros H'8 H'9; Clear H'7 H'5 E0 E H'1 | Clear H'1];
 Auto.
Exists c; Exists d; Split; [Idtac | Split; [Idtac | Split]]; Auto.
Cut (canonical (pX a0 q)); [Intros Op3 | Idtac]; Auto.
2:Apply ltP_pX_canonical; Auto.
2:Apply ltP_trans with y := p; Auto.
2:Apply ltP_reduce with Q := Q; Auto.
Apply eqp_trans with y := (pluspf (pX a0 pO) q); Auto.
Rewrite <- pluspf_inv1_eqa; Auto.
Apply eqp_sym; Auto.
Apply eqp_trans with y := (pluspf (pX a0 pO) (minuspf p (multm_lm d c))); Auto.
Apply eqp_trans
     with y :=
          (pluspf (pX a0 pO) (pluspf p (multm_lm (invTerm T1) (multm_lm d c))));
 Auto.
Apply eqp_trans
     with y :=
          (pluspf (pluspf (pX a0 pO) p) (multm_lm (invTerm T1) (multm_lm d c)));
 Auto.
Apply eqp_sym; Auto.
Apply eqp_trans
     with y := (pluspf (pX a0 p) (multm_lm (invTerm T1) (multm_lm d c))); Auto.
Rewrite <- pluspf_inv1_eqa; Auto.
Apply eqp_sym; Auto.
Qed.

Theorem reduce_cb:
  (a, b:(list Term))
  (Q:(list poly)) (reduce Q a b) -> (canonical a) -> (CombLinear Q a) ->
  (CombLinear Q b).
Intros a b Q H' H'0 H'1.
Cut (canonical b); [Intros Op1 | Apply canonical_reduce with Q := Q p := a];
 Auto.
Elim (reduce_minuspf a b Q);
 [Intros c E; Elim E; Intros d E0; Elim E0; Intros H'7 H'8; Elim H'8;
   Intros H'9 H'10; Elim H'10; Intros H'11 H'12; Clear H'10 H'8 E0 E | Idtac |
   Idtac]; Auto.
Apply CombLinear_comp with p := (minuspf a (multm_lm d c)); Auto.
Apply CombLinear_minuspf; Auto.
Apply CombLinear_multm_lm; Auto.
Apply CombLinear_id; Auto.
Apply eqp_sym; Auto.
Qed.

Theorem reduceplus_cb:
  (a, b:(list Term))
  (Q:(list poly)) (reduceplus Q a b) -> (canonical a) -> (CombLinear Q a) ->
  (CombLinear Q b).
Intros a b Q H'; Elim H'; Auto.
Intros x y H'0 H'1 H'2.
Apply CombLinear_comp with p := x; Auto.
Apply eqp_imp_canonical with p := x; Auto.
Intros x y z H'0 H'1 H'2 H'3 H'4.
Apply H'2; Auto.
Apply canonical_reduce with Q := Q p := x; Auto.
Apply reduce_cb with a := x; Auto.
Qed.

Theorem reducestar_cb:
  (a, b:(list Term))
  (Q:(list poly)) (reducestar Q a b) -> (canonical a) -> (CombLinear Q a) ->
  (CombLinear Q b).
Intros a b Q H'; Elim H'; Auto.
Intros p q H'0 H'1 H'2 H'3.
Apply reduceplus_cb with a := p; Auto.
Qed.

Theorem canonical_s2p: (x:poly)(canonical (s2p x)).
Intros x; Case x; Auto.
Qed.
Hints Resolve canonical_s2p.

Theorem nf_Cb: (a:poly) (aP:(list poly)) (Cb a aP) ->(Cb (nf a aP) aP).
Intros a; Case a; Unfold nf Cb; Simpl; Auto.
Intros x c Q H';
 Case (Reduce1a Q (exist (list Term) [l:(list Term)](canonical l) x c)); Simpl;
 Auto.
Intros x0; Case x0; Simpl.
Intros x1 H'0 H'1.
Apply CombLinear_multm_lm; Auto.
Apply reducestar_cb with a := x; Auto.
Qed.

Definition foreigner: poly -> poly ->Prop.
Intros a b; Case a; Case b.
Intros x; Case x.
Intros H' x0 H'0; Exact True.
Intros a0 l H' x0; Case x0.
Intros H'0; Exact True.
Intros a1 l0 H'0; Exact (eqM (ppc a0 a1) (multTerm a0 a1)).
Defined.

Definition foreigner_dec: (a, b:poly){(foreigner a b)}+{~ (foreigner a b)}.
Intros a b; Case a; Case b.
Intros x; Case x.
Simpl; Auto.
Intros a0 l c x0; Case x0; Simpl; Auto.
Intros a1 l0 H'.
Apply eqM_dec; Auto.
Defined.

Theorem foreigner_red:
  (a, b:poly) (P:(list poly)) (foreigner a b) -> (In a P) -> (In b P) ->
  (red (spolyp a b) P).
Intros a b; Case a; Case b.
Intros x; Case x.
Simpl; Auto.
Unfold red; Simpl; Auto.
Intros a0 l c x0; Case x0.
Unfold red; Simpl; Auto.
Unfold red; Simpl; Auto.
Intros a1 l0 c0 P H' H'0 H'1.
Apply reducetopO_top; Auto.
Unfold LetP; Simpl; Auto.
Apply reducestar_eqp_com with p := (spolyf (pX a0 l) (pX a1 l0) c c0) q := pO;
 Auto.
Apply spoly_Reducestar_ppc; Auto.
Generalize (in_inPolySet
              P (exist (list Term) [l:(list Term)](canonical l) (cons a1 l0) c0));
 Simpl; Intros H'2; Apply H'2; Auto.
Red; Intros H'3; Inversion H'3; Auto.
Generalize (in_inPolySet
              P (exist (list Term) [l0:(list Term)](canonical l0) (cons a0 l) c));
 Simpl; Intros H'2; Apply H'2; Auto.
Red; Intros H'3; Inversion H'3; Auto.
Qed.
Require Import OBuch.
Hypothesis RO:(list poly) -> (list poly) ->Prop.
Hypothesis wf_RO:(well_founded (list poly) RO).
Hypothesis RO_lem:
           (a:poly) (P:(list poly)) ~ (zerop (nf a P)) ->
           (RO (addEnd (nf a P) P) P).

Definition buchf :=
   (buch
      poly spolyp divp divp_dec addEnd addEnd zerop zerop_dec ppcp nf RO wf_RO
      RO_lem foreigner foreigner_dec).

Local reds: poly -> poly -> (list poly) ->Prop :=
   (reds poly spolyp divp red ppcp).

Local buch_reds:
  (P:(list poly)) (a, b:poly) (In a (buchf P)) -> (In b (buchf P)) ->
  (reds a b (buchf P)) :=
   (buch_reds
      poly spolyp divp divp_trans divp_dec addEnd addEnd_cons addEnd_id1
      addEnd_id2 addEnd addEnd_id1 addEnd_id2 red red_com red_incl red_cons
      red_id zerop zerop_dec ppcp divp_ppc nf nf_red zerop_red divP_ppc RO wf_RO
      RO_lem foreigner foreigner_red foreigner_dec zerop_ddivp_ppc divp_nzeropr
      zerop_red_spoly_l zerop_red_spoly_r).

Local stable: (list poly) -> (list poly) ->Prop := (stable poly Cb).

Theorem buch_stable: (P:(list poly))(stable P (buchf P)).
Exact (buch_Stable
         poly spolyp divp divp_dec addEnd addEnd_cons addEnd_id1 addEnd_id2
         addEnd addEnd_cons zerop zerop_dec ppcp Cb Cb_id Cb_in Cb_in1 Cb_trans
         Cb_sp nf nf_Cb RO wf_RO RO_lem foreigner foreigner_dec).
Qed.

Theorem reds_SpolyQ:
  (P:(list poly)) (a, b:poly) (reds a b P) ->(Spoly_1 P (s2p a) (s2p b)).
Intros P a b H'; Elim H'; Auto.
Intros P0 a0 b0 H'0; Cut (red (spolyp b0 a0) P0); Auto.
Case a0; Case b0; Unfold red; Simpl; Auto.
Intros x H'1 x0 H'2 H'3; Inversion H'3.
Apply Spoly_10 with Cp := H'2 Cq := H'1; Auto.
Apply red_com; Auto.
Intros P0 a0 b0 c.
Case c; Case b0; Case a0; Simpl.
Intros x; Case x; Simpl; Auto.
Intros c0 x0 c1 x1 c2 H'0 H'1 H'2 H'3 H'4 H'5; Elim H'5.
Intros a1 l c0 x0; Case x0; Simpl.
Intros c1 x1 c2 H'0 H'1 H'2 H'3 H'4 H'5; Elim H'5.
Intros a2 l0 c1 x1; Case x1; Simpl.
Intros c2 H'0 H'1 H'2 H'3 H'4 H'5; Elim H'5.
Intros a3 l1 c2 H'0 H'1 H'2 H'3 H'4 H'5.
Apply Spoly_11 with d := a3 t := l1; Auto.
Generalize (in_inPolySet
              P0
              (exist (list Term) [l:(list Term)](canonical l) (cons a3 l1) c2));
 Simpl; Auto.
Intros H'6; LApply H'6;
 [Intros H'7; LApply H'7;
   [Intros H'8; Clear H'6 | Red; Intros H'9; Inversion H'9; Clear H'6] |
   Clear H'6]; Auto.
Qed.

Theorem imp_in:
  (P:(list poly)) (a:(list Term)) (inPolySet a P) ->
  (Ex [b:poly] (In b P) /\ a=(s2p b)).
Intros P a H'; Elim H'; Auto.
Intros a0 p H P0;
 Exists (exist (list Term) [l0:(list Term)](canonical l0) (pX a0 p) H); Split;
 Auto.
Simpl; Auto.
Intros a0 p P0 H'0 H'1; Elim H'1; Intros b E; Elim E; Intros H'2 H'3;
 Clear E H'1; Auto.
Exists b; Split; Auto with datatypes.
Qed.

Theorem reds_SpolyQ1:
  (P:(list poly)) ((a, b:poly) (In a P) -> (In b P) ->(reds a b P)) ->(SpolyQ P).
Intros P H'.
Apply SpolyQ0; Auto.
Intros p q H'0 H'1 H'2 H'3.
Elim (imp_in P p); [Intros b E; Elim E; Intros H'7 H'8; Clear E | Idtac]; Auto.
Rewrite H'8.
Elim (imp_in P q); [Intros b0 E; Elim E; Intros H'9 H'10; Clear E | Idtac]; Auto.
Rewrite H'10.
Apply reds_SpolyQ; Auto.
Qed.

Theorem buch_spolyQ: (P:(list poly))(SpolyQ (buchf P)).
Intros P.
Apply reds_SpolyQ1; Auto.
Intros a b H' H'0.
Apply buch_reds; Auto.
Qed.

Theorem buch_Grobner: (P:(list poly))(Grobner (buchf P)).
Intros P.
Apply ConfluentReduce_imp_Grobner.
Apply SpolyQ_imp_ConfluentReduce.
Apply buch_spolyQ; Auto.
Qed.

(* Final red *)
Require Import fred.

Local rcb := [L:(list poly)] [p:poly](Cb p L).

Local rcb_id: (L:(list poly)) (p:poly) (In p L) ->(rcb L p).
Intros L p H'.
Unfold rcb; Apply Cb_id; Auto.
Defined.

Local rcb_incl:
  (L1, L2:(list poly)) (p:poly) (incl L1 L2) -> (rcb L1 p) ->(rcb L2 p).
Unfold rcb; Intros L1 L2 p H' H'0; Auto.
Apply Cb_incl with P := L1; Auto.
Defined.

Local rnf := [L:(list poly)] [p:poly](nf p L).

Theorem reduce_cb1:
  (a:poly) (b:(list Term)) (Q:(list poly)) (reduce Q (s2p a) b) ->
  (CombLinear (cons a Q) b).
Intros a; Case a; Simpl.
Intros x c b Q H'.
Cut (canonical b); [Intros Op1 | Apply canonical_reduce with Q := Q p := x];
 Auto.
Elim (reduce_minuspf x b Q);
 [Intros c E; Elim E; Intros d E0; Elim E0; Intros H'7 H'8; Elim H'8;
   Intros H'9 H'10; Elim H'10; Intros H'11 H'12; Clear H'10 H'8 E0 E | Idtac |
   Idtac]; Auto.
Apply CombLinear_comp with p := (minuspf x (multm_lm d c0)); Auto.
Apply CombLinear_minuspf; Auto.
Apply CombLinear_id; Auto.
Generalize c H'; Case x; Auto.
Intros c1 H'0; Inversion H'0; Auto.
Apply CombLinear_multm_lm; Auto.
Apply CombLinear_id; Auto.
Apply eqp_sym; Auto.
Qed.

Theorem CombLinear_compo:
  (p:(list Term)) (L1:(list poly)) (CombLinear L1 p) ->
  (L2:(list poly)) ((q:(list Term)) (inPolySet q L1) ->(CombLinear L2 q)) ->
  (CombLinear L2 p).
Intros p L1 H'; Elim H'; Auto.
Intros L2 H'0.
Apply CombLinear0; Auto.
Intros a p0 q s H'0 H'1 H'2 H'3 H'4 L2 H'5.
Apply CombLinear_comp with p := (pluspf (multm_lm a q) p0); Auto.
Apply CombLinear_pluspf; Auto.
Apply CombLinear_multm_lm; Auto.
Apply eqp_imp_canonical with p := (pluspf (multm_lm a q) p0); Auto.
Apply eqp_sym; Auto.
Apply canonical_pluspf; Auto.
Apply canonical_multlm_lm; Auto.
Apply inPolySet_imp_canonical with L := L1; Auto.
Apply CombLinear_canonical with Q := L1; Auto.
Apply eqp_sym; Auto.
Qed.

Theorem reduceplus_cb1_lem:
  (a, b:(list Term)) (Q:(list poly)) (reduceplus Q a b) ->
  (x:poly) (s2p x)=a ->(CombLinear (cons x Q) b).
Intros a b Q H'; Elim H'; Auto.
Intros x y H'0 x0; Case x0; Simpl; Auto.
Intros x1 c H'1.
Apply CombLinear_comp with p := x; Auto.
Rewrite <- H'1; Auto.
Generalize c; Case x1; Auto.
Intros c0; Apply CombLinear0; Auto.
Intros t l c0; Apply CombLinear_id; Auto.
Apply eqp_imp_canonical with p := x1; Auto; Rewrite H'1; Auto.
Intros x y z; Case y; Auto.
Intros H'0 H'1 H'2 x0 H'3.
Cut (canonical (nil Term)).
Intros H'4.
Apply CombLinear_compo with L1 := (cons (mks (nil Term) H'4) Q); Auto.
Intros q H'5; Inversion H'5; Auto.
Apply CombLinear_id; Auto.
Apply canonicalpO; Auto.
Intros a0 l H'0 H'1 H'2 x0 H'3.
Cut (canonical (cons a0 l)).
Intros H'4.
Apply CombLinear_compo with L1 := (cons (mks (cons a0 l) H'4) Q); Auto.
Intros q H'5; Inversion H'5; Auto.
Simpl; Auto.
Simpl in H2; Simpl in H4.
Apply reduce_cb1; Auto.
Rewrite H'3; Auto.
Apply CombLinear_id; Auto.
Apply canonical_reduce with Q := Q p := x; Auto.
Generalize H'3; Case x0; Simpl; Auto.
Intros x1 H'4 H'5; Elim H'5; Auto.
Qed.

Theorem reduceplus_cb1:
  (a:poly) (b:(list Term)) (Q:(list poly)) (reduceplus Q (s2p a) b) ->
  (CombLinear (cons a Q) b).
Intros a b Q H'.
Apply reduceplus_cb1_lem with a := (s2p a); Auto.
Qed.

Theorem reducestar_cb1:
  (a:poly) (b:(list Term)) (Q:(list poly)) (reducestar Q (s2p a) b) ->
  (CombLinear (cons a Q) b).
Intros a b Q H'; Inversion H'; Auto.
Apply reduceplus_cb1; Auto.
Qed.

Local rnf_rcb: (p:poly) (L:(list poly))(rcb (cons p L) (rnf L p)).
Intros p L; Unfold rnf; Unfold rcb; Auto.
Unfold nf Cb; Simpl; Auto.
Case (Reduce1a L p); Simpl; Auto.
Intros x0; Case x0; Simpl.
Intros x c H'.
Apply CombLinear_multm_lm; Auto.
Apply reducestar_cb1; Auto.
Qed.

Remark CombLinear_trans_cons_lem:
  (a:(list Term)) (R:(list poly)) (CombLinear R a) ->
  (b:poly) (Q:(list poly)) R=(cons b Q) -> (CombLinear Q (s2p b)) ->
  (CombLinear Q a).
Intros a R H'; Elim H'; Auto.
Intros b Q H'0 H'1.
Apply CombLinear0; Auto.
Intros a0 p q s H'0 H'1 H'2 H'3 H'4 b Q H'5 H'6.
Apply CombLinear_comp with p := (pluspf (multm_lm a0 q) p); Auto.
2:Apply eqp_imp_canonical with p := (pluspf (multm_lm a0 q) p); Auto.
2:Apply eqp_sym; Auto.
2:Apply canonical_pluspf; Auto.
2:Apply canonical_multlm_lm; Auto.
2:Apply inPolySet_imp_canonical with L := R; Auto.
2:Apply CombLinear_canonical with Q := R; Auto.
2:Apply eqp_sym; Auto.
Apply CombLinear_pluspf; Auto.
Apply CombLinear_multm_lm; Auto.
2:Apply H'3 with b := b; Auto.
Rewrite H'5 in H'1; Inversion H'1; Auto.
2:Apply CombLinear_id; Auto.
Rewrite <- H2 in H'6; Simpl in H'6; Auto.
Qed.

Local rcb_trans:
  (L:(list poly)) (p, q:poly) (rcb (cons p L) q) -> (rcb L p) ->(rcb L q).
Unfold rcb; Unfold Cb; Auto.
Intros L p q; Case p; Case q; Simpl.
Intros x H' x0 c H'0 H'1.
Apply CombLinear_trans_cons_lem
     with R := (cons (exist (list Term) [l:(list Term)](canonical l) x0 c) L)
          b := (exist (list Term) [l:(list Term)](canonical l) x0 c); Auto.
Defined.

Local rcb_comp:
  (L1, L2:(list poly)) ((p:poly) (In p L1) ->(rcb L2 p)) ->
  (q:poly) (rcb L1 q) ->(rcb L2 q).
Unfold rcb; Unfold Cb; Auto.
Intros L1 L2 H' q; Case q; Simpl.
Intros x H'0 H'1.
Apply CombLinear_compo with L1 := L1; Auto.
Intros q0 H'2.
LApply (inPolySet_inv1 L1 q0); [Intros H'5 | Idtac]; Auto.
Case H'5; Intros q1 E; Case E; Intros H'3 H'4; Clear E H'5.
LApply (H' q1); [Intros H'6 | Idtac]; Auto.
Generalize H'6 H'4; Case q1; Simpl; Auto.
Intros x0 H'5 H'7 H'8; Rewrite H'8; Auto.
Defined.

Theorem reduce_cb2:
  (a, b:poly) (Q:(list poly)) (reduce Q (s2p a) (s2p b)) ->
  (CombLinear (cons b Q) (s2p a)).
Intros a b; Case a; Case b; Simpl.
Intros x c x0 c1 Q H'0.
Elim (reduce_minuspf x0 x Q);
 [Intros c E; Elim E; Intros d E0; Elim E0; Intros H'7 H'8; Elim H'8;
   Intros H'9 H'10; Elim H'10; Intros H'11 H'12; Clear H'10 H'8 E0 E | Idtac |
   Idtac]; Auto.
Apply CombLinear_comp with p := (pluspf x (multm_lm d c0)); Auto.
Apply CombLinear_pluspf; Auto.
Generalize c H'0; Case x; Auto.
Intros c2 H'.
Apply CombLinear0; Auto.
Intros a0 l c2 H'.
Apply CombLinear_id; Auto.
Apply CombLinear_multm_lm; Auto.
Apply CombLinear_id; Auto.
Apply eqp_trans with y := (pluspf (minuspf x0 (multm_lm d c0)) (multm_lm d c0));
 Auto.
Qed.

Theorem reduceplus_cb2_lem:
  (a, b:(list Term)) (Q:(list poly)) (reduceplus Q a b) -> (canonical a) ->
  (x:poly) (s2p x)=b ->(CombLinear (cons x Q) a).
Intros a b Q H'; Elim H'; Auto.
Intros x y H'0 H'1 x0 H'2.
Apply CombLinear_comp with p := y; Auto.
Rewrite <- H'2; Case x0; Simpl; Auto.
Intros x1; Case x1; Simpl; Auto.
Intros H'3; Apply CombLinear0; Auto.
Intros t l c; Apply CombLinear_id; Auto.
Apply eqp_sym; Auto.
Intros x y z H'0 H'1 H'2 H'3 x0 H'4.
LApply H'2;
 [Intros H'5; LApply (H'5 x0); [Intros H'7; Clear H'2 | Clear H'2] | Clear H'2];
 Auto.
Cut (canonical y).
Intros H'2.
LApply (reduce_cb2 (mks x H'3) (mks y H'2) Q); Simpl; [Intros H'9 | Idtac]; Auto.
Apply CombLinear_trans_cons_lem
     with R := (cons (mks y H'2) (cons x0 Q)) b := (mks y H'2); Auto.
Apply CombLinear_incl with P := (cons (mks y H'2) Q); Auto.
Intros a0 H'6.
Apply Incl_inp_inPolySet with P := (cons (mks y H'2) Q); Auto.
Red; Simpl; Auto with datatypes.
Intros a1 H'8; Elim H'8; Auto.
Apply canonical_reduce with Q := Q p := x; Auto.
Apply canonical_reduce with Q := Q p := x; Auto.
Qed.

Theorem reduceplus_cb2:
  (a, b:poly) (Q:(list poly)) (reduceplus Q (s2p a) (s2p b)) ->
  (CombLinear (cons b Q) (s2p a)).
Intros a b Q H'.
Apply reduceplus_cb2_lem with b := (s2p b); Auto.
Qed.

Theorem reducestar_cb2:
  (a, b:poly) (Q:(list poly)) (reducestar Q (s2p a) (s2p b)) ->
  (CombLinear (cons b Q) (s2p a)).
Intros a b Q H'; Inversion H'; Auto.
Apply reduceplus_cb2; Auto.
Qed.

Local rcb_rnf: (p:poly) (L:(list poly))(rcb (cons (rnf L p) L) p).
Intros p L; Unfold rnf; Unfold rcb; Auto.
Unfold nf Cb; Simpl; Auto.
Case (Reduce1a L p); Simpl; Auto.
Case p; Simpl.
Unfold LetP; Intros x H' x0; Case x0; Simpl.
Intros x1 c H'0.
Apply CombLinear_compo
     with L1 := (cons (exist (list Term) [l:(list Term)](canonical l) x1 c) L);
 Auto.
Generalize (reducestar_cb2 (mks x H') (mks x1 c) L).
Simpl; Auto.
Intros q H'1; Inversion H'1; Auto.
2:Apply CombLinear_id; Auto.
Generalize c H2; Case x1; Auto.
Intros c0 H'2; Inversion H'2.
Intros a0 l c0 H'2.
Cut ~ (zeroP (unit (mks (cons a0 l) c0))); [Intros nZu | Idtac]; Auto.
Apply CombLinear1
     with a := (divTerm T1 (unit (mks (cons a0 l) c0)) nZu) p := pO
          q := (multm_lm (unit (mks (cons a0 l) c0)) (cons a0 l)); Auto.
Simpl; Auto.
Apply CombLinear0; Auto.
Apply eqp_trans
     with y :=
          (multm_lm
             (divTerm T1 (unit (mks (cons a0 l) c0)) nZu)
             (multm_lm (unit (mks (cons a0 l) c0)) (cons a0 l))); Auto.
2:Apply eqp_sym; Auto.
Apply eqp_trans
     with y :=
          (multm_lm
             (multTerm
                (divTerm T1 (unit (mks (cons a0 l) c0)) nZu)
                (unit (mks (cons a0 l) c0))) (cons a0 l)); Auto.
Apply eqp_trans with y := (multm_lm T1 (cons a0 l)); Auto.
Rewrite H'2; Auto.
Apply eqp_sym; Auto.
Apply multm_lm_comp; Auto.
Apply divTerm_on_eq; Auto.
Change (eqM T1 (unit (mks (cons a0 l) c0))).
Apply eqM_sym; Auto.
Qed.

Local zerop_elim_rcb:
  (L:(list poly)) (p, q:poly) (zerop p) -> (rcb (cons p L) q) ->(rcb L q).
Intros L p q H' H'0.
Apply rcb_comp with L1 := (cons p L); Auto.
Simpl; Auto.
Intros p0 H'1; Case H'1;
 [Intros H'2; Rewrite <- H'2; Clear H'1 | Intros H'2; Clear H'1]; Auto.
Generalize H'; Case p; Simpl; Auto.
Intros x; Case x; Simpl; Auto.
Intros H'1 H'3; Try Assumption.
Apply CombLinear0; Auto.
Intros a l H'1 H'3; Elim H'3; Auto.
Apply rcb_id; Auto.
Qed.

Local rcb_compo:
  (p:poly) (L1:(list poly)) (rcb L1 p) ->
  (L2:(list poly)) ((q:poly) (In q L1) ->(rcb L2 q)) ->(rcb L2 p).
Intros p L1 H' L2 H'0.
Apply rcb_comp with L1 := L1; Auto.
Qed.

Local rreduce: (list poly) -> poly -> poly ->Prop.
Intros H' p q; Case p; Case q.
Intros x H'0 x0 H'1; Exact (reduce H' x0 x).
Defined.

Local grobner_def:
  (L:(list poly)) (Grobner L) ->
  (p:poly) (rcb L p) ->(zerop p) \/ (Ex [q:poly] (rreduce L p q)).
Intros L H'; Inversion H'; Auto.
Intros p H'0.
Case (Reduce1a L p).
Intros x H'1; Inversion H'.
LApply (H0 (s2p p) (s2p x));
 [Intros H'4; LApply H'4; [Clear H'4 | Clear H'4] | Idtac]; Auto.
Inversion H'1; Auto.
Inversion H1; Auto.
Intros H'2; Left.
Cut (eqP (s2p p) pO); Auto.
Case p; Simpl; Auto.
Intros x1; Case x1; Auto.
Intros a l H'3 H'4; Inversion H'4.
Apply eqp_trans with y := (s2p x); Auto.
Intros H'2; Right; Cut (canonical y); Auto.
Intros H'3; Exists (mks y H'3); Generalize H5; Case p; Simpl; Auto.
Apply canonical_reduce with Q := L p := (s2p p); Auto.
Generalize H'0; Case p; Simpl; Auto.
Qed.

Local def_grobner:
  (L:(list poly))
  ((p:poly) (rcb L p) ->(zerop p) \/ (Ex [q:poly] (rreduce L p q))) ->
  (Grobner L).
Intros L H'.
Apply (Grobner0
         Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec plusTerm multTerm
         invTerm T1 minusTerm divTerm).
Intros p q H'0 H'1.
Cut (canonical p).
Intros H'2.
Cut (canonical q).
Intros H'3.
Elim (H' (mks q H'3)); [Intros H'6 | Intros H'6 | Idtac]; Auto.
Generalize H'3 H'6; Case q; Simpl; Auto.
Intros H'4 H'5; Apply eqP0; Auto.
Intros a l H'4 H'5; Elim H'5; Auto.
Case H'6; Intros q0 E; Clear H'6.
Inversion H'1.
Generalize H0 E; Case q0; Auto.
Simpl; Auto.
Intros x H'4 H'5 H'6; Absurd (reduce L q x); Auto.
Red.
Red.
Simpl; Auto.
Apply reducestar_cb with a := p; Auto.
Inversion H'1; Apply canonical_reduceplus with Q := L p := p; Auto.
Apply CombLinear_canonical with Q := L; Auto.
Qed.

Definition rdivp: poly -> poly ->Prop.
Intros p q; Case q; Case p.
Intros x H' x0 H'0; (Case x0; Case x).
Exact True.
Intros H'1 H'2; Exact False.
Intros H'1 H'2; Exact False.
Intros y1 H'2 y2 H'4; Exact (divP y1 y2).
Defined.

Local rdivp_id: (p:poly)(rdivp p p).
Intros p; Case p; Auto.
Intros x; Case x; Simpl; Auto.
Intros a l H'.
Cut ~ (zeroP a); [Intros Z | Idtac].
Apply divTerm_def with nZb := Z.
Apply canonical_nzeroP with p := l; Auto.
Apply eqTerm_trans with y := (multTerm T1 a); Auto.
Apply canonical_nzeroP with p := l; Auto.
Defined.

Local rdivp_trans: (transitive poly rdivp).
Red.
Intros x y z; Case x; Case y; Case z.
Intros x0; Case x0; Simpl; Auto.
Intros H' x1; Case x1; Simpl; Auto.
Intros a l H'0 x2 H'1 H'2 H'3; Elim H'3; Auto.
Intros a l H' x1; Case x1; Simpl; Auto.
Intros H'0 x2 H'1 H'2; Case x2; Simpl; Auto.
Intros a0 H'3 H'4; Elim H'4.
Intros a0 l0 H'0 x2; Case x2; Simpl; Auto.
Intros a1 l1 H'1 H'2 H'3.
Cut ~ (zeroP a0); [Intros Z0 | Apply canonical_nzeroP with p := l0]; Auto.
Cut ~ (zeroP a); [Intros Z1 | Apply canonical_nzeroP with p := l]; Auto.
Cut ~ (zeroP a1); [Intros Z2 | Apply canonical_nzeroP with p := l1]; Auto.
Apply divP_trans with y := a0; Auto.
Defined.

Theorem reduce_divp:
  (p, q:poly) (Q:(list poly)) (reduce Q (s2p p) (s2p q)) ->
  (Ex [r:poly] (In r (cons q Q)) /\ ((rdivp p r) /\ ~ (zerop r))).
Intros p q; Case p; Case q; Simpl.
Intros x H' x0 c Q H'0; Inversion H'0.
Generalize c; Rewrite <- H2; Simpl; Auto.
LApply (inPolySet_inv1 Q (cons b q0)); [Intros H'3 | Idtac]; Auto.
Case H'3; Intros q1 E; Case E; Intros H'1 H'2; Clear E H'3.
Intros c0; Exists q1; Split; [Right | Split]; Auto.
Generalize H'2; Case q1; Simpl; Auto.
Intros x1; Case x1; Auto.
Intros H'4 H'5; Inversion H'5; Auto.
Intros a0 l H'4 H'5; Inversion H'5.
Rewrite <- H5; Auto.
Generalize H'1 H'2 c0; Case q1; Simpl; Auto.
Intros x1; Case x1; Auto.
Intros c1 H'3 H'4; Inversion H'4.
Exists (exist (list Term) [l:(list Term)](canonical l) x H'); Split;
 [Left | Split]; Simpl; Auto.
Generalize c; Rewrite <- H1; Auto.
Generalize H'; Rewrite <- H2; Auto.
Intros H'1 H'2.
Apply divP_eqTerm_comp with a := b; Auto.
Cut ~ (zeroP b); [Intros Z | Idtac]; Auto.
Apply divTerm_def with nZb := Z; Auto.
Apply canonical_nzeroP with p := q0; Auto.
Generalize c H'; Rewrite <- H2; Auto.
Qed.

Theorem reduceplus_rdivp_lem:
  (a, b:(list Term)) (Q:(list poly)) (reduceplus Q a b) -> (canonical a) ->
  (x, y:poly) (s2p x)=a -> (s2p y)=b -> ~ (zerop x) ->
  (Ex [r:poly] (In r (cons y Q)) /\ ((rdivp x r) /\ ~ (zerop r))).
Intros a b Q H'; Elim H'; Auto.
Intros x y H'0 H'1 x0 y0 H'2 H'3 H'4; Exists y0; Split; [Idtac | Split];
 Auto with datatypes.
Generalize H'0; Clear H'0; Rewrite <- H'3; Rewrite <- H'2; Case x0; Case y0;
 Simpl; Auto.
Intros x1; Case x1; Simpl; Auto.
Intros H'2 x2; Case x2; Auto.
Intros t l H'5 H'6; Inversion H'6; Auto.
Intros t l H'0 x2; Case x2; Simpl; Auto.
Intros H'5 H'6; Inversion H'6.
Intros t0 l0 H'5 H'6; Inversion H'6; Auto.
Apply divP_eqTerm_comp with a := t; Auto.
Cut ~ (zeroP t); [Intros Z | Idtac]; Auto.
Apply divTerm_def with nZb := Z; Auto.
Apply canonical_nzeroP with p := l; Auto.
Generalize H'0 H'4; Clear H'0 H'4; Rewrite <- H'3; Rewrite <- H'2; Case x0;
 Case y0; Simpl; Auto.
Intros x1; Case x1; Simpl; Auto.
Intros H'0 x2; Case x2; Simpl; Auto.
Intros t l H'4 H'5; Inversion H'5.
Intros x y z H'0 H'1 H'2 H'3 x0 y0 H'4 H'5 H'6.
Cut (canonical y); [Intros Z | Idtac].
2:Apply canonical_reduce with Q := Q p := x; Auto.
LApply (reduce_divp x0 (mks y Z) Q); [Intros H'9 | Idtac]; Auto.
2:Rewrite H'4; Simpl; Auto.
Case H'9; Intros r E; Case E; Simpl; Intros H'7 H'8; Case H'8; Intros H'10 H'11;
 Clear H'8 E H'9.
Case H'7; [Intros H'8; Clear H'7 | Intros H'8; Clear H'7].
2:Exists r; Split; [Right | Idtac]; Auto.
LApply H'2;
 [Intros H'7; LApply (H'7 (mks y Z) y0); Simpl;
   [Intros H'13; LApply H'13;
     [Intros H'14; LApply H'14;
       [Intros H'15; Clear H'14 H'13 H'2 | Clear H'14 H'13 H'2] | Clear H'13 H'2] |
     Clear H'2] | Clear H'2]; Auto.
Case H'15; Intros r0 E; Case E; Intros H'2 H'9; Case H'9; Intros H'12 H'13;
 Clear H'9 E H'15.
Exists r0; Split; [Idtac | Split]; Auto.
Apply rdivp_trans with y := r; Auto.
Rewrite <- H'8; Auto.
Generalize H'11; Rewrite <- H'8.
Generalize Z; Case y; Auto.
Qed.

Theorem reduceplus_rdivp:
  (a, b:poly) (Q:(list poly)) (reduceplus Q (s2p a) (s2p b)) -> ~ (zerop a) ->
  (Ex [r:poly] (In r (cons b Q)) /\ ((rdivp a r) /\ ~ (zerop r))).
Intros a b Q H' H'0.
Apply reduceplus_rdivp_lem with a := (s2p a) b := (s2p b); Auto.
Qed.

Theorem reducestar_rdivp:
  (a, b:poly) (Q:(list poly)) (reducestar Q (s2p a) (s2p b)) -> ~ (zerop a) ->
  (Ex [r:poly] (In r (cons b Q)) /\ ((rdivp a r) /\ ~ (zerop r))).
Intros a b Q H' H'0; Apply reduceplus_rdivp; Auto.
Inversion H'; Auto.
Qed.

Local rnf_rdivp:
  (p:poly) (L:(list poly)) ~ (zerop p) -> ~ (zerop (rnf L p)) ->
  (Ex [q:poly] (In q (cons (rnf L p) L)) /\ ((rdivp p q) /\ ~ (zerop q))).
Intros p L; Case p; Unfold rnf; Auto.
Unfold nf; Auto.
Intros x c;
 Case (Reduce1a L (exist (list Term) [l:(list Term)](canonical l) x c)).
Unfold LetP.
Simpl; Intros x0; Case x0; Simpl; Auto.
Intros x1 c0 H' H'0 H'1.
LApply (reducestar_rdivp (mks x c) (mks x1 c0) L); Simpl;
 [Intros H'5; LApply H'5; [Intros H'6; Clear H'5 | Clear H'5] | Idtac]; Auto.
Case H'6; Intros r E; Case E; Intros H'2 H'3; Case H'3; Intros H'4 H'5;
 Clear H'3 E H'6.
Case H'2; [Intros H'3; Clear H'2 | Intros H'3; Clear H'2].
Exists (exist
          (list Term) [l:(list Term)](canonical l)
          (multm_lm (unit (mks x1 c0)) x1)
          (canonical_multlm_lm (unit (mks x1 c0)) x1 (unit_nZ (mks x1 c0)) c0));
 Split; [Idtac | Split]; Auto.
Apply rdivp_trans with y := r; Auto.
Rewrite <- H'3.
Generalize c0; Case x1; Simpl; Auto.
Intros a l c1.
Cut ~ (zeroP a); [Intros nZa | Apply canonical_nzeroP with p := l]; Auto.
Cut ~ (zeroP (multTerm (unit (mks (cons a l) c1)) a)); [Intros nZu | Idtac];
 Auto.
Apply divTerm_def with nZb := nZu; Auto.
2:Exists r; Split; [Idtac | Split]; Auto.
Apply divTerm_on_eq with a := a; Auto.
Change (eqM a (multTerm (unit (mks (cons a l) c1)) a)); Auto.
Apply eqM_trans with y := (multTerm T1 a); Auto.
Apply multTerm_eqM; Auto.
Apply eqM_sym; Auto.
Qed.

Local rdivp_rreduce:
  (p:poly)
  (L1, L2:(list poly))
  ((r1:poly) (In r1 L1) -> ~ (zerop r1) ->
   (Ex [r2:poly] (In r2 L2) /\ (rdivp r1 r2))) ->
  (q:poly) (rreduce L1 p q) ->(Ex [r:poly] (rreduce L2 p r)).
Intros p L1 L2 H' q; Case p; Case q; Simpl; Auto.
Intros x H'0 x0 c H'1; Generalize c; Elim H'1; Auto.
Intros a b nZb p0 q0 r H'2 H'3 H'4 c0.
LApply (inPolySet_inv1 L1 (cons b q0)); [Intros H'6 | Idtac]; Auto.
Case H'6; Intros q1 E; Case E; Intros H'4 H'5; Clear E H'6.
Elim (H' q1); [Intros r2 E; Elim E; Intros H'10 H'11; Clear E | Idtac | Idtac];
 Auto.
Generalize H'10 H'11 H'5 c0 H'7; Case q1; Simpl; Auto.
Intros x1 c1; Case r2; Simpl; Auto.
Intros x2; Case x2; Simpl; Auto.
Generalize c1; Case x1; Auto.
Intros c2 c3 H'6 H'8 H'9 c4 H'12; Try Inversion H'12.
Intros t l c2 c3 H'6 H'8; Elim H'8.
Intros a0 l c2; Generalize c1; Case x1; Auto.
Intros c3 H'6 H'8; Elim H'8.
Intros t l0 c3 H'6 H'8 H'9 c4 H'12.
Cut ~ (zeroP a0); [Intros nZa0 | Idtac].
Cut (canonical (spminusf a a0 nZa0 p0 l)); [Intros Z | Idtac].
Exists (mks (spminusf a a0 nZa0 p0 l) Z); Simpl; Auto.
Apply reducetop_sp; Auto.
Apply (in_inPolySet L2 (mks (pX a0 l) c2)); Auto.
Simpl.
Red; Intros H'12; Inversion H'12.
Inversion H'13.
Apply divP_trans with y := b; Auto.
Inversion H'12; Auto.
Apply canonical_spminusf_full; Auto.
Apply divP_trans with y := b; Auto.
Inversion H'12; Auto.
Apply canonical_nzeroP with p := l; Auto.
Generalize H'7; Case q1; Simpl; Auto.
Intros x1; Case x1; Simpl; Auto.
Intros c1 H'6; Inversion H'6.
Intros a b p0 q0 H'2 H'3 H'4 c0.
Cut (canonical p0); [Intro | EAuto].
Specialize 1 H'3 with c := H; Intros H'4.
Case H'5; Intros r; Case r.
Intros x1 H'6 H'7.
Cut (canonical (pX b x1)); [Intros Z | Idtac].
Exists (mks (pX b x1) Z); Simpl; Auto.
Apply eqp_imp_canonical with p := (pX a x1); Auto.
Apply ltP_pX_canonical; Auto.
Apply canonical_nzeroP with p := p0; Auto.
Apply ltP_trans with y := p0; Auto.
Apply ltP_reduce with Q := L2; Auto.
Qed.

Local rnf_rdivp_zero:
  (p:poly) (L:(list poly)) ~ (zerop p) -> (zerop (rnf L p)) ->
  (Ex [q:poly] (In q L) /\ ((rdivp p q) /\ ~ (zerop q))).
Intros p L; Case p; Unfold rnf; Auto.
Unfold nf; Auto.
Intros x c;
 Case (Reduce1a L (exist (list Term) [l:(list Term)](canonical l) x c)).
Unfold LetP.
Simpl; Intros x0; Case x0; Simpl; Auto.
Intros x1 c0 H' H'0 H'1.
LApply (reducestar_rdivp (mks x c) (mks x1 c0) L); Simpl;
 [Intros H'5; LApply H'5; [Intros H'6; Clear H'5 | Clear H'5] | Idtac]; Auto.
Case H'6; Intros r E; Case E; Intros H'2 H'3; Case H'3; Intros H'4 H'5;
 Clear H'3 E H'6.
Case H'2; [Intros H'3; Clear H'2 | Intros H'3; Clear H'2].
Case H'5; Rewrite <- H'3.
Generalize c0 H'1; Case x1; Auto.
Exists r; Split; [Idtac | Split]; Auto.
Qed.

Definition redL: (list poly) ->(list poly) := (red poly rnf zerop zerop_dec).

Local cb_redL_cb1: (p:poly) (L:(list poly)) (Cb p L) ->(Cb p (redL L)) :=
   (cb_red_cb1
      poly rcb rnf zerop zerop_dec rcb_id rcb_incl rcb_comp rcb_rnf rcb_compo
      zerop_elim_rcb).

Local cb_redL_cb2: (p:poly) (L:(list poly)) (Cb p (redL L)) ->(Cb p L) :=
   (cb_red_cb2
      poly rcb rnf zerop zerop_dec rcb_id rcb_incl rnf_rcb rcb_trans rcb_compo).

Theorem redL_stable: (P:(list poly))(stable P (redL P)).
Intros P.
Apply (stable0 poly Cb); Auto.
Intros a H'; Apply cb_redL_cb1; Auto.
Intros a H'; Apply cb_redL_cb2; Auto.
Qed.

Theorem redL_Grobner: (P:(list poly)) (Grobner P) ->(Grobner (redL P)).
Intros P H'.
Apply (red_grobner
         poly rcb rdivp rreduce rnf Grobner zerop zerop_dec rcb_id rcb_incl
         rnf_rcb rcb_trans rcb_compo grobner_def def_grobner rnf_rdivp
         rdivp_rreduce rdivp_id rdivp_trans rnf_rdivp_zero); Auto.
Qed.

Definition redbuchL: (list poly) ->(list poly) :=
   [L:(list poly)](redL (buchf L)).

Theorem redbuchL_stable: (P:(list poly))(stable P (redbuchL P)).
Intros P.
Apply (stable0 poly Cb); Auto.
Intros a H'.
Unfold redbuchL.
Apply cb_redL_cb1; Auto.
Specialize 1 buch_stable with P := P; Intros H'0; Inversion H'0; Auto.
Unfold redbuchL.
Intros a H'.
Specialize 1 buch_stable with P := P; Intros H'0; Inversion H'0; Auto.
Apply H0; Auto.
Apply cb_redL_cb2; Auto.
Qed.

Theorem redbuchL_Grobner: (P:(list poly))(Grobner (redbuchL P)).
Intros P.
Unfold redbuchL.
Apply redL_Grobner; Auto.
Apply buch_Grobner; Auto.
Qed.
End Buch.
