
(****************************************************************************
                                                                           
          Buchberger : the maximum of nat                                  
                                                                           
          Laurent Thery 	                                             
                                                                           
****************************************************************************)
Section Max.
Require Import Arith.

Definition max: nat -> nat ->nat.
Intros H'; Elim H'.
Intros n1; Exact n1.
Intros n1 Rec H0; Case H0.
Exact (S n1).
Intros n2; Exact (S (Rec n2)).
Defined.

Theorem max_0_r: (a:nat)(max a O)=a.
Intros a; Elim a; Simpl; Auto.
Qed.

Theorem max_0_l: (a:nat)(max O a)=a.
Intros a; Elim a; Simpl; Auto.
Qed.
Hints Resolve max_0_r max_0_l.

Theorem max_sym: (a, b:nat)(max a b)=(max b a).
Intros a; Elim a; Simpl; Auto.
Intros n H' b; Case b; Simpl; Auto.
Qed.

Theorem max_intro_l: (a, b:nat)(le a (max a b)).
Intros a; Elim a; Simpl; Auto with arith.
Intros n H' b; Case b; Simpl; Auto with arith.
Qed.

Theorem max_intro_r: (a, b:nat)(le b (max a b)).
Intros a; Elim a; Simpl; Auto with arith.
Intros n H' b; Case b; Simpl; Auto with arith.
Qed.

Theorem max_id: (a:nat)(max a a)=a.
Intros a; Elim a; Simpl; Auto.
Qed.

Theorem max_le: (a, b:nat) (le a b) ->(max a b)=b.
Intros a; Elim a; Simpl; Auto with arith.
Intros n H' b; Case b; Simpl; Auto with arith.
Qed.

Theorem max_is_lub: (a, b, c:nat) (le a c) -> (le b c) ->(le (max a b) c).
Intros a; Elim a; Simpl; Auto.
Intros n H' b; Case b; Simpl; Auto.
Intros n0 c; Case c; Simpl; Auto with arith.
Intros H'0; Absurd (le (S n) O); Auto with arith.
Qed.
End Max.

