
(****************************************************************************
                                                                           
          Buchberger : criterion for optimization                          
                                                                           
          Laurent Thery March 98 (revised Mai 98)                          
                                                                           
****************************************************************************)
Section crit.
Load "shyp_crit".
Load "mod_def_spoly".

Theorem eqM_nzero_divTerm:
  (a, b:Term) (nZb:~ (zeroP b)) (eqM a (multTerm (divTerm a b nZb) b)) ->
  (eqTerm a (multTerm (divTerm a b nZb) b)).
Auto.
Qed.

Theorem multTerm_eqM_com: (a, b:Term)(eqM (multTerm a b) (multTerm b a)).
Intros; Red; Red; Auto.
Qed.

Theorem divTerm_multTerm_eqM_com:
  (a, b:Term) (nZa:~ (zeroP a))(eqM (divTerm (multTerm a b) a nZa) b).
Intros; Red; Red; Auto.
Qed.
Hints Resolve eqM_nzero_divTerm multTerm_eqM_com divTerm_multTerm_eqM_com.

Definition Rminus:
  (a:Term) (nZa:~ (zeroP a)) (list Term) -> (list Term) -> (list Term) ->
  (list Term).
Intros a nZa p q r; Elim r; Clear r.
Exact p.
Intros b r Rec; Exact (minuspf Rec (multm_lm (divTerm b a nZa) q)).
Defined.

Theorem minuspf_in:
  (p, q:(list Term))
  (a, b:Term)
  (In a p) -> (order b a) -> (canonical p) -> (canonical (pX b q)) ->
  (In a (minuspf p (pX b q))).
Intros p; Elim p; Simpl; Auto.
Intros q a b H'; Elim H'; Auto.
Intros a l H' q a0 b H'0 H'1 H'2 H'3.
Elim H'0; [Intros H'4; Rewrite H'4; Clear H'0 | Intros H'4; Clear H'0].
Rewrite <- minuspf_inv1_eq; Simpl; Auto.
Case (order_dec a b); Intros test; [Case test; Clear test; Intros test | Idtac].
Absurd (order b a0); Auto.
Apply order_not_order.
Generalize H'4 H'2; Elim l; Simpl; Auto.
Intros H'0; Elim H'0; Auto.
Intros a1 l0 H'0 H'5; Elim H'5;
 [Intros H'6; Rewrite <- H'6; Clear H'5 | Intros H'6; Clear H'5]; Auto.
Intros H'5; Apply order_trans with y := a; Auto.
Apply canonical_imp_order with l := l0; Auto.
Intros H'5; Apply H'0; Auto.
Apply canonical_skip_fst with b := a1; Auto.
Rewrite <- minuspf_inv1_eq; Simpl; Auto.
Right; Auto.
Apply H'; Auto.
Apply canonical_imp_canonical with a := a; Auto.
Absurd (order b a0); Auto.
Apply order_not_order.
Apply order_eqM_l with a := a; Auto.
Generalize H'4 H'2; Elim l; Simpl; Auto.
Intros H'0; Elim H'0; Auto.
Intros a1 l0 H'0 H'5; Elim H'5;
 [Intros H'6; Rewrite <- H'6; Clear H'5 | Intros H'6; Clear H'5]; Auto.
Intros H'5; Apply canonical_imp_order with l := l0; Auto.
Intros H'5; Apply H'0; Auto.
Apply canonical_skip_fst with b := a1; Auto.
Qed.

Theorem minus_is_reduce:
  (Q:(list poly))
  (a:Term) (nZa:~ (zeroP a)) (q:(list Term)) (inPolySet (pX a q) Q) ->
  (u:Term) (divP u a) ->
  (p:(list Term)) (canonical p) -> (In u p) ->
  (reduce Q p (minuspf p (multm_lm (divTerm u a nZa) (pX a q)))).
Intros Q a nZa q inP0 u divP0 p; Elim p.
Intros H' H'0; Elim H'0; Auto.
Intros a0 l H' H'0 H'1; Elim H'1;
 [Intros H'2; Rewrite H'2; Clear H'1 | Intros H'2; Clear H'1]; Auto.
Apply reducetop with b := a nZb := nZa q := q; Auto.
Apply eqp_trans with y := (spminusf u a nZa (pX u l) (pX a q)); Auto.
Apply spminusf_extend; Auto.
Rewrite <- H'2; Auto.
Apply inPolySet_imp_canonical with L := Q; Auto.
Apply reduce_eqp_com
     with p := (pX a0 l)
          q := (pX a0 (minuspf l (multm_lm (divTerm u a nZa) (pX a q)))); Auto.
Apply reduceskip; Auto.
Apply H'; Auto.
Apply canonical_imp_canonical with a := a0; Auto.
Simpl; Apply minuspf_inv1.
Apply order_eqM_r with a := u; Auto.
Inversion divP0; Auto.
Generalize H'2 H'0; Elim l; Simpl; Auto.
Intros H'1; Elim H'1; Auto.
Intros a2 l0 H'1 H'3; Elim H'3;
 [Intros H'4; Rewrite <- H'4; Clear H'3 | Intros H'4; Clear H'3]; Auto.
Intros H'1.
Apply canonical_imp_order with l := l0; Auto.
Intros H'1; Apply H'1; Auto.
Apply canonical_skip_fst with b := a2; Auto.
Qed.

Definition divPp: Term -> (list Term) ->Prop.
Intros a p; Elim p; Clear p.
Exact True.
Intros b p Rec; Exact (divP b a) /\ Rec.
Defined.
Hints Resolve divP_inv3.

Definition divpf: (a:Term) (nZa:~ (zeroP a)) (list Term) ->(list Term).
Intros a nZa p; Elim p; Clear p.
Exact pO.
Intros b p Rec; Exact (pluspf (pX (divTerm b a nZa) pO) Rec).
Defined.

Theorem divpf_canonical:
  (a:Term) (p:(list Term)) (nZa:~ (zeroP a)) (canonical p) ->
  (canonical (divpf a nZa p)).
Intros a p; Elim p; Simpl; Auto.
Intros a0 l H' H'0 H'1.
Apply canonical_pluspf; Auto.
Apply canonical1; Auto.
Apply divTerm_nZ; Auto.
Apply canonical_nzeroP with p := l; Auto.
Apply H'; Auto.
Apply canonical_imp_canonical with a := a0; Auto.
Qed.
Hints Resolve divpf_canonical.

Theorem divPp_divpf:
  (a:Term) (nZa:~ (zeroP a)) (p:(list Term)) (canonical p) -> (divPp a p) ->
  (eqP p (multm_lm a (divpf a nZa p))).
Intros a nZa p; Elim p; Simpl; Auto.
Intros a0 l H' H'0 H'1; Elim H'1; Intros H'2 H'3; Clear H'1.
Cut (canonical l); [Intros Op0 | Apply canonical_imp_canonical with a := a0];
 Auto.
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm a (pX (divTerm a0 a nZa) pO))
             (multm_lm a (divpf a nZa l))).
2:Apply eqp_sym; Auto.
Apply eqp_trans with y := (pluspf (multm_lm a (pX (divTerm a0 a nZa) pO)) l).
Simpl.
Apply eqp_trans with y := (pluspf (pX (multTerm (divTerm a0 a nZa) a) pO) l).
Apply eqp_trans with y := (pluspf (pX a0 pO) l).
Auto.
Apply eqp_trans with y := (pX a0 (pluspf pO l)).
Apply eqp_sym; Auto.
Rewrite pluspf_inv1_eqa; Auto.
Apply canonical1; Auto.
Apply canonical_nzeroP with p := l; Auto.
Inversion H'2; Auto.
Auto.
Auto.
Qed.

Theorem canonical_Rminus:
  (r, p, q:(list Term))
  (a:Term) (nZa:~ (zeroP a)) (canonical p) -> (canonical q) -> (canonical r) ->
  (canonical (Rminus a nZa p q r)).
Intros r; Elim r; Simpl; Auto.
Intros a l nZa p q a0 H'0 H'1 H'2 H'3.
Cut (canonical l); [Idtac | Apply canonical_imp_canonical with a := a; Auto];
 Auto.
Cut ~ (zeroP a); [Idtac | Apply canonical_nzeroP with p := l]; Auto.
Qed.
Hints Resolve canonical_Rminus.

Theorem Rminus_in:
  (r, p, q:(list Term))
  (a, b:Term)
  (nZb:~ (zeroP b))
  (divPp b r) ->
  (In a p) -> (canonical p) -> (canonical (pX b q)) -> (canonical (pX a r)) ->
  (In a (Rminus b nZb p (pX b q) r)).
Intros r; Elim r; Simpl; Auto.
Intros a l H' p q a0 b nZb H'0 H'1 H'2 H'3 H'4.
Elim H'0; Intros H'6 H'7; Clear H'0.
Apply minuspf_in; Auto.
Apply H'; Auto.
Apply canonical_skip_fst with b := a; Auto.
Apply order_eqM_r with a := a; Auto.
Apply canonical_imp_order with l := l; Auto.
Apply canonical_Rminus; Auto.
Apply canonical_imp_canonical with a := a; Auto.
Apply canonical_imp_canonical with a := a0; Auto.
Qed.

Theorem Rminus_is_reduceplus:
  (Q:(list poly))
  (a:Term)
  (q:(list Term)) (nZa:~ (zeroP a)) (canonical q) -> (inPolySet (pX a q) Q) ->
  (r:(list Term)) (canonical r) -> (divPp a r) ->
  (p:(list Term)) (canonical p) -> (incl r p) ->
  (reduceplus Q p (Rminus a nZa p (pX a q) r)).
Intros Q a q nZa Op0 in0 r; Elim r; Clear r.
Simpl; Intros H' H'0 p H'1 H'2; Auto.
Intros a0 r1 Rec Op1 divp0 p Op2 incl0.
Cut (canonical r1);
 [Intros Cr1 | Apply canonical_imp_canonical with a := a0; Auto].
Cut (canonical (pX a q));
 [Intros Caq | Apply inPolySet_imp_canonical with L := Q; Auto].
Elim divp0; Intros H' H'0; Clear divp0.
Apply reduceplus_trans with y := (Rminus a nZa p (pX a q) r1); Auto.
Apply Rec; Auto.
Red; Intros p H; Apply incl0; Auto with datatypes.
Apply reduceplus_eqp_com
     with p := (Rminus a nZa p (pX a q) r1)
          q :=
          (minuspf
             (Rminus a nZa p (pX a q) r1) (multm_lm (divTerm a0 a nZa) (pX a q)));
 Auto.
Apply reduce_imp_reduceplus.
Apply minus_is_reduce; Auto.
Apply Rminus_in; Auto with datatypes.
Qed.
Load "mod_smult".

Definition Dmult:
  (a:Term) (nZa:~ (zeroP a)) (list Term) -> (list Term) ->(list Term).
Intros a nZa p q; Elim p; Clear p.
Exact pO.
Intros a1 p1 rec; Exact (pluspf (divpf a nZa (multm_lm a1 q)) rec).
Defined.

Theorem canonical_Dmult:
  (a:Term)
  (nZa:~ (zeroP a)) (p, q:(list Term)) (canonical p) -> (canonical q) ->
  (canonical (Dmult a nZa p q)).
Intros a nZa p; Elim p; Simpl; Auto.
Intros a0 l H' q H'0 H'1.
Cut (canonical l); [Idtac | Apply canonical_imp_canonical with a := a0; Auto].
Cut ~ (zeroP a0); Auto.
Apply canonical_nzeroP with p := l; Auto.
Qed.
Hints Resolve canonical_Dmult.

Theorem divp_is_multTerm:
  (a, b:Term) (nZb:~ (zeroP b)) (divP a b) ->
  (p:(list Term)) (canonical p) ->
  (eqP (multm_lm (divTerm a b nZb) p) (divpf b nZb (multm_lm a p))).
Intros a b nZb H'; Inversion H'.
Intros p; Elim p; Simpl; Auto.
Intros a1 p1 H'0 H'1.
Cut (canonical p1); [Intros Op0 | Apply canonical_imp_canonical with a := a1];
 Auto.
Cut ~ (zeroP a1); [Intros Z0 | Apply canonical_nzeroP with p := p1]; Auto.
Apply eqp_trans
     with y :=
          (pluspf
             (pX (divTerm (multTerm a a1) b nZb) pO)
             (multm_lm (divTerm a b nZb) p1)); Auto.
Cut (eqTerm (multTerm (divTerm a b nZb) a1) (divTerm (multTerm a a1) b nZb));
 Auto.
Intros H'2.
Apply eqp_trans
     with y :=
          (pX
             (multTerm (divTerm a b nZb) a1)
             (pluspf pO (multm_lm (divTerm a b nZb) p1))); Auto.
Apply eqp_sym; Auto.
Rewrite pluspf_inv1_eqa; Auto.
Qed.

Theorem Rminus_is_mult:
  (r, p, q:(list Term))
  (a:Term)
  (nZa:~ (zeroP a))
  (canonical p) -> (canonical q) -> (canonical r) -> (divPp a r) ->
  (eqP (Rminus a nZa p q r) (minuspf p (Dmult a nZa r q))).
Intros r; Elim r; Clear r; Simpl; Auto.
Intros p q a nZa H'0 H'1 H'2 H'3; Apply eqp_sym; Auto.
Intros a l H' p q a0 nZa0 H'1 H'2 H'3 H'4; Elim H'4; Intros H'5 H'6; Clear H'4.
Cut (canonical l);
 [Intros Op0 | Apply canonical_imp_canonical with a := a; Auto].
Cut ~ (zeroP a); [Intros Z0 | Apply canonical_nzeroP with p := l; Auto].
Apply eqp_trans
     with y :=
          (minuspf
             (minuspf p (Dmult a0 nZa0 l q)) (multm_lm (divTerm a a0 nZa0) q));
 [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (minuspf p (Dmult a0 nZa0 l q))
             (multm_lm (invTerm T1) (multm_lm (divTerm a a0 nZa0) q)));
 [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (pluspf p (multm_lm (invTerm T1) (Dmult a0 nZa0 l q)))
             (multm_lm (invTerm T1) (multm_lm (divTerm a a0 nZa0) q)));
 [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             p
             (pluspf
                (multm_lm (invTerm T1) (Dmult a0 nZa0 l q))
                (multm_lm (invTerm T1) (multm_lm (divTerm a a0 nZa0) q))));
 [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             p
             (multm_lm
                (invTerm T1)
                (pluspf (Dmult a0 nZa0 l q) (multm_lm (divTerm a a0 nZa0) q)))).
Apply eqp_pluspf_com; Auto.
Apply eqp_sym; Apply multlm_lm_dist_pluspf; Auto.
Apply eqp_trans
     with y :=
          (minuspf
             p (pluspf (Dmult a0 nZa0 l q) (multm_lm (divTerm a a0 nZa0) q))).
Apply eqp_sym; Auto.
Apply minuspf_comp; Auto.
Apply eqp_trans
     with y := (pluspf (multm_lm (divTerm a a0 nZa0) q) (Dmult a0 nZa0 l q)).
Apply pluspf_com; Auto.
Apply eqp_pluspf_com; Auto.
Apply divp_is_multTerm; Auto.
Qed.

Theorem divpf_comp:
  (a, b:Term)
  (p, q:(list Term))
  (eqP p q) -> (canonical p) -> (canonical q) -> (eqTerm a b) ->
  (nZa:~ (zeroP a)) (nZb:~ (zeroP b))(eqP (divpf a nZa p) (divpf b nZb q)).
Intros a b p q H'; Elim H'; Simpl; Auto.
Intros ma mb p0 q0 H'0 H'1 H'2 H'3 H'4 H'5 H'6 H'7; Try Assumption.
Cut (canonical p0);
 [Intros Op1 | Apply canonical_imp_canonical with a := ma; Auto].
Cut (canonical q0);
 [Intros Op2 | Apply canonical_imp_canonical with a := mb; Auto].
Cut ~ (zeroP ma); [Intros Z0 | Apply canonical_nzeroP with p := p0; Auto].
Cut ~ (zeroP mb); [Intros Z1 | Apply canonical_nzeroP with p := q0; Auto].
Auto.
Qed.

Theorem Dmult_is_mulpf:
  (a:Term)
  (nZa:~ (zeroP a)) (p, q:(list Term)) (canonical p) -> (canonical q) ->
  (eqP (Dmult a nZa (multm_lm a p) q) (multpf p q)).
Intros a nZa p; Elim p; Simpl; Auto.
Intros a0 l H'0 q H'1 H'2.
Cut (canonical l);
 [Intros Op0 | Apply canonical_imp_canonical with a := a0; Auto].
Cut (canonical (multpf l q)); [Intros Op1 | Auto].
Cut ~ (zeroP a0); [Intros Z0 | Apply canonical_nzeroP with p := l; Auto].
Apply eqp_pluspf_com; Auto.
Apply eqp_trans with y := (multm_lm (divTerm (multTerm a a0) a nZa) q).
Apply eqp_sym.
Apply divp_is_multTerm; Auto.
Apply multm_lm_comp; Auto.
Apply eqTerm_trans with y := (multTerm a0 (divTerm a a nZa)); Auto.
Apply eqTerm_trans with y := (divTerm (multTerm a0 a) a nZa); Auto.
Qed.

Theorem sp_Rminus:
  (a, b:Term)
  (nZb:~ (zeroP b))
  (p, q:(list Term)) (canonical (pX a p)) -> (canonical (pX b q)) ->
  (eqP
     (Rminus
        b nZb (minuspf (multm_lm b p) (multm_lm a q)) (pX b q) (multm_lm b p))
     (multm_lm (invTerm T1) (multpf (pX a p) q))).
Intros a b nZb p q H' H'0.
Cut (canonical p);
 [Intros Op0 | Apply canonical_imp_canonical with a := a; Auto].
Cut (canonical q);
 [Intros Op1 | Apply canonical_imp_canonical with a := b; Auto].
Cut ~ (zeroP a); [Intros Z0 | Apply canonical_nzeroP with p := p; Auto].
Cut ~ (zeroP b); [Intros Z1 | Apply canonical_nzeroP with p := q; Auto]; Auto.
Apply eqp_trans
     with y :=
          (minuspf
             (minuspf (multm_lm b p) (multm_lm a q))
             (Dmult b nZb (multm_lm b p) (pX b q))).
Apply Rminus_is_mult; Auto.
Generalize Op0; Elim p; Simpl; Auto.
Intros a0 l H'1 H'2; Split; Auto.
Apply divTerm_multTerml; Auto.
Apply canonical_nzeroP with p := l; Auto.
Apply H'1.
Apply canonical_imp_canonical with a := a0; Auto.
Apply eqp_trans
     with y :=
          (minuspf (minuspf (multm_lm b p) (multm_lm a q)) (multpf p (pX b q))).
Apply minuspf_comp; Auto.
Apply Dmult_is_mulpf; Auto.
Apply eqp_trans
     with y :=
          (minuspf (minuspf (multm_lm b p) (multm_lm a q)) (multpf p (pX b q))).
Apply minuspf_comp; Auto.
Apply eqp_trans
     with y :=
          (minuspf
             (minuspf (multm_lm b p) (multm_lm a q))
             (pluspf (multm_lm b p) (multpf p q))); [Auto | Idtac].
Apply eqp_trans
     with y :=
          (minuspf
             (pluspf (multm_lm b p) (multm_lm (invTerm T1) (multm_lm a q)))
             (pluspf (multm_lm b p) (multpf p q))); [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (pluspf (multm_lm b p) (multm_lm (invTerm T1) (multm_lm a q)))
             (multm_lm (invTerm T1) (pluspf (multm_lm b p) (multpf p q))));
 [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (pluspf (multm_lm b p) (multm_lm (invTerm T1) (multm_lm a q)))
             (pluspf
                (multm_lm (invTerm T1) (multm_lm b p))
                (multm_lm (invTerm T1) (multpf p q)))); [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (pluspf (multm_lm (invTerm T1) (multm_lm a q)) (multm_lm b p))
             (pluspf
                (multm_lm (invTerm T1) (multm_lm b p))
                (multm_lm (invTerm T1) (multpf p q)))).
Apply eqp_pluspf_com; Auto.
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm (invTerm T1) (multm_lm a q))
             (pluspf
                (multm_lm b p)
                (pluspf
                   (multm_lm (invTerm T1) (multm_lm b p))
                   (multm_lm (invTerm T1) (multpf p q))))); [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm (invTerm T1) (multm_lm a q))
             (pluspf
                (pluspf (multm_lm b p) (multm_lm (invTerm T1) (multm_lm b p)))
                (multm_lm (invTerm T1) (multpf p q)))).
Apply eqp_pluspf_com; Auto.
Apply eqp_sym; Auto.
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm (invTerm T1) (multm_lm a q))
             (pluspf
                (minuspf (multm_lm b p) (multm_lm b p))
                (multm_lm (invTerm T1) (multpf p q)))).
Apply eqp_sym; Auto.
Apply eqp_pluspf_com; Auto.
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm (invTerm T1) (multm_lm a q))
             (pluspf pO (multm_lm (invTerm T1) (multpf p q)))); [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (multm_lm (invTerm T1) (multm_lm a q))
             (multm_lm (invTerm T1) (multpf p q))); [Auto | Idtac].
Apply eqp_trans
     with y := (multm_lm (invTerm T1) (pluspf (multm_lm a q) (multpf p q)));
 Auto.
Apply eqp_sym; Auto.
Qed.

Theorem eqM_nzero_divP:
  (a, b:Term)
  (nZb:~ (zeroP b)) (eqM a (multTerm (divTerm a b nZb) b)) -> ~ (zeroP a) ->
  (divP a b).
Intros a b nZb H'0 H'1; Auto.
Apply divTerm_def with nZb := nZb; Auto.
Qed.
Hints Resolve eqM_nzero_divP.

Theorem eqM_nzero_eqM_divP:
  (a, b, c:Term)
  (nZb:~ (zeroP b))
  (eqM c (multTerm (divTerm c b nZb) b)) -> ~ (zeroP a) -> (eqM a c) ->
  (divP a b).
Intros a b c nZb H'0 H'1 H'2.
Apply eqM_nzero_divP with nZb := nZb; Auto.
Apply eqM_trans with y := c; Auto.
Apply eqM_trans with y := (multTerm (divTerm c b nZb) b); Auto.
Apply eqM_sym; Auto.
Qed.
Hints Resolve eqM_nzero_eqM_divP.

Theorem minuspf_spoly_in:
  (a, b:Term)
  (nZa:~ (zeroP a)) (nZb:~ (zeroP b)) (eqM (ppc a b) (multTerm a b)) ->
  (p, q:(list Term))
  (canonical p) ->
  (canonical q) ->
  ((c:Term) (In c p) ->
   (order c (multTerm a b)) /\ (eqM c (multTerm (divTerm c b nZb) b))) ->
  ((c:Term) (In c q) ->
   (order c (multTerm a b)) /\ (eqM c (multTerm (divTerm c a nZa) a))) ->
  (c:Term) (In c p) ->(In c (minuspf p q)).
Intros a b nZa nZb H'1 p q; Pattern p q.
Apply Opm_ind; Simpl; Intros; Auto.
Elim H3; Auto.
Rewrite minuspf_pO_refl_eq; Auto.
Rewrite <- minuspf_inv2_eq; Simpl; Auto.
Right; Apply H; Auto.
Apply canonical_imp_canonical with a := b0; Auto.
Rewrite <- minuspf_inv1_eq; Simpl; Auto.
Elim H5; Intros H'2; Clear H5; Auto.
Right; Apply H; Auto.
Apply canonical_imp_canonical with a := a0; Auto.
Elim (H4 b0); [Intros H'4 H'5 | Idtac]; Auto.
Elim (H3 a0); [Intros H'6 H'7 | Idtac]; Auto.
Cut ~ (zeroP a0); [Intros Z0 | Apply canonical_nzeroP with p := p0; Auto].
Cut ~ (zeroP b0); [Intros Z1 | Apply canonical_nzeroP with p := q0; Auto].
Absurd (eqM (ppc a b) (multTerm a b)); Auto.
Apply eqM_not_order.
Case (order_dec (ppc a b) a0); Intros test;
 [Case test; Clear test; Intros test | Idtac].
Apply order_trans with y := a0; Auto.
Absurd (order a0 (ppc a b)); Auto.
Apply divP_is_not_order; Auto.
Cut (ppcm a b (ppc a b)); [Intros H'8; Inversion H'8 | Idtac]; Auto.
Apply H6; Auto.
Apply eqM_nzero_eqM_divP with c := b0 nZb := nZa; Auto.
Apply eqM_nzero_divP with nZb := nZb; Auto.
Apply order_eqM_r with a := a0; Auto.
Apply eqM_sym; Auto.
Qed.

Theorem multm_or_z_d1:
  (a, b:Term) (nZb:~ (zeroP b)) (p:(list Term)) (canonical (pX a p)) ->
  (c:Term) (In c (multm_lm b p)) ->
  (order c (multTerm a b)) /\ (eqM c (multTerm (divTerm c b nZb) b)).
Intros a b nZb p; Elim p; Simpl; Auto.
Intros H' c H'0; Elim H'0; Auto.
Intros a0 l H' H'0 c H'1; Elim H'1;
 [Intros H'2; Rewrite <- H'2; Clear H'1 | Intros H'2; Clear H'1]; Auto.
2:Apply H'; Auto.
2:Apply canonical_skip_fst with b := a0; Auto.
Split; Auto.
Apply order_eqM_l with a := (multTerm b a); Auto.
Apply multTerm_order_l; Auto.
Apply canonical_imp_order with l := l; Auto.
Apply eqM_trans with y := (multTerm a0 b); Auto.
Apply multTerm_eqM; Auto.
Apply eqM_sym; Auto.
Qed.

Theorem multm_or_z_d2:
  (a, b:Term) (nZb:~ (zeroP b)) (p:(list Term)) (canonical (pX a p)) ->
  (c:Term) (In c (multm_lm b p)) ->
  (order c (multTerm b a)) /\ (eqM c (multTerm (divTerm c b nZb) b)).
Intros a b H' p; Elim p; Simpl; Auto.
Intros H'0 c H'1; Elim H'1.
Intros a0 l H'0 H'1 c H'2; Elim H'2;
 [Intros H'3; Rewrite <- H'3; Clear H'2 | Intros H'3; Clear H'2]; Auto.
2:Apply H'0; Auto.
2:Apply canonical_skip_fst with b := a0; Auto.
Split; Auto.
Apply multTerm_order_l; Auto.
Apply canonical_imp_order with l := l; Auto.
Apply eqM_trans with y := (multTerm a0 b); Auto.
Apply multTerm_eqM; Auto.
Apply eqM_sym; Auto.
Qed.

Theorem in_minuspf_spoly_in:
  (a, b:Term) (eqM (ppc a b) (multTerm a b)) ->
  (p, q:(list Term)) (canonical (pX a p)) -> (canonical (pX b q)) ->
  (c:Term) (In c (multm_lm b p)) ->
  (In c (minuspf (multm_lm b p) (multm_lm a q))).
Intros a b H' p q H'0 H'1 c H'2.
Cut (canonical p); [Intros Op0 | Apply canonical_imp_canonical with a := a];
 Auto.
Cut (canonical q); [Intros Op1 | Apply canonical_imp_canonical with a := b];
 Auto.
Cut ~ (zeroP a); [Intros Z0 | Apply canonical_nzeroP with p := p]; Auto.
Cut ~ (zeroP b); [Intros Z1 | Apply canonical_nzeroP with p := q]; Auto.
Apply minuspf_spoly_in with a := a b := b nZa := Z0 nZb := Z1; Auto.
Intros c0 H'6.
Apply multm_or_z_d1 with p := p; Auto.
Intros c0 H'6.
Apply multm_or_z_d2 with p := q; Auto.
Qed.

Theorem divPp_multm_lm:
  (a:Term) ~ (zeroP a) ->
  (p:(list Term)) ((b:Term) (In b p) ->~ (zeroP b)) ->(divPp a (multm_lm a p)).
Intros a H' p; Elim p; Simpl; Auto.
Qed.

Theorem canonical_imp_in_nzero:
  (p:(list Term)) (canonical p) ->(a:Term) (In a p) ->~ (zeroP a).
Intros p; Elim p; Auto.
Intros a l H' H'0 a0 H'1; Elim H'1; Auto.
Intros H'2; Rewrite <- H'2.
Apply canonical_nzeroP with p := l; Auto.
Intros H'2; Auto.
Apply H'; Auto.
Apply canonical_imp_canonical with a := a; Auto.
Qed.

Theorem spoly_Reduce:
  (Q:(list poly)) (a, b:Term) (eqM (ppc a b) (multTerm a b)) ->
  (p, q:(list Term)) (inPolySet (pX b q) Q) -> (canonical (pX a p)) ->
  (reduceplus
     Q (minuspf (multm_lm b p) (multm_lm a q))
     (multm_lm (invTerm T1) (multpf (pX a p) q))).
Intros Q a b H' p q H'0 H'1.
Cut ~ (zeroP b);
 [Intros nZb |
   Apply canonical_nzeroP with p := q; Apply inPolySet_imp_canonical with L := Q];
 Auto.
Cut (canonical p); [Intros Op0 | Apply canonical_imp_canonical with a := a];
 Auto.
Cut (canonical (pX b q));
 [Intros Op1 | Apply inPolySet_imp_canonical with L := Q]; Auto.
Cut ~ (zeroP a); [Intros Z0 | Apply canonical_nzeroP with p := p]; Auto.
Cut (canonical q); [Intros Op2 | Apply canonical_imp_canonical with a := b];
 Auto.
Cut ~ (zeroP b); [Intros Z1 | Apply canonical_nzeroP with p := q]; Auto.
Apply reduceplus_eqp_com
     with p := (minuspf (multm_lm b p) (multm_lm a q))
          q :=
          (Rminus
             b nZb (minuspf (multm_lm b p) (multm_lm a q)) (pX b q)
             (multm_lm b p)); Auto.
Apply Rminus_is_reduceplus; Auto.
Apply divPp_multm_lm; Auto.
Intros b0 H'2; Apply (canonical_imp_in_nzero p); Auto.
Red; Intros a0 H'2; Apply in_minuspf_spoly_in; Auto.
Apply sp_Rminus; Auto; Auto.
Qed.

Lemma not_nil_in_polySet_elm:
  (Q:(list poly)) (p:(list Term)) (inPolySet p Q) ->~ p=pO.
Intros Q p H'; Elim H'; Auto.
Intros a p0 H'0 H'1; Red; Intros H'2; Inversion H'2.
Qed.

Theorem not_nil_in_polySet: (Q:(list poly)) (p:(list Term))~ (inPolySet pO Q).
Intros Q H'; Red; Intros H'0.
LApply (not_nil_in_polySet_elm Q pO);
 [Intros H'3; Apply H'3 Orelse Elim H'3 | Idtac]; Auto.
Qed.

Theorem spoly_reduceplus_pO:
  (Q:(list poly)) (p, q:(list Term)) (inPolySet q Q) -> (canonical p) ->
  (reduceplus Q (multpf p q) pO).
Intros Q p; Elim p; Auto.
Intros a1 p1 H' q H'0 H'1.
Cut (canonical p1); [Intros Op0 | Apply canonical_imp_canonical with a := a1];
 Auto.
Cut (canonical q); [Intros Op1 | Apply inPolySet_imp_canonical with L := Q];
 Auto.
Cut ~ (zeroP a1); [Intros Z0 | Apply canonical_nzeroP with p := p1]; Auto.
Apply reduceplus_trans with y := (multpf p1 q); Auto.
Generalize Op1 H'0; Case q; Clear Op1 H'0 q.
Intros H'0 H'2; Elim (not_nil_in_polySet Q); Auto.
Intros b1 q1 H'0 H'2.
Cut (canonical q1); [Intros Op2 | Apply canonical_imp_canonical with a := b1];
 Auto.
Cut ~ (zeroP b1); [Intros nZb1 | Apply canonical_nzeroP with p := q1]; Auto.
Apply reduceplus_eqp_com
     with p := (multpf (pX a1 p1) (pX b1 q1))
          q :=
          (minuspf
             (multpf (pX a1 p1) (pX b1 q1))
             (multm_lm (divTerm (multTerm a1 b1) b1 nZb1) (pX b1 q1))); Auto.
Apply reduce_imp_reduceplus; Auto.
Apply minus_is_reduce; Auto.
Apply in_multpf_head; Auto.
Cut (eqTerm (divTerm (multTerm a1 b1) b1 nZb1) a1); [Intros Eq0 | Auto].
Apply eqp_trans
     with y := (minuspf (multpf (pX a1 p1) (pX b1 q1)) (multm_lm a1 (pX b1 q1)));
 [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (pluspf (multm_lm a1 (pX b1 q1)) (multpf p1 (pX b1 q1)))
             (multm_lm (invTerm T1) (multm_lm a1 (pX b1 q1)))); [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (pluspf (multpf p1 (pX b1 q1)) (multm_lm a1 (pX b1 q1)))
             (multm_lm (invTerm T1) (multm_lm a1 (pX b1 q1)))); [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (multpf p1 (pX b1 q1))
             (pluspf
                (multm_lm a1 (pX b1 q1))
                (multm_lm (invTerm T1) (multm_lm a1 (pX b1 q1)))));
 [Auto | Idtac].
Apply eqp_trans
     with y :=
          (pluspf
             (multpf p1 (pX b1 q1))
             (minuspf (multm_lm a1 (pX b1 q1)) (multm_lm a1 (pX b1 q1)))).
Apply eqp_sym; Auto.
Apply eqp_trans with y := (pluspf (multpf p1 (pX b1 q1)) pO); Auto.
Apply eqTerm_trans with y := (multTerm a1 (divTerm b1 b1 nZb1)); Auto.
Qed.

Theorem fspoly_Reduceplus_pO:
  (Q:(list poly)) (a, b:Term) (eqM (ppc a b) (multTerm a b)) ->
  (p, q:(list Term)) (inPolySet (pX b q) Q) -> (inPolySet (pX a p) Q) ->
  (reduceplus Q (minuspf (multm_lm b p) (multm_lm a q)) pO).
Intros Q a b H' p q H'0 H'1.
Cut (canonical (pX a p));
 [Intros Op0 | Apply inPolySet_imp_canonical with L := Q]; Auto.
Cut (canonical (pX b q));
 [Intros Op1 | Apply inPolySet_imp_canonical with L := Q]; Auto.
Cut (canonical p); [Intros Op2 | Apply canonical_imp_canonical with a := a];
 Auto.
Cut (canonical q); [Intros Op3 | Apply canonical_imp_canonical with a := b];
 Auto.
Cut ~ (zeroP a); [Intros Z0 | Apply canonical_nzeroP with p := p]; Auto.
Cut ~ (zeroP b); [Intros Z1 | Apply canonical_nzeroP with p := q]; Auto.
Apply reduceplus_trans with y := (multm_lm (invTerm T1) (multpf (pX a p) q));
 Auto.
Apply spoly_Reduce; Auto.
Apply reduceplus_eqp_com
     with p := (multm_lm (invTerm T1) (multpf q (pX a p)))
          q := (multm_lm (invTerm T1) pO); Auto.
Apply reduceplus_multm; Auto.
Apply spoly_reduceplus_pO; Auto.
Qed.
Hints Resolve divTerm_multTerml divTerm_multTermr.

Theorem divP_comp_ppc0:
  (a, b:Term)
  (nZa:~ (zeroP a))
  (nZb:~ (zeroP b)) (nZppab:~ (zeroP (ppc a b))) (p:(list Term))
  (eqTerm
     b
     (multTerm
        (divTerm (multTerm a b) (ppc a b) nZppab) (divTerm (ppc a b) a nZa))).
Intros a b nZa nZb nZppab p.
Apply eqTerm_trans with y := (multTerm (divTerm a a nZa) b); Auto.
Apply eqTerm_trans with y := (divTerm (multTerm a b) a nZa); Auto.
Apply divTerm_compo; Auto.
Apply divP_pccl; Auto.
Qed.

Theorem divP_comp_ppc1:
  (a, b:Term)
  (nZa:~ (zeroP a))
  (nZb:~ (zeroP b)) (nZppab:~ (zeroP (ppc a b))) (p:(list Term))
  (eqTerm
     a
     (multTerm
        (divTerm (multTerm a b) (ppc a b) nZppab) (divTerm (ppc a b) b nZb))).
Intros a b nZa nZb nZppab H'0.
Apply eqTerm_trans with y := (multTerm a (divTerm b b nZb)); Auto.
Apply eqTerm_trans with y := (divTerm (multTerm a b) b nZb); Auto.
Apply divTerm_compo; Auto.
Apply divP_pccr; Auto.
Qed.

Theorem mulTerm__eqTerm_inv:
  (a, b, c:Term) (eqTerm (multTerm a b) (multTerm a c)) -> ~ (zeroP a) ->
  (eqTerm b c).
Intros a b c H' H'1.
Apply eqTerm_trans with y := (multTerm b (divTerm a a H'1)); Auto.
Apply eqTerm_trans with y := (divTerm (multTerm b a) a H'1); Auto.
Apply eqTerm_trans with y := (divTerm (multTerm a b) a H'1); Auto.
Apply eqTerm_trans with y := (multTerm c (divTerm a a H'1)); Auto.
Apply eqTerm_trans with y := (divTerm (multTerm c a) a H'1); Auto.
Apply eqTerm_trans with y := (divTerm (multTerm a c) a H'1); Auto.
Qed.

Theorem multm_lm_eqp_inv:
  (a:Term)
  (p, q:(list Term)) (eqP (multm_lm a p) (multm_lm a q)) -> ~ (zeroP a) ->
  (eqP p q).
Intros a p; Elim p; Auto.
Intros q; Case q; Simpl; Auto.
Intros t l H'; Inversion H'; Auto.
Intros a0 l H' q; Case q; Simpl; Auto.
Intros H'0; Inversion H'0; Auto.
Intros t l0 H'0; Inversion H'0; Auto.
Intros H'1.
Apply eqpP1; Auto.
Apply mulTerm__eqTerm_inv with a := a; Auto.
Qed.

Theorem reduce_multm_invf:
  (a:Term) (nZa:~ (zeroP a)) (eqM a T1) ->
  (Q:(list poly))
  (p, q:(list Term)) (canonical p) -> (reduce Q (multm_lm a p) q) ->
  (reduce Q p (multm_lm (divTerm T1 a nZa) q)).
Intros a H' eq0 Q p; Elim p; Simpl; Auto.
Intros q H'0 H'1; Inversion H'1; Auto.
Intros a0 l H'0 q H'1 H'2.
Cut (canonical l); [Intros Op0 | Apply canonical_imp_canonical with a := a0];
 Auto.
Cut ~ (zeroP a0); [Intros Z0 | Apply canonical_nzeroP with p := l]; Auto.
Generalize H'0 H'1; Inversion H'2; Clear H'0 H'1 H'2; Simpl; Auto.
Intros H'0 H'1.
Cut (canonical (pX b q0));
 [Intros Op1 | Apply inPolySet_imp_canonical with L := Q]; Auto.
Cut (canonical q0); [Intros Op2 | Apply canonical_imp_canonical with a := b];
 Auto.
Cut (divP a0 b); [Intros d0 | Idtac].
Apply reduce_eqp_com with p := (pX a0 l) q := (spminusf a0 b nZb l q0); Auto.
Apply reducetop_sp; Auto.
Apply multm_lm_eqp_inv with a := a; Auto.
Apply eqp_trans with y := (multm_lm (multTerm a (divTerm T1 a H')) q); Auto.
Apply eqp_trans with y := (multm_lm T1 q); Auto.
Apply eqp_trans with y := q; Auto.
Apply eqp_trans with y := (spminusf (multTerm a a0) b nZb (multm_lm a l) q0);
 Auto.
Apply eqp_sym; Auto.
Apply eqp_sym; Auto.
Apply multm_lm_comp; Auto.
Apply eqTerm_trans with y := (divTerm (multTerm a T1) a H'); Auto.
Apply eqTerm_trans with y := (divTerm a a H'); Auto.
Apply eqM_nzero_eqM_divP with c := (multTerm a a0) nZb := nZb; Auto.
Apply eqM_trans with y := (multTerm T1 a0); Auto.
Apply eqM_sym; Auto.
Intros H'0 H'1.
Apply reduceskip; Auto.
Apply eqTerm_trans with y := (multTerm (divTerm T1 a H') (multTerm a a0)); Auto.
Apply eqTerm_trans with y := (multTerm (multTerm (divTerm T1 a H') a) a0); Auto.
Qed.

Theorem mutlm_eqp_zpO:
  (a:Term) ~ (zeroP a) ->(p:(list Term)) (eqP (multm_lm a p) pO) ->(eqP p pO).
Intros a H' p; Elim p; Simpl; Auto.
Intros a0 l H'0 H'1; Inversion H'1; Auto.
Qed.

Theorem reduceplus_multm_invf0:
  (a:Term) ~ (zeroP a) -> (eqM a T1) ->
  (Q:(list poly)) (p, q:(list Term)) (reduceplus Q p q) -> (canonical p) ->
  (r, s:(list Term))
  (canonical r) -> (eqP p (multm_lm a r)) -> (eqP q (multm_lm a s)) ->
  (reduceplus Q r s).
Intros a H' H'0 Q p q H'1; Elim H'1; Auto.
Intros x y H'2 H'3 r s H'4 H'5 H'6.
Apply Rstar_0; Auto.
Apply multm_lm_eqp_inv with a := a; Auto.
Apply eqp_trans with y := y; Auto.
Apply eqp_trans with y := x; Auto.
Apply eqp_sym; Auto.
Intros x y z H'2 H'3 H'4 H'5 r s H'6 H'7 H'8.
Apply Rstar_n with y := (multm_lm (divTerm T1 a H') y); Auto.
Apply reduce_multm_invf; Auto.
Apply reduce_eqp_com with p := x q := y; Auto.
Apply H'4; Auto.
Apply canonical_reduce with Q := Q p := x; Auto.
Apply canonical_multlm_lm; Auto.
Apply canonical_reduce with Q := Q p := x; Auto.
Apply eqp_trans with y := (multm_lm (multTerm a (divTerm T1 a H')) y); Auto.
Apply eqp_trans with y := (multm_lm (divTerm (multTerm a T1) a H') y); Auto.
Apply eqp_trans with y := (multm_lm (divTerm a a H') y); Auto.
Apply eqp_trans with y := (multm_lm T1 y); Auto.
Apply eqp_sym; Auto.
Qed.

Theorem reduceplus_multm_inv:
  (a:Term) ~ (zeroP a) -> (eqM a T1) ->
  (Q:(list poly))
  (p, q:(list Term))
  (reduceplus Q (multm_lm a p) (multm_lm a q)) -> (canonical p) ->
  (reduceplus Q p q).
Intros a H' H'0 Q p q H'1 H'2.
Apply reduceplus_multm_invf0 with a := a p := (multm_lm a p) q := (multm_lm a q);
 Auto.
Qed.

Theorem spoly_Reducestar_pO:
  (Q:(list poly)) (a, b:Term) (eqM (ppc a b) (multTerm a b)) ->
  (p, q:(list Term))
  (Cpxb:(canonical (pX b q)))
  (Cpxa:(canonical (pX a p)))
  (inPolySet (pX b q) Q) -> (inPolySet (pX a p) Q) ->
  (reduceplus Q (spolyf (pX a p) (pX b q) Cpxa Cpxb) pO).
Intros Q a b H' p q Cpxb Cpxa H'0 H'1.
Cut (canonical p); [Intros Op2 | Apply canonical_imp_canonical with a := a];
 Auto.
Cut (canonical q); [Intros Op3 | Apply canonical_imp_canonical with a := b];
 Auto.
Cut ~ (zeroP a); [Intros nZa | Idtac]; Auto.
Cut ~ (zeroP b); [Intros nZb | Idtac]; Auto.
Cut ~ (zeroP (ppc a b)); [Intros nZppab | Idtac]; Auto.
Apply reduceplus_multm_inv with a := (divTerm (multTerm a b) (ppc a b) nZppab);
 Auto.
Apply divP_on_eqM_eqM; Auto.
Apply eqM_sym; Auto.
2:Apply canonical_nzeroP with p := q; Auto.
2:Apply canonical_nzeroP with p := p; Auto.
Apply reduceplus_eqp_com
     with p := (minuspf (multm_lm b p) (multm_lm a q)) q := pO; Auto.
Apply fspoly_Reduceplus_pO; Auto.
Apply eqp_trans
     with y :=
          (multm_lm
             (divTerm (multTerm a b) (ppc a b) nZppab)
             (minuspf
                (multm_lm (divTerm (ppc a b) a nZa) p)
                (multm_lm (divTerm (ppc a b) b nZb) q))); Auto.
Apply eqp_trans
     with y :=
          (minuspf
             (multm_lm
                (divTerm (multTerm a b) (ppc a b) nZppab)
                (multm_lm (divTerm (ppc a b) a nZa) p))
             (multm_lm
                (divTerm (multTerm a b) (ppc a b) nZppab)
                (multm_lm (divTerm (ppc a b) b nZb) q))); Auto.
Apply eqp_trans
     with y :=
          (minuspf
             (multm_lm
                (multTerm
                   (divTerm (multTerm a b) (ppc a b) nZppab)
                   (divTerm (ppc a b) a nZa)) p)
             (multm_lm
                (multTerm
                   (divTerm (multTerm a b) (ppc a b) nZppab)
                   (divTerm (ppc a b) b nZb)) q)); Auto.
Apply minuspf_comp; Auto.
Apply multm_lm_comp; Auto.
Apply divP_comp_ppc0; Auto.
Apply multm_lm_comp; Auto.
Apply divP_comp_ppc1; Auto.
Apply minuspf_comp; Auto.
Apply eqp_sym; Auto.
Apply multm_lm_comp; Auto.
Apply spolyf_def; Auto.
Qed.

Theorem spoly_Reducestar_ppc:
  (Q:(list poly)) (a, b:Term) (eqM (ppc a b) (multTerm a b)) ->
  (p, q:(list Term))
  (Cpxb:(canonical (pX b q)))
  (Cpxa:(canonical (pX a p)))
  (inPolySet (pX b q) Q) -> (inPolySet (pX a p) Q) ->
  (reducestar Q (spolyf (pX a p) (pX b q) Cpxa Cpxb) pO).
Intros Q a b H' p q Cpxb Cpxa H'0 H'1.
Apply reducestar0; Auto.
Apply spoly_Reducestar_pO; Auto.
Apply pO_irreducible; Auto.
Qed.
End crit.
