
(****************************************************************************
                                                                           
          Buchberger : main just before instanciation                      
                                                                           
          Laurent Thery 	                                             
                                                                           
****************************************************************************)
Section Main.
Require Import Buch.
Load "shyp_crit".
Load "mod_crit".

Theorem canonical_dec: (a:(list Term)){(canonical a)}+{~ (canonical a)}.
Intros a; Elim a; Auto.
Intros a0 l H'.
Case (zeroP_dec a0).
Intros H'1; Right; Red; Intros H'2; Inversion H'2; Auto.
Simpl in H0; Generalize H0 H; Case (zeroP_dec a0); Auto.
Intros Z; Case H'.
Case l.
Intros H'0; Left; Auto.
Intros a1 l0 H'0; Case (zeroP_dec a1).
Intros H'1; Right; Red; Intros H'2; Inversion H'2.
Simpl in H0; Generalize H0 H'1 Z; Case (zeroP_dec a0); Case (zeroP_dec a1); Auto.
Intros H'1; Case (order_dec a0 a1); Auto.
Intros H'2; Case H'2; Auto.
Intros H'3; Right.
Red; Intros H'4; Absurd (order a1 a0); Auto.
Apply canonical_imp_order with l := l0; Auto.
Intros H'2; Right.
Red; Intros H'3; Absurd (order a1 a0); Auto.
Apply order_not_eqM; Auto.
Apply eqM_sym; Auto.
Apply canonical_imp_order with l := l0; Auto.
Intros H'0; Right; Red; Intros Op1; Apply H'0; EAuto.
Qed.

Definition selectdiv:
  (a:Term) ~ (zeroP a) ->
  (Q:(list poly))
  {q:(list Term) |
    (Ex [b:Term]
    (Ex [p:(list Term)] (divP a b) /\ ((inPolySet q Q) /\ q=(pX b p))))}+{
   (b:Term) (q:(list Term)) (inPolySet (pX b q) Q) ->~ (divP a b)}.
Intros a Z Q; Elim Q; Auto.
Right.
Intros b q H'; Inversion H'.
Intros a0; Case a0.
Intros x; Case x.
Intros c l H'; Case H'.
Intros H'1; Case H'1.
Intros x0 H'0; Left.
Exists x0.
Elim H'0; Intros b E; Elim E; Intros p E0; Elim E0; Intros H'2 H'3; Elim H'3;
 Intros H'4 H'5; Try Exact H'5; Clear H'3 E0 E H'0.
Exists b; Exists p; Split; [Idtac | Split]; Auto.
Intros H'0; Right.
Intros b q H'1; Inversion H'1; Auto.
Apply H'0 with q := q; Auto.
Intros a1 l c l0 H'; Case (divP_dec a a1); Auto.
Apply canonical_nzeroP with p := l; Auto.
Intros divP1; Left; Exists (pX a1 l); Auto.
Exists a1; Exists l; Split; [Idtac | Split]; Auto.
Intros divP1; Case H'; Intros Hyp1.
Case Hyp1.
Intros x0 H'0; Left; Exists x0.
Elim H'0; Intros b E; Elim E; Intros p E0; Elim E0; Intros H'1 H'2; Elim H'2;
 Intros H'3 H'4; Try Exact H'4; Clear H'2 E0 E H'0.
Exists b; Exists p; Split; [Idtac | Split]; Auto.
Right.
Intros b q H'1; Generalize divP1; Inversion H'1; Simpl; Auto.
LApply (Hyp1 b q); [Intros H'3 | Idtac]; Auto.
Qed.

Definition tselectpoly:
  (Q:(list poly)) (r:(list Term)) (canonical r) ->
  {q:(list Term) | (reduce Q r q)}+{(irreducible Q r)}.
Intros Q r; Elim r.
Intros H'; Right; Apply pO_irreducible; Auto.
Intros a l H' H'0.
Cut (canonical l); [Intros C0 | EAuto].
Cut ~ (zeroP a); [Intros Z0 | Apply canonical_nzeroP with p := l].
Case (selectdiv a Z0 Q); Intros Hyp1.
Case Hyp1.
Intros x0; Case x0; Left.
Absurd True; Auto.
Elim e; Intros b E; Elim E; Intros p E0; Elim E0; Intros H'1 H'2; Elim H'2;
 Intros H'3 H'4; Inversion H'4; Clear H'2 E0 E e.
Cut ~ (zeroP t); [Intros nZt | Idtac].
Exists (spminusf a t nZt l l0).
Elim e; Intros b E; Elim E; Intros p E0; Elim E0; Intros H'1 H'2; Elim H'2;
 Intros H'3 H'4; Clear H'2 E0 E e.
Apply reducetop_sp; Auto.
Rewrite (pX_invl t b l0 p); Auto.
Apply canonical_nzeroP with p := l0.
Apply inPolySet_imp_canonical with L := Q; Auto.
Elim e; Intros b E; Elim E; Intros p E0; Elim E0; Intros H'1 H'2; Elim H'2;
 Intros H'3 H'4; Try Exact H'3; Clear H'2 E0 E e.
LApply H'; [Intros H'1; Case H'1; Clear H' | Clear H'].
Intros H'; Case H'.
Intros x H'2; Left; Exists (pX a x).
Apply reduceskip; Auto.
Intros H'; Right; Change (q:(list Term))~ (reduce Q (pX a l) q).
Intros q; Red; Intros H'2; Generalize H' Hyp1; Inversion H'2.
Simpl in H3.
Intros H'3 H'4; LApply (H'4 b q0); [Intros H'7; Apply H'7 | Idtac]; Auto.
Simpl in H2.
Intros H'3 H'4; Absurd (reduce Q l q0); Auto.
Auto.
Auto.
Qed.

Definition mmks: (p:(list Term)) (canonical p) ->poly.
Intros p H'; Exists p; Exact H'.
Defined.

Definition Reduce1a:
  (Q:(list poly)) (p:poly){q:poly | (reducestar Q (s2p p) (s2p q))}.
Intros Q p; Pattern p.
Apply (well_founded_induction ? sltP sltp_wf); Auto.
Intros x; Case x.
Intros x0; Case x0.
Intros o H'; Simpl.
Exists spO; Simpl; Auto.
Apply reducestar0; Auto.
Apply pO_irreducible; Auto.
Simpl; Intros a l o H'; Auto.
Cut ~ (zeroP a); [Intros Z0 | Apply canonical_nzeroP with p := l]; Auto.
LApply (selectdiv a);
 [Intros H'1; Specialize 1 H'1 with Q := Q; Intros H'2; Case H'2 | Idtac]; Auto;
 Intros Div1.
Case Div1.
Intros x1; Case x1.
Intros H'0; Absurd True; Auto.
Elim H'0; Intros b E; Elim E; Intros p0 E0; Elim E0; Intros H'3 H'4; Elim H'4;
 Intros H'5 H'6; Inversion H'6; Clear H'4 E0 E H'0.
Intros a0 l0 H'0.
Cut ~ (zeroP a0); [Intros nZt | Idtac].
2:Apply canonical_nzeroP with p := l0.
2:Apply inPolySet_imp_canonical with L := Q; Auto.
2:Elim H'0; Intros b E; Elim E; Intros p0 E0; Elim E0; Intros H'3 H'4; Elim H'4;
   Intros H'5 H'6; Try Exact H'5; Clear H'4 E0 E H'0.
Cut (canonical (spminusf a a0 nZt l l0)); [Intros Op2 | Idtac]; Auto.
LApply (H' (mmks (spminusf a a0 nZt l l0) Op2)); [Intros H'4; Case H'4 | Idtac];
 Auto.
Intros x2 H'3; Exists x2.
Apply reducestar0; Auto.
Apply Rstar_n with y := (spminusf a a0 nZt l l0); Auto.
Elim H'0; Intros b E; Elim E; Intros p0 E0; Elim E0; Intros H'5 H'6; Elim H'6;
 Intros H'7 H'8; Clear H'6 E0 E H'0.
Apply reducetop_sp; Auto.
Rewrite (pX_invl a0 b l0 p0); Auto.
Inversion H'3; Auto.
Inversion H'3; Auto.
Simpl; Apply ltP_reduce with Q := Q; Auto.
Elim H'0; Intros b E; Elim E; Intros p0 E0; Elim E0; Intros H'3 H'4; Elim H'4;
 Intros H'5 H'6; Clear H'4 E0 E H'0.
Apply reducetop_sp; Auto.
Rewrite (pX_invl a0 b l0 p0); Auto.
Apply canonical_spminusf; Auto.
EAuto.
Elim H'0; Intros b E; Elim E; Intros p0 E0; Elim E0; Intros H'3 H'4; Elim H'4;
 Intros H'5 H'6; Clear H'4 E0 E H'0.
Apply canonical_imp_canonical with a := a0; Auto.
Apply inPolySet_imp_canonical with L := Q; Auto.
Elim H'0; Intros b E; Elim E; Intros p0 E0; Elim E0; Intros H'3 H'4; Elim H'4;
 Intros H'5 H'6; Clear H'4 E0 E H'0.
Rewrite (pX_invl a0 b l0 p0); Auto.
Cut (canonical l); [Intros Op2 | EAuto].
LApply (H' (mmks l Op2)); Simpl; [Intros H'3; Case H'3 | Idtac]; Auto.
2:Apply ltP_refl_pX; Auto.
Intros x1; Case x1.
Intros x2 c H'4; Simpl; Cut (canonical (pX a x2)); [Intros Op3 | Auto].
Exists (mmks (pX a x2) Op3); Simpl.
Apply reducestar0; Auto.
Apply reduceplus_skip; Auto.
Inversion H'4; Auto.
Change (p:(list Term))~ (reduce Q (pX a x2) p).
Intros p0; Red; Intros H'5; Generalize H'4 Div1; Inversion H'5; Simpl.
Simpl in H3.
Intros H'6 H'7; LApply (H'7 b q); [Intros H'10; Apply H'10 | Idtac]; Auto.
Simpl in H2.
Intros H'6 H'7; Absurd (reduce Q x2 q); Auto.
Inversion H'6; Auto.
Inversion H'4.
Apply canonical_reduceplus with Q := Q p := (pX a l); Auto.
Apply reduceplus_skip; Auto.
Qed.
End Main.

