Require Import crit.
Load "mod_def_spoly".

Local spO: poly.
Exists pO; Auto.
Defined.

Local seqP: poly -> poly ->Prop :=
   (seqP Term Monome T2M zeroP zeroP_dec eqTerm ltM).

Local seqp_dec: (p, q:poly){(seqP p q)}+{~ (seqP p q)} :=
   (seqp_dec Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_dec ltM).

Local reducestar_pO_is_pO:
  (Q:(list poly)) (p, q:(list Term)) (canonical p) ->(reducestar Q pO pO) :=
   (reducestar_pO_is_pO
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm).

Local reduce_in_pO:
  (Q:(list poly)) (p:(list Term)) (inPolySet p Q) ->(reduce Q p pO) :=
   (reduce_in_pO
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l multTerm_eq eqTerm_multTerm_comp invTerm
      plusTerm_invTerm_zeroP zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l
      mult_invTerm_com eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div
      nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm divTerm div_is_T1
      divTerm_on_eq divTerm_nZ).

Local CombLinear: (list poly) -> (list Term) ->Prop :=
   (CombLinear
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec plusTerm multTerm).

Local CombLinear0: (Q:(list poly))(CombLinear Q pO) :=
   (CombLinear0
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec plusTerm multTerm).

Local CombLinear1:
  (Q:(list poly))
  (a:Term)
  (p, q, s:(list Term))
  ~ (zeroP a) ->
  (inPolySet q Q) -> (CombLinear Q p) -> (eqP s (pluspf (multm_lm a q) p)) ->
  (CombLinear Q s) :=
   (CombLinear1
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec plusTerm multTerm).

Local CombLinear_canonical:
  (Q:(list poly)) (p:(list Term)) (CombLinear Q p) ->(canonical p) :=
   (CombLinear_canonical
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_trans ltM_dec eqTerm_imp_eq plusTerm plusTerm_eq1
      plusTerm_eq2 multTerm multTerm_ltM_l multTerm_zeroP_div).

Local CombLinear_comp:
  (Q:(list poly)) (p:(list Term)) (CombLinear Q p) ->
  (q:(list Term)) (canonical q) -> (eqP p q) ->(CombLinear Q q) :=
   (CombLinear_comp
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_sym ltM ltM_dec
      plusTerm multTerm).

Local CombLinear_id:
  (Q:(list poly)) (p:(list Term)) (inPolySet p Q) ->(CombLinear Q p) :=
   (CombLinear_id
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref eqTerm_sym
      ltM ltM_nonrefl ltM_trans ltM_dec plusTerm multTerm T1 T1_multTerm_l
      nZero_T1).

Local CombLinear_spoly:
  (Q:(list poly))
  (p, q:(list Term))
  (Cp:(canonical p)) (Cq:(canonical q)) (inPolySet p Q) -> (inPolySet q Q) ->
  (CombLinear Q (spolyf p q Cp Cq)) :=
   (CombLinear_spoly
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_r
      multTerm_plusTerm_dist_r multTerm_eq multTerm_assoc eqTerm_multTerm_comp
      invTerm plusTerm_invTerm_zeroP zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com ppc
      ppc_nZ divTerm_ppc divTerm_ppcl divTerm_ppcr divTerm_nZ).

Local CombLinear_pluspf:
  (Q:(list poly)) (p:(list Term)) (CombLinear Q p) ->
  (q:(list Term)) (CombLinear Q q) ->(CombLinear Q (pluspf p q)) :=
   (CombLinear_pluspf
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l multTerm_zeroP_div).

Local CombLinear_multm_lm:
  (Q:(list poly)) (a:Term) (p:(list Term)) ~ (zeroP a) -> (CombLinear Q p) ->
  (CombLinear Q (multm_lm a p)) :=
   (CombLinear_multm_lm
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_eq1 plusTerm_eq2 eqTerm_plusTerm_comp
      multTerm multTerm_ltM_l zeroP_multTerm_r multTerm_plusTerm_dist_r
      multTerm_eq multTerm_assoc eqTerm_multTerm_comp multTerm_zeroP_div).

Local CombLinear_minuspf:
  (Q:(list poly)) (p:(list Term)) (CombLinear Q p) ->
  (q:(list Term)) (CombLinear Q q) ->(CombLinear Q (minuspf p q)) :=
   (CombLinear_minuspf
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_r
      multTerm_plusTerm_dist_r multTerm_eq multTerm_assoc eqTerm_multTerm_comp
      invTerm zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l
      mult_invTerm_com eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div
      nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l
      invTerm_ltM_l minusTerm_eq).

Local spoly_is_minus:
  (a, b:Term)
  (nZa:~ (zeroP a))
  (nZb:~ (zeroP b))
  (p, q:(list Term)) (Cpxa:(canonical (pX a p))) (Cpxb:(canonical (pX b q)))
  (eqP
     (spolyf (pX a p) (pX b q) Cpxa Cpxb)
     (minuspf
        (multm_lm (divTerm (ppc a b) a nZa) (pX a p))
        (multm_lm (divTerm (ppc a b) b nZb) (pX b q)))) :=
   (spoly_is_minus
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r eqTerm_plusTerm_comp multTerm multTerm_ltM_l multTerm_eq
      eqTerm_multTerm_comp invTerm plusTerm_invTerm_zeroP zeroP_invTerm_zeroP
      invTerm_invol T1 T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp
      invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm divTerm eqTerm_divTerm_com ppc ppc_nZ
      divTerm_ppc divTerm_ppcl divTerm_ppcr divTerm_nZ).

Local spoly_Reducestar_ppc:
  (Q:(list poly)) (a, b:Term) (eqM (ppc a b) (multTerm a b)) ->
  (p, q:(list Term))
  (Cpxb:(canonical (pX b q)))
  (Cpxa:(canonical (pX a p)))
  (inPolySet (pX b q) Q) -> (inPolySet (pX a p) Q) ->
  (reducestar Q (spolyf (pX a p) (pX b q) Cpxa Cpxb) pO) :=
   (spoly_Reducestar_ppc
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l multTerm_ltM_r
      zeroP_multTerm_l zeroP_multTerm_r multTerm_plusTerm_dist_r multTerm_eq
      multTerm_assoc multTerm_com eqTerm_multTerm_comp invTerm
      plusTerm_invTerm_zeroP zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l
      T1_multTerm_r mult_invTerm_com eqTerm_invTerm_comp invTerm_eq T1_is_min
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eq_divTerm
      eqTerm_divTerm_com divTerm_multTerm_l divTerm_multTerm_r div_is_T1 ppc
      divTerm_on_eq divTerm_on_eq_eq ppc_nZ divTerm_ppc divTerm_ppcl
      divTerm_ppcr divTerm_nZ eq_nzero_divTerm multTerm_eq_com
      divTerm_multTerm_eq_com).


Local reduce_multm_invf:
  (a:Term) (nZa:~ (zeroP a)) (eqM a T1) ->
  (Q:(list poly))
  (p, q:(list Term)) (canonical p) -> (reduce Q (multm_lm a p) q) ->
  (reduce Q p (multm_lm (divTerm T1 a nZa) q)) :=
   (reduce_multm_invf
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp
      multTerm multTerm_ltM_l zeroP_multTerm_l zeroP_multTerm_r
      multTerm_plusTerm_dist_r multTerm_eq multTerm_assoc multTerm_com
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol
      T1 T1_multTerm_l T1_multTerm_r mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div nZero_T1
      minusTerm eqTerm_minusTerm_plusTerm_invTerm divTerm eq_divTerm
      eqTerm_divTerm_com divTerm_multTerm_l div_is_T1 divTerm_on_eq
      eq_nzero_divTerm).

Local reduceplus_multm_inv:
  (a:Term) ~ (zeroP a) -> (eqM a T1) ->
  (Q:(list poly))
  (p, q:(list Term))
  (reduceplus Q (multm_lm a p) (multm_lm a q)) -> (canonical p) ->
  (reduceplus Q p q) :=
   (reduceplus_multm_inv
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l
      zeroP_multTerm_r multTerm_plusTerm_dist_r multTerm_eq
      multTerm_assoc multTerm_com eqTerm_multTerm_comp invTerm
      zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l T1_multTerm_r
      mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l invTerm_ltM_l
      minusTerm_eq divTerm eq_divTerm eqTerm_divTerm_com
      divTerm_multTerm_l div_is_T1 divTerm_on_eq divTerm_nZ
      eq_nzero_divTerm).
