Require Import def_spoly.
Load "mod_sreduce".

Local divTerm_compo:
  (a, b, c:Term) (nZb:~ (zeroP b)) (nZc:~ (zeroP c)) (divP a b) -> (divP b c) ->
  (eqTerm (divTerm a c nZc) (multTerm (divTerm a b nZb) (divTerm b c nZc))) :=
   (divTerm_compo
      Term zeroP eqTerm eqTerm_trans eqTerm_ref eqTerm_sym multTerm
      eqTerm_multTerm_comp divTerm eqTerm_divTerm_com divTerm_multTerm_l).

Local divP_pccl: (a, b:Term) ~ (zeroP a) -> ~ (zeroP b) ->(divP (ppc a b) a) :=
   (divP_pccl
      Term zeroP eqTerm eqTerm_trans eqTerm_ref eqTerm_sym multTerm
      eqTerm_multTerm_comp divTerm eqTerm_divTerm_com ppc ppc_nZ divTerm_ppc
      divTerm_ppcl divTerm_ppcr).

Local divP_pccr: (a, b:Term) ~ (zeroP a) -> ~ (zeroP b) ->(divP (ppc a b) b) :=
   (divP_pccr
      Term zeroP eqTerm eqTerm_trans eqTerm_ref eqTerm_sym multTerm
      eqTerm_multTerm_comp divTerm eqTerm_divTerm_com ppc ppc_nZ divTerm_ppc
      divTerm_ppcl divTerm_ppcr).

Local spolyf:
  (p, q:(list Term)) (Cp:(canonical p)) (Cq:(canonical q))(list Term) :=
   (spolyf
      Term Monome T2M zeroP zeroP_dec ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm ppc).

Local ppcm: Term -> Term -> Term ->Prop :=
   (ppcm Term zeroP eqTerm multTerm divTerm).

Local pcc_is_ppcm:
  (a, b:Term) ~ (zeroP a) -> ~ (zeroP b) ->(ppcm a b (ppc a b)) :=
   (pcc_is_ppcm
      Term zeroP eqTerm eqTerm_trans eqTerm_ref eqTerm_sym multTerm
      eqTerm_multTerm_comp divTerm eqTerm_divTerm_com ppc ppc_nZ divTerm_ppc
      divTerm_ppcl divTerm_ppcr).
Hints Resolve pcc_is_ppcm.

Local ppc_multTerm_divP:
  (a, b:Term) ~ (zeroP a) -> ~ (zeroP b) ->(divP (multTerm a b) (ppc a b)) :=
   (ppc_multTerm_divP
      Term zeroP eqTerm eqTerm_trans eqTerm_ref eqTerm_sym multTerm multTerm_com
      eqTerm_multTerm_comp T1 T1_multTerm_l T1_multTerm_r multTerm_zeroP_div
      divTerm eqTerm_divTerm_com divTerm_multTerm_l divTerm_multTerm_r div_is_T1
      ppc ppc_nZ divTerm_ppc divTerm_ppcl divTerm_ppcr).
Hints Resolve ppc_multTerm_divP.

Local divP_on_eqM_eqM:
  (a, b:Term) ~ (zeroP a) ->
  (nZb:~ (zeroP b)) (eqM a b) ->(eqM (divTerm a b nZb) T1) :=
   (divP_on_eqM_eqM Term Monome T2M zeroP T1 divTerm divTerm_on_eq_eq).

Local reducestar_trans:
  (Q:(list poly))
  (x, y, z:(list Term))
  (canonical x) -> (reduceplus Q x y) -> (reducestar Q y z) ->(reducestar Q x z) :=
   (reducestar_trans
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com).

Local reducetop_sp:
  (Q:(list poly))
  (a, b:Term)
  (nZb:~ (zeroP b)) (p, q:(list Term)) (inPolySet (pX b q) Q) -> (divP a b) ->
  (reduce Q (pX a p) (spminusf a b nZb p q)) :=
   (reducetop_sp
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_ref ltM ltM_dec multTerm
      invTerm T1 minusTerm divTerm).

Local SpolyQ: (list poly) ->Prop :=
   (SpolyQ
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm ppc).

Local Spoly_1: (list poly) -> (list Term) -> (list Term) ->Prop :=
   (Spoly_1
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm ppc).

Local Spoly_10:
  (Q:(list poly))
  (p, q:(list Term))
  (Cp:(canonical p)) (Cq:(canonical q)) (reducestar Q (spolyf p q Cp Cq) pO) ->
  (Spoly_1 Q p q) :=
   (Spoly_10
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm ppc).

Local Spoly_11:
  (Q:(list poly))
  (b, c, d:Term)
  (q, r, r0, s0, t:(list Term))
  (Spoly_1 Q (pX c r) (pX d t)) ->
  (Spoly_1 Q (pX d t) (pX b q)) ->
  (inPolySet (pX d t) Q) -> (divP (ppc c b) d) ->(Spoly_1 Q (pX c r) (pX b q)) :=
   (Spoly_11
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm ppc).

Local SpolyQ0:
  (Q:(list poly))
  ((p, q:(list Term))
   (inPolySet p Q) -> (canonical p) -> (inPolySet q Q) -> (canonical q) ->
   (Spoly_1 Q p q)) ->(SpolyQ Q) :=
   (SpolyQ0
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm ppc).

Local Grobner: (list poly) ->Prop :=
   (Grobner
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec plusTerm multTerm
      invTerm T1 minusTerm divTerm).

Local ConfluentReduce: (list poly) ->Prop :=
   (ConfluentReduce
      Term Monome T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm).

Local SpolyQ_imp_ConfluentReduce:
  (Q:(list poly)) (SpolyQ Q) ->(ConfluentReduce Q) :=
   (SpolyQ_imp_ConfluentReduce
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec ltM_wf
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l
      zeroP_multTerm_r multTerm_plusTerm_dist_l multTerm_plusTerm_dist_r
      multTerm_eq multTerm_assoc multTerm_com eqTerm_multTerm_comp invTerm
      plusTerm_invTerm_zeroP zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l
      mult_invTerm_com eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div
      nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l
      invTerm_ltM_l minusTerm_eq divTerm eq_divTerm_plusTerm divTerm_invTerm_l
      eq_divTerm eqTerm_divTerm_com divTerm_multTerm_l divTerm_eq ppc
      divTerm_rew ppc_nZ divTerm_ppc divTerm_ppcl divTerm_ppcr divTerm_nZ sOp).

Local ConfluentReduce_imp_Grobner:
  (Q:(list poly)) (ConfluentReduce Q) ->(Grobner Q) :=
   (ConfluentReduce_imp_Grobner
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec ltM_wf
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l
      zeroP_multTerm_r multTerm_plusTerm_dist_l multTerm_plusTerm_dist_r
      multTerm_eq multTerm_assoc multTerm_com eqTerm_multTerm_comp invTerm
      plusTerm_invTerm_zeroP zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l
      mult_invTerm_com eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div
      nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l
      invTerm_ltM_l minusTerm_eq divTerm eq_divTerm_plusTerm eq_divTerm
      eqTerm_divTerm_com divTerm_multTerm_l div_is_T1 divTerm_eq divTerm_on_eq
      divTerm_nZ sOp).

Local spolyf_def:
  (a, b:Term)
  (nZa:~ (zeroP a))
  (nZb:~ (zeroP b))
  (p, q:(list Term)) (Cpxa:(canonical (pX a p))) (Cpxb:(canonical (pX b q)))
  (eqP
     (spolyf (pX a p) (pX b q) Cpxa Cpxb)
     (minuspf
        (multm_lm (divTerm (ppc a b) a nZa) p)
        (multm_lm (divTerm (ppc a b) b nZb) q))) :=
   (spolyf_def
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l multTerm_eq eqTerm_multTerm_comp invTerm
      zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm divTerm eqTerm_divTerm_com ppc ppc_nZ
      divTerm_nZ).

Local spolyf_canonical:
  (p, q:(list Term)) (Cp:(canonical p)) (Cq:(canonical q))
  (canonical (spolyf p q Cp Cq)) :=
   (spolyf_canonical
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_trans ltM_dec eqTerm_imp_eq multTerm multTerm_ltM_l
      multTerm_eq invTerm zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l
      invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm minusTerm_ltM_l
      invTerm_ltM_l minusTerm_eq divTerm ppc ppc_nZ divTerm_nZ).
Hints Resolve spolyf_canonical.

