(****************************************************************************
                                                                           
          Buchberger : module for seq                                      
                                                                           
          Laurent Thery 	                                             
                                                                           
****************************************************************************)
Load "mod_porder".
Require Import seq.

Local lessP: (list Term) * (list Term) -> (list Term) * (list Term) ->Prop :=
   (lessP Term).
Hints Unfold  lessP.

Local wf_lessP: (well_founded (list Term) * (list Term) lessP) :=
   (wf_lessP Term).
Hints Resolve wf_lessP.

Local pX_inj:
  (n1, n2:Term) (l1, l2:(list Term)) n1=n2 -> l1=l2 ->(pX n1 l1)=(pX n2 l2) :=
   (pX_inj Term).

Local pX_invl: (a, b:Term) (p, q:(list Term)) (pX a p)=(pX b q) ->a=b :=
   (pX_invl Term).
Hints Unfold  pX.

Local pX_invr: (p, q:(list Term)) (a, b:Term) (pX a p)=(pX b q) ->p=q :=
   (pX_invr Term).

Local canonicalpO: (canonical pO) := (canonicalpO ? ? T2M zeroP zeroP_dec ltM).

Local canonical1: (a:Term) ~ (zeroP a) ->(canonical (pX a pO)) :=
   (canonical1 ? ? T2M zeroP zeroP_dec ltM).
Hints Resolve canonical1 canonicalpO.

Local eqP: (list Term) -> (list Term) ->Prop := (eqP ? eqTerm).

Local eqP0: (eqP pO pO) := (eqP0 ? eqTerm).

Local eqpP1:
  (ma, mb:Term) (p, q:(list Term)) (eqTerm ma mb) -> (eqP p q) ->
  (eqP (pX ma p) (pX mb q)) := (eqpP1 ? eqTerm).
Hints Resolve eqP0 eqpP1.

Local eqp_refl: (reflexive (list Term) eqP) := (eqp_refl ? eqTerm eqTerm_ref).

Local eqp_sym: (symmetric (list Term) eqP) := (eqp_sym ? eqTerm eqTerm_sym).

Local eqp_inv1: (p:(list Term)) (eqP pO p) ->p=pO := (eqp_inv1 Term eqTerm).

Local eqp_inv2: (p:(list Term)) (eqP p pO) ->p=pO := (eqp_inv2 Term eqTerm).

Local eqp_inv3l:
  (a, b:Term) (p, q:(list Term)) (eqP (pX a p) (pX b q)) ->(eqTerm a b) :=
   (eqp_inv3l ? eqTerm).

Local eqp_inv3r:
  (a, b:Term) (p, q:(list Term)) (eqP (pX a p) (pX b q)) ->(eqP p q) :=
   (eqp_inv3r ? eqTerm).
Hints Resolve eqp_refl.

Local eqp_trans: (transitive (list Term) eqP) :=
   (eqp_trans ? eqTerm eqTerm_trans).

Local eqTerm_imp_eqM: (a, b:Term) (eqTerm a b) ->(eqM a b) :=
   (eqTerm_imp_eqM ? ? T2M eqTerm eqTerm_imp_eq).

Hints Resolve eqTerm_imp_eqM.

Local ltp_eqp_comp:
  (p, q, r, s:(list Term))
  (ltP p q) -> (canonical p) -> (canonical q) -> (eqP p r) -> (eqP q s) ->
  (ltP r s) :=
   (ltp_eqp_comp ? ? T2M zeroP zeroP_dec eqTerm eqTerm_sym ltM eqTerm_imp_eq).

Local nzeroP_comp_eqTerm:
  (a, b:Term) ~ (zeroP a) -> (eqTerm a b) ->~ (zeroP b) :=
   (nzeroP_comp_eqTerm Term zeroP eqTerm zeroP_comp_eqTerm eqTerm_sym).

Local eqp_imp_canonical:
  (p, q:(list Term)) (eqP p q) -> (canonical p) ->(canonical q) :=
   (eqp_imp_canonical
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_ref zeroP_comp_eqTerm eqTerm_sym ltM
      eqTerm_imp_eq).

Local lessP3:
  (list Term) * ((list Term) * (list Term)) ->
  (list Term) * ((list Term) * (list Term)) ->Prop := (lessP3 Term).

Local wf_lessP3:
  (well_founded (list Term) * ((list Term) * (list Term)) lessP3) :=
   (wf_lessP3 Term).

Local ltP_refl_pX:
  (a:Term) (p:(list Term)) (canonical (pX a p)) ->(ltP p (pX a p)) :=
   (ltP_refl_pX Term Monome T2M zeroP zeroP_dec ltM ltM_trans).
Hints Resolve wf_lessP3.
