(****************************************************************************
                                                                           
          Buchberger : module for sminus                                   
                                                                           
          Laurent Thery 	                                             
                                                                           
****************************************************************************)
Require Import sminus.
Load "mod_smultm_lm".

Local multTerm_minusTerm_dist_l:
  (a, b, c:Term) (eqM a b) ->
  (eqTerm
     (minusTerm (multTerm a c) (multTerm b c)) (multTerm (minusTerm a b) c)) :=
   (multTerm_minusTerm_dist_l
      ? ? T2M eqTerm eqTerm_trans eqTerm_ref eqTerm_sym plusTerm
      eqTerm_plusTerm_comp multTerm multTerm_plusTerm_dist_l multTerm_eq
      eqTerm_multTerm_comp invTerm mult_invTerm_com invTerm_eqM minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve multTerm_minusTerm_dist_l.

Local minusTerm_order_l:
  (a, b, c:Term) (eqM a b) -> (order a c) ->(order (minusTerm a b) c) :=
   (minusTerm_order_l ? ? T2M ltM minusTerm minusTerm_ltM_l).
Hints Resolve minusTerm_order_l.

Local invTerm_order_l: (a, c:Term) (order a c) ->(order (invTerm a) c) :=
   (invTerm_order_l ? ? T2M ltM invTerm invTerm_ltM_l).
Hints Resolve invTerm_order_l.

Local minuspf: (list Term) -> (list Term) ->(list Term) :=
   (minuspf ? ? T2M zeroP zeroP_dec ltM ltM_dec multTerm invTerm T1 minusTerm).
Hints Unfold minuspf.

Local minusTerm_eqM1: (m1, m2:Term) (eqM m1 m2) ->(eqM (minusTerm m1 m2) m1) :=
   (minusTerm_eqM1 ? ? T2M minusTerm minusTerm_eq).
Hints Resolve minusTerm_eqM1.

Local nZero_invTerm_nZero: (a:Term) ~ (zeroP a) ->~ (zeroP (invTerm a)) :=
   (nZero_invTerm_nZero
      ? zeroP eqTerm zeroP_comp_eqTerm eqTerm_sym invTerm zeroP_invTerm_zeroP
      invTerm_invol).
Hints Resolve nZero_invTerm_nZero.

Local canonical_minuspf:
  (l1, l2:(list Term)) (canonical l1) -> (canonical l2) ->
  (canonical (minuspf l1 l2)) :=
   (canonical_minuspf
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_ref zeroP_comp_eqTerm eqTerm_sym ltM
      ltM_trans ltM_dec eqTerm_imp_eq multTerm multTerm_ltM_l multTerm_eqM
      invTerm zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l invTerm_eqM
      multTerm_zeroP_div nZero_T1 minusTerm minusTerm_ltM_l invTerm_ltM_l
      minusTerm_eq).
Hints Resolve canonical_minuspf.

Local invTerm_eqM_comp: (a, b:Term) (eqM a b) ->(eqM a (invTerm b)) :=
   (invTerm_eqM_comp ? ? T2M invTerm invTerm_eqM).
Hints Resolve invTerm_eqM_comp.

Local invTerm_T1_eqM_comp:
  (a, b:Term) (eqM a b) ->(eqM a (invTerm (multTerm T1 b))) :=
   (invTerm_T1_eqM_comp
      ? ? T2M eqTerm eqTerm_ref eqTerm_sym eqTerm_imp_eq multTerm invTerm T1
      T1_multTerm_l invTerm_eqM).
Hints Resolve invTerm_T1_eqM_comp.

Local multTerm_invTerm_T1_eqM_comp:
  (a, b:Term) (eqM a b) ->(eqM a (multTerm (invTerm T1) b)) :=
   (multTerm_invTerm_T1_eqM_comp
      ? ? T2M eqTerm eqTerm_ref eqTerm_sym eqTerm_imp_eq multTerm multTerm_eq
      invTerm T1 T1_multTerm_l invTerm_eqM).
Hints Resolve multTerm_invTerm_T1_eqM_comp.

Local invTerm_T1_multTerm_T1:
  (eqTerm (multTerm (invTerm T1) (invTerm T1)) T1) :=
   (invTerm_T1_multTerm_T1
      ? eqTerm eqTerm_trans eqTerm_ref eqTerm_sym multTerm invTerm invTerm_invol
      T1 T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp).
Hints Resolve invTerm_T1_multTerm_T1.

Local minuspf_is_pluspf_multm_lm:
  (p, q:(list Term))(eqP (minuspf p q) (pluspf p (multm_lm (invTerm T1) q))) :=
   (minuspf_is_pluspf_multm_lm
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r eqTerm_plusTerm_comp multTerm multTerm_eq invTerm T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eqM minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve minuspf_is_pluspf_multm_lm.

Local minuspf_pO_refl: (p:(list Term))(eqP (minuspf p pO) p) :=
   (minuspf_pO_refl
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r eqTerm_plusTerm_comp multTerm multTerm_eq invTerm T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eqM minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve minuspf_pO_refl.

Local minuspf_pOmultm_lm:
  (p:(list Term))(eqP (minuspf pO p) (multm_lm (invTerm T1) p)) :=
   (minuspf_pOmultm_lm
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r eqTerm_plusTerm_comp multTerm multTerm_eq invTerm T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eqM minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve minuspf_pOmultm_lm.

Local Opm_ind:
  (P:(list Term) -> (list Term) ->Prop)
  (p, q:(list Term))
  ((p:(list Term))(P pO p)) ->
  ((p:(list Term))(P p pO)) ->
  ((a, b:Term) (p, q:(list Term)) (P (pX a p) q) -> (order a b) ->
   (P (pX a p) (pX b q))) ->
  ((a, b:Term) (p, q:(list Term)) (P p (pX b q)) -> (order b a) ->
   (P (pX a p) (pX b q))) ->
  ((a, b:Term) (p, q:(list Term)) (P p q) -> (eqM a b) ->(P (pX a p) (pX b q))) ->
  (p, q:(list Term))(P p q) := (Opm_ind ? ? T2M ltM ltM_dec).

Local minuspf_inv1:
  (a, b:Term) (p, q:(list Term)) (order b a) ->
  (eqP (pX a (minuspf p (pX b q))) (minuspf (pX a p) (pX b q))) :=
   (minuspf_inv1
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_ref ltM ltM_nonrefl ltM_trans
      ltM_dec multTerm invTerm T1 minusTerm).

Local minuspf_inv2:
  (a, b:Term) (p, q:(list Term)) (order a b) ->
  (eqP (pX (invTerm b) (minuspf (pX a p) q)) (minuspf (pX a p) (pX b q))) :=
   (minuspf_inv2
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_ref ltM ltM_nonrefl ltM_trans
      ltM_dec multTerm invTerm T1 minusTerm).

Local minuspf_inv3a:
  (a, b:Term) (p, q:(list Term)) (eqM a b) -> (zeroP (minusTerm a b)) ->
  (eqP (minuspf p q) (minuspf (pX a p) (pX b q))) :=
   (minuspf_inv3a
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_ref ltM ltM_nonrefl ltM_trans
      ltM_dec multTerm invTerm T1 minusTerm).

Local minuspf_inv3b:
  (a, b:Term) (p, q:(list Term)) (eqM a b) -> ~ (zeroP (minusTerm a b)) ->
  (eqP (pX (minusTerm a b) (minuspf p q)) (minuspf (pX a p) (pX b q))) :=
   (minuspf_inv3b
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_ref ltM ltM_nonrefl ltM_trans
      ltM_dec multTerm invTerm T1 minusTerm).
Hints Resolve minuspf_inv1 minuspf_inv2 minuspf_inv3a minuspf_inv3b.

Local minuspf_pOmultm_lm_eq:
  (p:(list Term))(minuspf pO p)=(multm_lm (invTerm T1) p) :=
   (minuspf_pOmultm_lm_eq
      Term Monome T2M zeroP zeroP_dec ltM ltM_nonrefl ltM_trans ltM_dec multTerm
      invTerm T1 minusTerm).

Local minuspf_pO_refl_eq: (p:(list Term))(minuspf p pO)=p :=
   (minuspf_pO_refl_eq
      Term Monome T2M zeroP zeroP_dec ltM ltM_dec multTerm invTerm T1 minusTerm).

Local minuspf_inv2_eq:
  (a, b:Term) (p, q:(list Term)) (order a b) ->
  (pX (invTerm b) (minuspf (pX a p) q))=(minuspf (pX a p) (pX b q)) :=
   (minuspf_inv2_eq
      ? ? T2M zeroP zeroP_dec ltM ltM_nonrefl ltM_trans ltM_dec multTerm invTerm
      T1 minusTerm).

Local minuspf_inv1_eq:
  (a, b:Term) (p, q:(list Term)) (order b a) ->
  (pX a (minuspf p (pX b q)))=(minuspf (pX a p) (pX b q)) :=
   (minuspf_inv1_eq
      ? ? T2M zeroP zeroP_dec ltM ltM_nonrefl ltM_trans ltM_dec multTerm invTerm
      T1 minusTerm).

Local minuspf_inv3a_eq:
  (a, b:Term) (p, q:(list Term)) (eqM a b) -> (zeroP (minusTerm a b)) ->
  (minuspf p q)=(minuspf (pX a p) (pX b q)) :=
   (minuspf_inv3a_eq
      ? ? T2M zeroP zeroP_dec ltM ltM_nonrefl ltM_trans ltM_dec multTerm invTerm
      T1 minusTerm).

Local minuspf_inv3b_eq:
  (a, b:Term) (p, q:(list Term)) (eqM a b) -> ~ (zeroP (minusTerm a b)) ->
  (pX (minusTerm a b) (minuspf p q))=(minuspf (pX a p) (pX b q)) :=
   (minuspf_inv3b_eq
      ? ? T2M zeroP zeroP_dec ltM ltM_nonrefl ltM_trans ltM_dec multTerm invTerm
      T1 minusTerm).

Local minuspf_eq_inv1:
  (a:Term) (p, q:(list Term)) (canonical (pX a p)) -> (canonical (pX a q)) ->
  (eqP (pX a (minuspf p q)) (minuspf (pX a p) q)) :=
   (minuspf_eq_inv1
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_ref ltM ltM_nonrefl
      ltM_trans ltM_dec multTerm invTerm T1 minusTerm).

Local minuspf_eq_inv2:
  (a:Term) (p, q:(list Term)) (canonical (pX a p)) -> (canonical (pX a q)) ->
  (eqP (pX (invTerm a) (minuspf p q)) (minuspf p (pX a q))) :=
   (minuspf_eq_inv2
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref eqTerm_sym
      ltM ltM_nonrefl ltM_trans ltM_dec multTerm invTerm T1 T1_multTerm_l
      mult_invTerm_com eqTerm_invTerm_comp minusTerm).

Local minuspf_comp:
  (p, q, r, s:(list Term))
  (canonical p) ->
  (canonical q) -> (canonical r) -> (canonical s) -> (eqP p r) -> (eqP q s) ->
  (eqP (minuspf p q) (minuspf r s)) :=
   (minuspf_comp
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r eqTerm_plusTerm_comp multTerm multTerm_ltM_l multTerm_eqM
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve minuspf_comp.

Local multlm_lm_dist_minuspf:
  (p, q:(list Term)) (a:Term) (canonical p) -> (canonical q) -> ~ (zeroP a) ->
  (eqP (multm_lm a (minuspf p q)) (minuspf (multm_lm a p) (multm_lm a q))) :=
   (multlm_lm_dist_minuspf
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r eqTerm_plusTerm_comp multTerm multTerm_ltM_l
      zeroP_multTerm_r multTerm_plusTerm_dist_r multTerm_eqM multTerm_assoc
      multTerm_com eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP
      invTerm_invol T1 T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp
      invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve multlm_lm_dist_minuspf.

Local multlm_lm_pO:
  (p:(list Term)) (a, b:Term) (eqM a b) -> (zeroP (minusTerm a b)) ->
  (eqP pO (minuspf (multm_lm a p) (multm_lm b p))) :=
   (multlm_lm_pO
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r eqTerm_plusTerm_comp multTerm zeroP_multTerm_l
      multTerm_plusTerm_dist_l multTerm_eqM eqTerm_multTerm_comp invTerm T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve multlm_lm_pO.

Local multlm_lm_minusTerm:
  (p:(list Term))
  (a, b:Term) (eqM a b) -> ~ (zeroP (minusTerm a b)) -> (canonical p) ->
  (eqP (multm_lm (minusTerm a b) p) (minuspf (multm_lm a p) (multm_lm b p))) :=
   (multlm_lm_minusTerm
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r eqTerm_plusTerm_comp multTerm multTerm_plusTerm_dist_l
      multTerm_eqM eqTerm_multTerm_comp invTerm T1 T1_multTerm_l
      mult_invTerm_com eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div
      minusTerm eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve multlm_lm_minusTerm.

Local order_pluspf:
  (l1, l2:(list Term))
  (a:Term) (canonical (pX a l1)) -> (canonical (pX a l2)) ->
  (canonical (pX a (pluspf l1 l2))) :=
   (order_pluspf
      ? ? T2M zeroP zeroP_dec ltM ltM_trans ltM_dec plusTerm plusTerm_eq1
      plusTerm_eq2).
Hints Resolve order_pluspf.

Local order_minuspf:
  (l1, l2:(list Term))
  (a:Term) (canonical (pX a l1)) -> (canonical (pX a l2)) ->
  (canonical (pX a (minuspf l1 l2))) :=
   (order_minuspf
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r plusTerm_eq1 plusTerm_eq2 eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l multTerm_eqM invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve order_minuspf.

Local minuspf_refl: (p:(list Term))(eqP (minuspf p p) pO) :=
   (minuspf_refl
      ? ? T2M zeroP zeroP_dec eqTerm zeroP_comp_eqTerm eqTerm_sym ltM
      ltM_nonrefl ltM_dec plusTerm multTerm invTerm plusTerm_invTerm_zeroP T1
      minusTerm eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve minuspf_refl.

Local multm_lm_comp_minuspf:
  (a:Term) (p, q:(list Term)) (canonical p) -> (canonical q) -> ~ (zeroP a) ->
  (eqP (minuspf (multm_lm a p) (multm_lm a q)) (multm_lm a (minuspf p q))) :=
   (multm_lm_comp_minuspf
      Term ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l zeroP_multTerm_r multTerm_plusTerm_dist_r multTerm_eqM
      multTerm_assoc multTerm_com eqTerm_multTerm_comp invTerm
      zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve multm_lm_comp_minuspf.

Local minuspf_zero:
  (a:Term) (p, q:(list Term))(eqP (minuspf (pX a p) (pX a q)) (minuspf p q)) :=
   (minuspf_zero
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec plusTerm multTerm invTerm
      plusTerm_invTerm_zeroP T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve minuspf_zero.

Local pluspf_minuspf_id:
  (p, q:(list Term)) (canonical p) -> (canonical q) ->
  (eqP (pluspf (minuspf p q) q) p) :=
   (pluspf_minuspf_id
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l plusTerm_comp_r
      plusTerm_com plusTerm_eqM1 plusTerm_eqM2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l multTerm_eqM
      eqTerm_multTerm_comp invTerm plusTerm_invTerm_zeroP zeroP_invTerm_zeroP
      invTerm_invol T1 T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp
      invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l invTerm_ltM_l
      minusTerm_eq).
Hints Resolve pluspf_minuspf_id.

Local zerop_is_eqTerm:
  (a, b:Term) (eqM a b) -> (zeroP (minusTerm a b)) ->(eqTerm a b) :=
   (zerop_is_eqTerm
      Term Monome T2M zeroP eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_com
      plusTerm_eq1 plusTerm_eq2 plusTerm_assoc eqTerm_plusTerm_comp invTerm
      plusTerm_invTerm_zeroP invTerm_eq minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).
Hints Resolve zerop_is_eqTerm.

Local inv: (list Term) -> Term ->Term := (inv ? multTerm invTerm T1).

Local inv_prop:
  (a:Term) (p, q:(list Term)) (canonical (pX a p)) ->
  (minuspf p (pX a q))=(pX (inv p a) (minuspf p q)) :=
   (inv_prop
      ? ? T2M zeroP zeroP_dec ltM ltM_nonrefl ltM_trans ltM_dec multTerm invTerm
      T1 minusTerm).

Local pluspf_is_minuspf:
  (p, q:(list Term)) (canonical p) -> (canonical q) ->
  (eqP (pluspf p q) (minuspf p (multm_lm (invTerm T1) q))) :=
   (pluspf_is_minuspf
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l multTerm_eq multTerm_assoc eqTerm_multTerm_comp invTerm
      zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm).

Local minuspf_pO_is_eqP:
  (p, q:(list Term)) (eqP (minuspf p q) pO) ->(eqP p q) :=
   (minuspf_pO_is_eqP
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_dec plusTerm zeroP_plusTermr
      zeroP_plusTerml plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm invTerm plusTerm_invTerm_zeroP T1 invTerm_eq
      minusTerm eqTerm_minusTerm_plusTerm_invTerm).

