Require Import smult.

Local multpf: (list Term) -> (list Term) ->(list Term) :=
   (multpf ? ? T2M zeroP zeroP_dec ltM ltM_dec plusTerm multTerm).

Local canonical_multpf:
  (p, q:(list Term)) (canonical p) -> (canonical q) ->(canonical (multpf p q)) :=
   (canonical_multpf
      Term Monome T2M zeroP zeroP_dec ltM ltM_trans ltM_dec plusTerm
      plusTerm_eq1 plusTerm_eq2 multTerm multTerm_ltM_l multTerm_zeroP_div).
Hints Resolve canonical_multpf.

Local multpf_disr_pX:
  (p, q:(list Term)) (a:Term) (canonical p) -> (canonical (pX a q)) ->
  (eqP (multpf p (pX a q)) (pluspf (multm_lm a p) (multpf p q))) :=
   (multpf_disr_pX
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l multTerm_com
      multTerm_zeroP_div).
Hints Resolve multpf_disr_pX.

Local in_multpf_head:
  (p, q:(list Term)) (a, b:Term) (canonical (pX a p)) -> (canonical (pX b q)) ->
  (In (multTerm a b) (multpf (pX a p) (pX b q))) :=
   (in_multpf_head
      Term Monome T2M zeroP zeroP_dec ltM ltM_nonrefl ltM_trans ltM_dec plusTerm
      multTerm multTerm_ltM_r).

Local multpf_comp:
  (p, r:(list Term)) (eqP p r) ->
  (q, s:(list Term))
  (canonical p) ->
  (canonical q) -> (canonical r) -> (canonical s) -> (eqP q s) ->
  (eqP (multpf p q) (multpf r s)) :=
   (multpf_comp
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_eq1 plusTerm_eq2 eqTerm_plusTerm_comp
      multTerm multTerm_ltM_l eqTerm_multTerm_comp multTerm_zeroP_div).
Hints Resolve multpf_comp.

Local multpf_com:
  (p, q:(list Term)) (canonical p) -> (canonical q) ->
  (eqP (multpf p q) (multpf q p)) :=
   (multpf_com
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l multTerm_com
      multTerm_zeroP_div).
Hints Resolve multpf_com.

