
(****************************************************************************
                                                                           
          Buchberger : module for smultm_lm                                
                                                                           
          Laurent Thery 	                                             
                                                                           
****************************************************************************)
Require Import smultm_lm.
Load "mod_splus".

Local multm_lm: Term -> (list Term) ->(list Term) := (multm_lm ? multTerm).

Local multTerm_order_l:
  (m1, m2, m3:Term) (order m1 m2) ->(order (multTerm m3 m1) (multTerm m3 m2)) :=
   (multTerm_order_l ? ? T2M ltM multTerm multTerm_ltM_l).
Hints Resolve multTerm_order_l.

Local multTerm_order_r:
  (m1, m2, m3:Term) (order m1 m2) ->(order (multTerm m1 m3) (multTerm m2 m3)) :=
   (multTerm_order_r ? ? T2M ltM multTerm multTerm_ltM_r).
Hints Resolve multTerm_order_r.

Local multTerm_eqM:
  (a, b, c, d:Term) (eqM a b) -> (eqM c d) ->(eqM (multTerm a c) (multTerm b d)) :=
   (multTerm_eqM ? ? T2M multTerm multTerm_eq).
Hints Resolve multTerm_eqM.

Local invTerm_eqM: (a:Term)(eqM a (invTerm a)) :=
   (invTerm_eqM ? ? T2M invTerm invTerm_eq).
Hints Resolve invTerm_eqM.

Local T1_is_min: (a:Term)~ (order a T1) :=
   (T1_is_min ? ? T2M ltM T1 T1_is_min_ltM).
Hints Resolve invTerm_eqM.

Local T1_eqM: (a, b:Term) (eqTerm a T1) ->(eqM b (multTerm a b)) :=
   (T1_eqM ? ? T2M eqTerm multTerm T1 T1_eq).

Local eqTerm_T1_eqM: (a:Term) (eqTerm a T1) ->(eqM a T1) :=
   (eqTerm_T1_eqM ? ? T2M eqTerm T1 eqTerm_T1_eq).

Local multm_order_l:
  (l:(list Term)) (m1, m2:Term) ~ (zeroP m1) -> (canonical (pX m2 l)) ->
  (canonical (pX (multTerm m1 m2) (multm_lm m1 l))) :=
   (multm_order_l
      ? ? T2M zeroP zeroP_dec ltM multTerm multTerm_ltM_l multTerm_zeroP_div).

Local canonical_multlm_lm:
  (m:Term) (l:(list Term)) ~ (zeroP m) -> (canonical l) ->
  (canonical (multm_lm m l)) :=
   (canonical_multlm_lm
      ? ? T2M zeroP zeroP_dec ltM multTerm multTerm_ltM_l multTerm_zeroP_div).
Hints Resolve canonical_multlm_lm.

Local tmultm_lm: Term -> (list Term) ->(list Term) :=
   (tmultm_lm ? zeroP zeroP_dec multTerm).

Local tmultlm_lm_zerop_eqp_pO:
  (p:(list Term)) (a:Term) (zeroP a) ->(eqP (tmultm_lm a p) pO) :=
   (tmultlm_lm_zerop_eqp_pO ? zeroP zeroP_dec eqTerm multTerm).
Hints Resolve tmultlm_lm_zerop_eqp_pO.

Local multlm_lm_eqp_pO_pO:
  (p:(list Term)) (a:Term) (eqP p pO) ->(eqP (multm_lm a p) pO) :=
   (multlm_lm_eqp_pO_pO ? eqTerm multTerm).
Hints Resolve multlm_lm_eqp_pO_pO.

Local multlm_lm_dist1:
  (p:(list Term))
  (a, b:Term)
  (eqM a b) ->
  ~ (zeroP a) -> ~ (zeroP b) -> ~ (zeroP (plusTerm a b)) -> (canonical p) ->
  (eqP (multm_lm (plusTerm a b) p) (pluspf (multm_lm a p) (multm_lm b p))) :=
   (multlm_lm_dist1
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec plusTerm multTerm
      multTerm_plusTerm_dist_l multTerm_eqM multTerm_zeroP_div).
Hints Resolve multlm_lm_dist1.

Local multlm_lm_dist2:
  (p:(list Term))
  (a, b:Term)
  (eqM a b) ->
  ~ (zeroP a) -> ~ (zeroP b) -> (zeroP (plusTerm a b)) -> (canonical p) ->
  (eqP pO (pluspf (multm_lm a p) (multm_lm b p))) :=
   (multlm_lm_dist2
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec plusTerm multTerm
      zeroP_multTerm_l multTerm_plusTerm_dist_l multTerm_eqM).
Hints Resolve multlm_lm_dist2.

Local multlm_lm_T1:
  (p:(list Term)) (a:Term) (eqTerm a T1) ->(eqP (multm_lm a p) p) :=
   (multlm_lm_T1 ? eqTerm eqTerm_sym multTerm T1 T1_multTerm_l).
Hints Resolve multlm_lm_T1.

Local multlm_lm_invTerm:
  (p:(list Term)) (a:Term) (eqTerm a T1) ->
  (eqP (pluspf p (multm_lm (invTerm a) p)) pO) :=
   (multlm_lm_invTerm
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec eqTerm_imp_eq plusTerm
      plusTerm_comp_r multTerm multTerm_eqM eqTerm_multTerm_comp invTerm
      plusTerm_invTerm_zeroP T1 T1_multTerm_l mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eqM).
Hints Resolve multlm_lm_invTerm.

Local multlm_lm_multTerm:
  (p:(list Term)) (a, b:Term)
  (eqP (multm_lm (multTerm a b) p) (multm_lm a (multm_lm b p))) :=
   (multlm_lm_multTerm ? eqTerm eqTerm_sym multTerm multTerm_assoc).
Hints Resolve multlm_lm_multTerm.

Local multlm_lm_comA:
  (p:(list Term)) (a, b:Term)
  (eqP (multm_lm (multTerm a b) p) (multm_lm (multTerm b a) p)) :=
   (multlm_lm_comA
      ? eqTerm eqTerm_ref eqTerm_sym multTerm multTerm_com eqTerm_multTerm_comp).
Hints Resolve multlm_lm_comA.

Local multm_lm_comp:
  (a, b:Term) (p, q:(list Term)) (eqTerm a b) -> (eqP p q) ->
  (eqP (multm_lm a p) (multm_lm b q)) :=
   (multm_lm_comp ? eqTerm eqTerm_sym multTerm eqTerm_multTerm_comp).
Hints Resolve multm_lm_comp.

Local multm_lm_ltP_comp:
  (a:Term) (p, q:(list Term)) (ltP p q) ->(ltP (multm_lm a p) (multm_lm a q)) :=
   (multm_lm_ltP_comp ? ? T2M ltM multTerm multTerm_ltM_l multTerm_eq).
Hints Resolve multm_lm_ltP_comp.

Local zeroP_nonZerop_imp_zeroPl:
  (a, b:Term) ~ (zeroP a) -> (zeroP b) ->(zeroP (multTerm b a)) :=
   (zeroP_nonZerop_imp_zeroPl
      ? zeroP multTerm zeroP_multTerm_l multTerm_zeroP_div).

Local zeroP_nonZerop_imp_zeroPr:
  (a, b:Term) ~ (zeroP a) -> (zeroP b) ->(zeroP (multTerm a b)) :=
   (zeroP_nonZerop_imp_zeroPr
      ? zeroP multTerm zeroP_multTerm_l zeroP_multTerm_r multTerm_zeroP_div).

Local nzeroP_nonZerop_imp_zeroPl:
  (a, b:Term) ~ (zeroP a) -> ~ (zeroP b) ->~ (zeroP (multTerm a b)) :=
   (nzeroP_nonZerop_imp_zeroPl ? zeroP multTerm multTerm_zeroP_div).
Hints Resolve
 zeroP_nonZerop_imp_zeroPl zeroP_nonZerop_imp_zeroPr nzeroP_nonZerop_imp_zeroPl
.

Local multlm_comp_canonical:
  (p:(list Term)) (a, b:Term) (canonical (pX a p)) -> ~ (zeroP b) ->
  (canonical (pX (multTerm b a) (multm_lm b p))) :=
   (multlm_comp_canonical
      ? ? T2M zeroP zeroP_dec ltM multTerm multTerm_ltM_l multTerm_zeroP_div).
Hints Resolve multlm_comp_canonical.

Local twoP_ind:
  (P:(list Term) -> (list Term) ->Prop)
  ((p, q:(list Term)) ((r, s:(list Term)) (lessP (r, s) (p, q)) ->(P r s)) ->
   (P p q)) ->(p, q:(list Term))(P p q) := (twoP_ind Term).

Local multlm_lm_dist_pluspf:
  (p, q:(list Term)) (a:Term) (canonical p) -> (canonical q) -> ~ (zeroP a) ->
  (eqP (multm_lm a (pluspf p q)) (pluspf (multm_lm a p) (multm_lm a q))) :=
   (multlm_lm_dist_pluspf
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref zeroP_comp_eqTerm
      eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec plusTerm multTerm
      multTerm_ltM_l zeroP_multTerm_r multTerm_plusTerm_dist_r multTerm_eq
      eqTerm_multTerm_comp multTerm_zeroP_div).
Hints Resolve multlm_lm_dist_pluspf.
