
(****************************************************************************
                                                                           
          Buchberger : module for reduce                                   
                                                                           
          Laurent Thery 	                                             
                                                                           
****************************************************************************)
Require Import sreduce.
Load "mod_spminus".

Local divP_dec:
  (a, b:Term) ~ (zeroP a) -> ~ (zeroP b) ->{(divP a b)}+{~ (divP a b)} :=
   (divP_dec
      Term zeroP eqTerm eqTerm_trans eqTerm_ref eqTerm_sym multTerm
      eqTerm_multTerm_comp divTerm eqTerm_divTerm_com divTerm_dec).

Local divP_eqM:
  (a, b, c:Term) (eqM a b) -> ~ (zeroP b) -> (divP a c) ->(divP b c) :=
   (divP_eqM Term Monome T2M zeroP eqTerm multTerm divTerm divTerm_eq).

Local inPolySet: (list Term) -> (list poly) ->Prop :=
   (inPolySet Term Monome T2M zeroP zeroP_dec ltM).

Local incons:
  (a:Term) (p:(list Term)) (H:(canonical (pX a p))) (P:(list poly))
  (inPolySet
     (pX a p)
     (cons (exist (list Term) [l0:(list Term)](canonical l0) (pX a p) H) P)) :=
   (incons Term Monome T2M zeroP zeroP_dec ltM).

Local inskip:
  (a:poly) (p:(list Term)) (P:(list poly)) (inPolySet p P) ->
  (inPolySet p (cons a P)) := (inskip Term Monome T2M zeroP zeroP_dec ltM).
Hints Resolve incons inskip.

Local inPolySet_imp_canonical:
  (p:(list Term)) (L:(list poly)) (inPolySet p L) ->(canonical p) :=
   (inPolySet_imp_canonical Term Monome T2M zeroP zeroP_dec ltM).

Local inPolySet_is_pX:
  (p:(list Term)) (L:(list poly)) (inPolySet p L) ->
  (Ex [a:Term] (Ex [q:(list Term)] p=(pX a q))) :=
   (inPolySet_is_pX Term Monome T2M zeroP zeroP_dec ltM).

Local pickinSetp: Term -> (list Term) -> (list poly) ->Prop :=
   (pickinSetp Term Monome T2M zeroP zeroP_dec eqTerm ltM multTerm divTerm).

Local pickinSeteqp:
  (a, b:Term)
  (p:(list Term)) (H:(canonical (pX b p))) (P:(list poly)) (divP a b) ->
  (pickinSetp
     a (pX b p)
     (cons (exist (list Term) [l0:(list Term)](canonical l0) (pX b p) H) P)) :=
   (pickinSeteqp Term Monome T2M zeroP zeroP_dec eqTerm ltM multTerm divTerm).

Local pickinSetskip:
  (a, b:Term) (p:(list Term)) (q:poly) (P:(list poly)) (pickinSetp a p P) ->
  (pickinSetp a p (cons q P)) :=
   (pickinSetskip Term Monome T2M zeroP zeroP_dec eqTerm ltM multTerm divTerm).
Hints Resolve pickinSeteqp pickinSetskip.

Local pickin_is_pX:
  (a:Term) (p:(list Term)) (Q:(list poly)) (pickinSetp a p Q) ->
  (Ex [b:Term] (Ex [q:(list Term)] p=(pX b q))) :=
   (pickin_is_pX Term Monome T2M zeroP zeroP_dec eqTerm ltM multTerm divTerm).

Local reduce: (list poly) -> (list Term) -> (list Term) ->Prop :=
   (reduce
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local reducetop:
  (Q:(list poly))
  (a, b:Term)
  (nZb:~ (zeroP b))
  (p, q, r:(list Term))
  (inPolySet (pX b q) Q) -> (divP a b) -> (eqP (spminusf a b nZb p q) r) ->
  (reduce Q (pX a p) r) :=
   (reducetop
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local reduceskip:
  (Q:(list poly))
  (a, b:Term) (p, q:(list Term)) (reduce Q p q) -> (eqTerm a b) ->
  (reduce Q (pX a p) (pX b q)) :=
   (reduceskip
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).
Hints Resolve reducetop reduceskip.

Local reducehead: (list poly) -> (list Term) -> (list Term) ->Prop :=
   (reducehead
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local reduceheadO:
  (Q:(list poly))
  (a, b:Term) (nZb:~ (zeroP b)) (p, q:(list Term)) (pickinSetp a (pX b q) Q) ->
  (reducehead Q (pX a p) (spminusf a b nZb p q)) :=
   (reduceheadO
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).
Hints Resolve reduceheadO.

Local pick_inv_in:
  (Q:(list poly)) (a:Term) (p:(list Term)) (pickinSetp a p Q) ->(inPolySet p Q) :=
   (pick_inv_in Term Monome T2M zeroP zeroP_dec eqTerm ltM multTerm divTerm).

Local pick_inv_eqM:
  (Q:(list poly)) (a, b:Term) (p, q:(list Term)) (pickinSetp a (pX b q) Q) ->
  (divP a b) :=
   (pick_inv_eqM Term Monome T2M zeroP zeroP_dec eqTerm ltM multTerm divTerm).

Local reducehead_imp_reduce:
  (Q:(list poly)) (p, q:(list Term)) (reducehead Q p q) ->(reduce Q p q) :=
   (reducehead_imp_reduce
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_ref ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm).

Local ltP_reduce:
  (Q:(list poly)) (p, q:(list Term)) (reduce Q p q) -> (canonical p) ->(ltP q p) :=
   (ltP_reduce
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eqM plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      divTerm eqTerm_divTerm_com).

Local canonical_reduce:
  (Q:(list poly)) (p, q:(list Term)) (reduce Q p q) -> (canonical p) ->
  (canonical q) :=
   (canonical_reduce
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eqM plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com).

Local reduce_eqp_com:
  (Q:(list poly))
  (p, q, r, s:(list Term))
  (reduce Q p q) -> (canonical p) -> (eqP p r) -> (eqP q s) ->(reduce Q r s) :=
   (reduce_eqp_com
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l zeroP_multTerm_l multTerm_eq eqTerm_multTerm_comp invTerm
      zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm divTerm eqTerm_divTerm_com).

Local reduceplus: (list poly) -> (list Term) -> (list Term) ->Prop :=
   (reduceplus
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local Rstar_0:
  (Q:(list poly)) (x, y:(list Term)) (eqP x y) ->(reduceplus Q x y) :=
   (Rstar_0
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local Rstar_n:
  (Q:(list poly)) (x, y, z:(list Term)) (reduce Q x y) -> (reduceplus Q y z) ->
  (reduceplus Q x z) :=
   (Rstar_n
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).
Hints Resolve Rstar_0.

Local reduceplus_eqp_com:
  (Q:(list poly))
  (p, q, r, s:(list Term))
  (reduceplus Q p q) -> (canonical p) -> (eqP p r) -> (eqP q s) ->
  (reduceplus Q r s) :=
   (reduceplus_eqp_com
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com).

Local reduceplus_trans:
  (Q:(list poly))
  (x, y, z:(list Term))
  (reduceplus Q x y) -> (canonical x) -> (reduceplus Q y z) ->(reduceplus Q x z) :=
   (reduceplus_trans
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com).

Local canonical_reduceplus:
  (Q:(list poly)) (p, q:(list Term)) (reduceplus Q p q) -> (canonical p) ->
  (canonical q) :=
   (canonical_reduceplus
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eqM plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com).

Local order_reduceplus:
  (Q:(list poly)) (p, q:(list Term)) (reduceplus Q p q) -> (canonical p) ->
  (ltP q p) \/ (eqP p q) :=
   (order_reduceplus
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eqM plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com).

Local reduceplus_skip:
  (Q:(list poly))
  (a, b:Term)
  (p, q:(list Term))
  (reduceplus Q p q) -> (canonical (pX a p)) -> (eqTerm a b) ->
  (reduceplus Q (pX a p) (pX b q)) :=
   (reduceplus_skip
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eqM plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com).

Local irreducible :=
   (irreducible
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local irreducible_eqp_com:
  (Q:(list poly))
  (p, q:(list Term)) (irreducible Q p) -> (canonical p) -> (eqP p q) ->
  (irreducible Q q) :=
   (irreducible_eqp_com
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l zeroP_multTerm_l multTerm_eq eqTerm_multTerm_comp invTerm
      zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm divTerm eqTerm_divTerm_com).

Local reducestar: (list poly) -> (list Term) -> (list Term) ->Prop :=
   (reducestar
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local reducestar0:
  (Q:(list poly)) (p, q:(list Term)) (reduceplus Q p q) -> (irreducible Q q) ->
  (reducestar Q p q) :=
   (reducestar0
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local reducestar_eqp_com:
  (Q:(list poly))
  (p, q, r, s:(list Term))
  (reducestar Q p q) -> (canonical p) -> (eqP p r) -> (eqP q s) ->
  (reducestar Q r s) :=
   (reducestar_eqp_com
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com).

Local reduce_multm:
  (Q:(list poly))
  (a:Term) (p, q:(list Term)) (reduce Q p q) -> (canonical p) -> ~ (zeroP a) ->
  (reduce Q (multm_lm a p) (multm_lm a q)) :=
   (reduce_multm
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l zeroP_multTerm_l zeroP_multTerm_r multTerm_plusTerm_dist_r
      multTerm_eq multTerm_assoc multTerm_com eqTerm_multTerm_comp invTerm
      zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm divTerm eqTerm_divTerm_com
      divTerm_multTerm_l).

Local reduce_imp_reduceplus:
  (Q:(list poly)) (p, q:(list Term)) (reduce Q p q) ->(reduceplus Q p q) :=
   (reduce_imp_reduceplus
      ? ? T2M zeroP zeroP_dec eqTerm eqTerm_ref ltM ltM_dec multTerm invTerm T1
      minusTerm divTerm).
Hypothesis sOp:
           (Q:(list poly)) (r:(list Term)) (canonical r) ->
           {q:(list Term) | (reduce Q r q)}+{(irreducible Q r)}.

Local s2p: poly ->(list Term) := (s2p ? ? T2M zeroP zeroP_dec ltM).

Local Reduce0:
  (Q:(list poly)) (p:poly){q:poly | (reducestar Q (s2p p) (s2p q))} :=
   (Reduce0
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec ltM_wf
      eqTerm_imp_eqM plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com sOp).

Local reduce0_reducestar:
  (Q:(list poly)) (p:(list Term)) (canonical p) ->
  (Ex [t:(list Term)] (reducestar Q p t)) :=
   (reduce0_reducestar
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec ltM_wf
      eqTerm_imp_eqM plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com sOp).

Local pO_irreducible: (Q:(list poly))(irreducible Q pO) :=
   (pO_irreducible
      ? ? T2M zeroP zeroP_dec eqTerm ltM ltM_dec multTerm invTerm T1 minusTerm
      divTerm).

Local pickinSet:
  (a:Term) ~ (zeroP a) ->
  (Q:(list poly))
  {p:(list Term) | (pickinSetp a p Q)}+{
   (b:Term) (p, q:(list Term)) (inPolySet p Q) -> (divP a b) ->~ p=(pX b q)} :=
   (pickinSet
      Term ? T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref eqTerm_sym ltM
      multTerm eqTerm_multTerm_comp divTerm eqTerm_divTerm_com divTerm_dec).

Local Reduce1:
  (Q:(list poly)) (p:poly){q:poly | (reducestar Q (s2p p) (s2p q))} :=
   (Reduce1
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec ltM_wf
      eqTerm_imp_eqM plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l multTerm_eq
      eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP invTerm_invol T1
      T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp invTerm_eq
      multTerm_zeroP_div nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm
      minusTerm_ltM_l invTerm_ltM_l minusTerm_eq divTerm eqTerm_divTerm_com
      divTerm_dec).

Local reduce_multm_invr:
  (Q:(list poly))
  (p, q:(list Term)) (reduce Q (multm_lm (invTerm T1) p) q) -> (canonical p) ->
  (reduce Q p (multm_lm (invTerm T1) q)) :=
   (reduce_multm_invr
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r eqTerm_plusTerm_comp multTerm
      multTerm_ltM_l zeroP_multTerm_l zeroP_multTerm_r multTerm_plusTerm_dist_r
      multTerm_eq multTerm_assoc multTerm_com eqTerm_multTerm_comp invTerm
      zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l mult_invTerm_com
      eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm divTerm eqTerm_divTerm_com
      divTerm_multTerm_l divTerm_eq).

Local reduceplus_multm_invr:
  (Q:(list poly))
  (p, q:(list Term))
  (reduceplus Q (multm_lm (invTerm T1) p) q) -> (canonical p) ->
  (reduceplus Q p (multm_lm (invTerm T1) q)) :=
   (reduceplus_multm_invr
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l
      zeroP_multTerm_r multTerm_plusTerm_dist_r multTerm_eq multTerm_assoc
      multTerm_com eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP
      invTerm_invol T1 T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp
      invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l invTerm_ltM_l
      minusTerm_eq divTerm eqTerm_divTerm_com divTerm_multTerm_l divTerm_eq).

Local reduceplus_multm:
  (Q:(list poly))
  (a:Term)
  (p, q:(list Term)) (reduceplus Q p q) -> (canonical p) -> ~ (zeroP a) ->
  (reduceplus Q (multm_lm a p) (multm_lm a q)) :=
   (reduceplus_multm
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm plusTerm_comp_r plusTerm_eq1 plusTerm_eq2
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l
      zeroP_multTerm_r multTerm_plusTerm_dist_r multTerm_eq multTerm_assoc
      multTerm_com eqTerm_multTerm_comp invTerm zeroP_invTerm_zeroP
      invTerm_invol T1 T1_multTerm_l mult_invTerm_com eqTerm_invTerm_comp
      invTerm_eq multTerm_zeroP_div nZero_T1 minusTerm
      eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l invTerm_ltM_l
      minusTerm_eq divTerm eqTerm_divTerm_com divTerm_multTerm_l).

Local red_minus_zero_reduce:
  (Q:(list poly))
  (p, q:(list Term))
  (canonical p) -> (canonical q) -> (reduceplus Q (minuspf p q) pO) ->
  (Ex [r1:(list Term)] (reduceplus Q p r1) /\ (reduceplus Q q r1)) :=
   (red_minus_zero_reduce
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l
      zeroP_multTerm_r multTerm_plusTerm_dist_l multTerm_plusTerm_dist_r
      multTerm_eq multTerm_assoc multTerm_com eqTerm_multTerm_comp invTerm
      plusTerm_invTerm_zeroP zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l
      mult_invTerm_com eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div
      nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l
      invTerm_ltM_l minusTerm_eq divTerm eq_divTerm_plusTerm eq_divTerm
      eqTerm_divTerm_com divTerm_multTerm_l divTerm_eq).

Local one_minus_reduceplus:
  (Q:(list poly)) (p1, p2:(list Term)) (reduce Q p1 p2) ->
  (r:(list Term)) (canonical p1) -> (canonical r) ->
  (Ex [s:(list Term)]
  (reduceplus Q (minuspf p1 r) s) /\ (reduceplus Q (minuspf p2 r) s)) :=
   (one_minus_reduceplus
      Term Monome T2M zeroP zeroP_dec eqTerm eqTerm_trans eqTerm_ref
      zeroP_comp_eqTerm eqTerm_sym ltM ltM_nonrefl ltM_trans ltM_dec
      eqTerm_imp_eq plusTerm zeroP_plusTermr zeroP_plusTerml plusTerm_comp_l
      plusTerm_comp_r plusTerm_com plusTerm_eq1 plusTerm_eq2 plusTerm_assoc
      eqTerm_plusTerm_comp multTerm multTerm_ltM_l zeroP_multTerm_l
      zeroP_multTerm_r multTerm_plusTerm_dist_l multTerm_plusTerm_dist_r
      multTerm_eq multTerm_assoc eqTerm_multTerm_comp invTerm
      plusTerm_invTerm_zeroP zeroP_invTerm_zeroP invTerm_invol T1 T1_multTerm_l
      mult_invTerm_com eqTerm_invTerm_comp invTerm_eq multTerm_zeroP_div
      nZero_T1 minusTerm eqTerm_minusTerm_plusTerm_invTerm minusTerm_ltM_l
      invTerm_ltM_l minusTerm_eq divTerm eq_divTerm_plusTerm divTerm_invTerm_l
      eq_divTerm eqTerm_divTerm_com divTerm_eq).
