(*****************************************************************************)
(*                                                                           *)
(*          Buchberger : hypothesis for spolynomials                         *)
(*                                                                           *)
(*          Laurent Thery June 97 (revised Mai 98)                           *)
(*                                                                           *)
(*****************************************************************************)

Load shyp_sreduce.

Variable ppc:Term -> Term ->Term.

Hypothesis divTerm_rew:
           (a, b:Term) (nZ1, nZ2:~ (zeroP b))
           (divTerm a b nZ1)=(divTerm a b nZ2).

Hypothesis divTerm_on_eq:
           (a, b:Term) ~ (zeroP a) -> (nZb:~ (zeroP b)) (T2M a)=(T2M b) ->
           (eqTerm a (multTerm (divTerm a b nZb) b)).

Hypothesis  divTerm_on_eq_eq:
           (a, b:Term) ~ (zeroP a) -> (nZb:~ (zeroP b))  (T2M a) = (T2M b) ->
           (T2M (divTerm a b nZb))=(T2M T1).

Hypothesis ppc_nZ:
(a,b:Term) ~ (zeroP a) -> ~ (zeroP b) -> ~ (zeroP (ppc a b)).

Hypothesis divTerm_ppc:

(a,b,c:Term) (nZa: ~ (zeroP a)) (nZb:~ (zeroP b)) (nZppab:~ (zeroP (ppc a b)))
  (eqTerm c (multTerm (divTerm c a nZa) a)) ->
  (eqTerm c (multTerm (divTerm c b nZb) b)) ->
  (eqTerm c (multTerm (divTerm c (ppc a b) nZppab) (ppc a b))).

Hypothesis divTerm_ppcl:
(a,b:Term) (nZa:~ (zeroP a))  ~ (zeroP b) -> 
  (eqTerm (ppc a b) (multTerm (divTerm (ppc a b) a nZa) a)).

Hypothesis divTerm_ppcr:
(a,b:Term) ~ (zeroP a) -> (nZb:~ (zeroP b)) 
  (eqTerm (ppc a b) (multTerm (divTerm (ppc a b) b nZb) b)).

Hypothesis divTerm_nZ:(a, b:Term) ~ (zeroP a) -> (nZb:~ (zeroP b)) ~ (zeroP (divTerm a b nZb)).

