
(****************************************************************************
                                                                           
          Buchberger : Hypothesis for canonical polynomial                 
                                                                           
          Laurent Thery February 97 (revised Mai 98)                       
                                                                           
****************************************************************************)
Require Import Relation_Definitions.
Variable Term:Set.
Variable Monome:Set.
Variable T2M:Term ->Monome.
Variable zeroP:Term ->Prop.
Hypothesis zeroP_dec:(x:Term){(zeroP x)}+{~ (zeroP x)}.
Variable eqTerm:Term -> Term ->Prop.
Hypothesis eqTerm_trans:(transitive Term eqTerm).
Hypothesis eqTerm_ref:(reflexive Term eqTerm).
Hypothesis eqTerm_dec:(x, y:Term){(eqTerm x y)}+{~ (eqTerm x y)}.
Hypothesis zeroP_comp_eqTerm:(a, b:Term) (zeroP a) -> (eqTerm a b) ->(zeroP b).
Hypothesis eqTerm_sym:(symmetric Term eqTerm).
Hypothesis eqMonome_dec:(x, y:Monome){x=y}+{~ x=y}.
Variable ltM:Monome -> Monome ->Prop.
Hypothesis ltM_nonrefl:(x:Monome)~ (ltM x x).
Hypothesis ltM_trans:(transitive Monome ltM).
Hypothesis ltM_dec:(x, y:Monome){(ltM x y)}+{(ltM y x)}+{x=y}.
Hypothesis ltM_wf:(well_founded Monome ltM).
Hypothesis eqTerm_imp_eq:(a, b:Term) (eqTerm a b) ->(T2M a)=(T2M b).
