(****************************************************************************
                                                                           
          Buchberger : hypothesis for multiplication by a term             
                                                                           
          Laurent Thery March 97 (revised Mai 98)                          
                                                                           
****************************************************************************)
Load "shyp_splus".
Variable multTerm:Term -> Term ->Term.
Hypothesis multTerm_ltM_l:
           (m1, m2, m3:Term) (ltM (T2M m1) (T2M m2)) ->
           (ltM (T2M (multTerm m3 m1)) (T2M (multTerm m3 m2))).
Hypothesis multTerm_ltM_r:
           (m1, m2, m3:Term) (ltM (T2M m1) (T2M m2)) ->
           (ltM (T2M (multTerm m1 m3)) (T2M (multTerm m2 m3))).
Hypothesis zeroP_multTerm_l:(a, b:Term) (zeroP a) ->(zeroP (multTerm a b)).
Hypothesis zeroP_multTerm_r:(a, b:Term) (zeroP a) ->(zeroP (multTerm b a)).
Hypothesis multTerm_plusTerm_dist_l:
           (a, b, c:Term)
           (eqTerm
              (plusTerm (multTerm a c) (multTerm b c))
              (multTerm (plusTerm a b) c)).
Hypothesis multTerm_plusTerm_dist_r:
           (a, b, c:Term)
           (eqTerm
              (plusTerm (multTerm c a) (multTerm c b))
              (multTerm c (plusTerm a b))).
Hypothesis multTerm_eq:
           (a, b, c, d:Term) (T2M a)=(T2M b) -> (T2M c)=(T2M d) ->
           (T2M (multTerm a c))=(T2M (multTerm b d)).
Hypothesis multTerm_assoc:
           (a, b, c:Term)
           (eqTerm (multTerm a (multTerm b c)) (multTerm (multTerm a b) c)).
Hypothesis multTerm_com:(a, b:Term)(eqTerm (multTerm a b) (multTerm b a)).
Hypothesis eqTerm_multTerm_comp:
           (a, b, c, d:Term) (eqTerm a b) -> (eqTerm c d) ->
           (eqTerm (multTerm a c) (multTerm b d)).
Variable invTerm:Term ->Term.
Hypothesis plusTerm_invTerm_zeroP:(a:Term)(zeroP (plusTerm a (invTerm a))).
Hypothesis zeroP_invTerm_zeroP:(a:Term) (zeroP a) ->(zeroP (invTerm a)).
Hypothesis invTerm_invol:(a:Term)(eqTerm a (invTerm (invTerm a))).
Variable T1:Term.
Hypothesis T1_multTerm_l:(a, b:Term) (eqTerm a T1) ->(eqTerm b (multTerm a b)).
Hypothesis T1_multTerm_r:(a, b:Term) (eqTerm a T1) ->(eqTerm b (multTerm b a)).
Hypothesis mult_invTerm_com:
           (a, b:Term)(eqTerm (multTerm (invTerm a) b) (invTerm (multTerm a b))).
Hypothesis mult_invTerm_com_r:
           (a, b:Term)(eqTerm (multTerm a (invTerm b)) (invTerm (multTerm a b))).
Hypothesis eqTerm_invTerm_comp:
           (a, b:Term) (eqTerm a b) ->(eqTerm (invTerm a) (invTerm b)).
Hypothesis invTerm_eq:(a:Term)(T2M a)=(T2M (invTerm a)).
Hypothesis T1_is_min_ltM:(a:Term)~ (ltM (T2M a) (T2M T1)).
Hypothesis T1_eq:(a, b:Term) (eqTerm a T1) ->(T2M b)=(T2M (multTerm a b)).
Hypothesis eqTerm_T1_eq:(a:Term) (eqTerm a T1) ->(T2M a)=(T2M T1).
Hypothesis multTerm_zeroP_div:
           (a, b:Term) (zeroP (multTerm a b)) ->(zeroP a) \/ (zeroP b).

