(*****************************************************************************)
(*                                                                           *)
(*          Buchberger : Hypothesis for addition over polynomials            *)
(*                                                                           *)
(*          Laurent Thery February 97 (revised Mai 98)                       *)
(*                                                                           *)
(*****************************************************************************)

Load "shyp_seq".
Variable plusTerm:Term -> Term ->Term.
Hypothesis zeroP_plusTermr:(a, b:Term) (T2M a) = (T2M b) ->  (zeroP b) ->(eqTerm a (plusTerm a b)).
Hypothesis zeroP_plusTerml:(a, b:Term)  (T2M a) = (T2M b) ->  (zeroP a) ->(eqTerm b (plusTerm a b)).
Hypothesis plusTerm_comp_l:(a, b, c:Term)  (T2M a) = (T2M c) -> (T2M b) = (T2M c) -> (eqTerm a b) ->(eqTerm (plusTerm a c) (plusTerm b c)).
Hypothesis plusTerm_comp_r:(a, b, c:Term)  (T2M c) = (T2M a) -> (T2M c) = (T2M b) -> (eqTerm a b) ->(eqTerm (plusTerm c a) (plusTerm c b)).
Hypothesis plusTerm_com:(x, y:Term) (T2M x) = (T2M y) -> (eqTerm (plusTerm x y) (plusTerm y x)).
Hypothesis plusTerm_eq1:(m1, m2:Term) (T2M m1) =(T2M m2) ->(T2M (plusTerm m1 m2)) =(T2M m1).
Hypothesis plusTerm_eq2:(m1, m2:Term) (T2M m1) =(T2M m2) ->(T2M (plusTerm m1 m2)) =(T2M m2).
Hypothesis plusTerm_assoc:
           (a, a0, a1:Term) (T2M a1) = (T2M a0) -> (T2M a) = (T2M a0) -> 
               (eqTerm (plusTerm (plusTerm a1 a0) a) (plusTerm a1 (plusTerm a0 a))).
Hypothesis eqTerm_plusTerm_comp:
           (a, b, c, d:Term) (T2M a) = (T2M c) -> (T2M b) = (T2M d) -> 
                          (eqTerm a b) -> (eqTerm c d) ->(eqTerm (plusTerm a c) (plusTerm b d)).
