(*****************************************************************************)
(*                                                                           *)
(*          Buchberger : hypotheis for one step division                     *)
(*                                                                           *)
(*          Laurent Thery April 97 (revised Mai 98)                          *)
(*                                                                           *)
(*****************************************************************************)

Load "shyp_sminus".
Variable divTerm:(a,b:Term) (nZb:~(zeroP b)) Term.
Hypothesis eq_divTerm_plusTerm: (a,b,c:Term) 
(nZc: ~(zeroP c))
(T2M a) = (T2M b) ->
(eqTerm a (multTerm (divTerm a c nZc) c))  -> 
(eqTerm b (multTerm (divTerm b c nZc) c)) -> 
(eqTerm (divTerm (plusTerm a b) c nZc) (plusTerm (divTerm a c nZc) (divTerm b c nZc))).

Hypothesis divTerm_invTerm_l: (a,b:Term) 
(nZa:~(zeroP a))
(eqTerm b (multTerm (divTerm b a nZa) a))  -> 
(eqTerm (divTerm (invTerm b) a nZa) (invTerm (divTerm b a nZa))).

Hypothesis divTerm_invTerm_r: (a,b:Term) 
(nZa:~(zeroP a))
(nZia:~(zeroP (invTerm a)))
(eqTerm b (multTerm (divTerm b a nZa) a))  -> 
(eqTerm (divTerm  b (invTerm a) nZia) (invTerm (divTerm b a nZa))).

Hypothesis eq_divTerm : 
(a,b,c,d:Term)
(nZc:~(zeroP c))
(nZd:~(zeroP d))
((T2M a) = (T2M b)) ->((T2M c) = (T2M d)) ->
            (T2M (divTerm a c nZc)) = (T2M (divTerm b d nZd)).

Hypothesis eqTerm_divTerm_com: (a,b,c,d:Term) 
(nZc:~(zeroP c))
(nZd:~(zeroP d))
(eqTerm a b) -> (eqTerm c d) ->
(eqTerm (divTerm a c nZc) (divTerm b d nZd)).


Hypothesis divTerm_multTerm_l: (a,b,c:Term) 
(nZa:~(zeroP a))
(eqTerm b (multTerm (divTerm b a nZa) a))  -> 
(eqTerm (divTerm (multTerm c b) a nZa) (multTerm c (divTerm b a nZa))).

Hypothesis divTerm_multTerm_r: (a,b,c:Term) 
(nZa: ~(zeroP a))
(eqTerm b (multTerm (divTerm b a nZa) a))  -> 
(eqTerm (divTerm  (multTerm b c) a nZa) (multTerm (divTerm b a nZa) c)).


Hypothesis div_is_T1:(a:Term) (nZa:~ (zeroP a)) (eqTerm (divTerm a a nZa) T1).

