
(****************************************************************************
                                                                           
          Buchberger : substraction over polynomials                       
                                                                           
          Laurent Thery March 97 (revised Mai 98)                          
                                                                           
***************************************************************************
 definition of minusP *)
Section SMinus.
Load "shyp_sminus".
Load "mod_smultm_lm".

Theorem multTerm_minusTerm_dist_l:
  (a, b, c:Term) (eqM a b) ->
  (eqTerm
     (minusTerm (multTerm a c) (multTerm b c)) (multTerm (minusTerm a b) c)).
Intros a b c eqM1.
Apply eqTerm_trans with y := (multTerm (plusTerm a (invTerm b)) c); Auto.
Apply eqTerm_trans with y := (plusTerm (multTerm a c) (multTerm (invTerm b) c));
 Auto.
Apply eqTerm_trans with y := (plusTerm (multTerm a c) (invTerm (multTerm b c)));
 Auto.
Apply eqTerm_plusTerm_comp; Auto.
Change (eqM (multTerm a c) (invTerm (multTerm b c))).
Apply eqM_trans with y := (multTerm b c); Auto.
Change (eqM (multTerm a c) (multTerm (invTerm b) c)).
Apply eqM_trans with y := (multTerm b c); Auto.
Qed.
Hints Resolve multTerm_minusTerm_dist_l.

Theorem minusTerm_order_l:
  (a, b, c:Term) (eqM a b) -> (order a c) ->(order (minusTerm a b) c).
Exact minusTerm_ltM_l.
Qed.
Hints Resolve minusTerm_order_l.

Theorem invTerm_order_l: (a, c:Term) (order a c) ->(order (invTerm a) c).
Exact invTerm_ltM_l.
Qed.
Hints Resolve invTerm_order_l.

Mutual Inductive minusP: (list Term) -> (list Term) -> (list Term) ->Prop :=
     mnillu1: (l1:(list Term))(minusP pO l1 (multm_lm (invTerm T1) l1))
    | mnillu2: (l1:(list Term))(minusP l1 pO l1)
    | mmainu1:
        (a1, a2:Term)
        (l1, l2, l3:(list Term)) (order a2 a1) -> (minusP l1 (pX a2 l2) l3) ->
        (minusP (pX a1 l1) (pX a2 l2) (pX a1 l3))
    | mmainu2a:
        (a1, a2:Term)
        (l1, l2, l3:(list Term))
        (minusP l1 l2 l3) -> (eqM a1 a2) -> (zeroP (minusTerm a1 a2)) ->
        (minusP (pX a1 l1) (pX a2 l2) l3)
    | mmainu2b:
        (a1, a2:Term)
        (l1, l2, l3:(list Term))
        (minusP l1 l2 l3) -> (eqM a1 a2) -> ~ (zeroP (minusTerm a1 a2)) ->
        (minusP (pX a1 l1) (pX a2 l2) (pX (minusTerm a1 a2) l3))
    | mmainu3:
        (a1, a2:Term)
        (l1, l2, l3:(list Term)) (order a1 a2) -> (minusP (pX a1 l1) l2 l3) ->
        (minusP (pX a1 l1) (pX a2 l2) (pX (invTerm a2) l3)) .
Hints Resolve mnillu1 mnillu2 mmainu1 mmainu2a mmainu2b mmainu3.
Require Import LetP.

Definition minuspp:
  (l:(list Term) * (list Term)){a:(list Term) | (minusP (Fst l) (Snd l) a)}.
Intros l; Pattern l.
Apply well_founded_induction with A := (list Term) * (list Term) R := lessP;
 Auto.
Intros x; Case x; Intros l1 l2; Simpl.
Case l1.
Intros H'; Exists (multm_lm (invTerm T1) l2); Auto.
Intros a1 m1; Case l2.
Intros H'; Exists (pX a1 m1); Auto.
Intros a2 m2 H'; Case (order_dec a1 a2); [Intros P; Case P; Clear P | Idtac];
 Intros H1.
LApply (H' ((pX a1 m1), m2)); Simpl;
 [Intros Rec; Case Rec; Clear Rec; Intros Orec Prec | Idtac].
Exists (pX (invTerm a2) Orec); Auto.
Red; Red; Simpl; Rewrite <- plus_n_Sm; Auto.
LApply (H' (m1, (pX a2 m2))); Simpl;
 [Intros Rec; Case Rec; Clear Rec; Intros Orec Prec | Idtac].
Exists (pX a1 Orec); Auto.
Red; Red; Simpl; Rewrite <- plus_n_Sm; Auto.
LApply (H' (m1, m2)); Simpl;
 [Intros Rec; Case Rec; Clear Rec; Intros Orec Prec | Idtac].
Apply LetP with A := Term h := (minusTerm a1 a2).
Intros u H'0; Case (zeroP_dec u); Intros Z0.
Exists Orec; Auto.
Rewrite H'0 in Z0; Auto.
Exists (pX u Orec); Auto.
Rewrite H'0 in Z0; Auto.
Rewrite H'0; Auto.
Red; Red; Simpl; Rewrite <- plus_n_Sm; Auto.
Defined.

Definition minuspf :=
   [l1, l2:(list Term)](projsig1 (list Term) ? (minuspp (l1, l2))).

Theorem zerop_is_eqTerm:
  (a, b:Term) (eqM a b) -> (zeroP (minusTerm a b)) ->(eqTerm a b).
Intros a b H' H'0.
Cut (eqM a (invTerm b)); [Intros eq1 | Idtac].
Cut (eqM a (plusTerm b (invTerm b))); [Intros eq2 | Idtac].
Apply eqTerm_trans with y := (plusTerm (plusTerm a (invTerm b)) b); Auto.
Apply eqTerm_trans with y := (plusTerm a (plusTerm (invTerm b) b)); Auto.
Apply eqTerm_trans with y := (plusTerm a (plusTerm b (invTerm b))); Auto.
Apply eqTerm_plusTerm_comp; Auto.
Change (eqM a (plusTerm (invTerm b) b)).
Apply eqM_trans with y := (plusTerm a b); Apply eqM_sym; Auto.
Apply eqM_trans with y := b; Auto.
Apply plusTerm_eqM2; Auto.
Apply eqM_sym; Auto.
Apply eqM_sym; Auto.
Apply eqTerm_sym; Apply zeroP_plusTerml; Auto.
Change (eqM (plusTerm a (invTerm b)) b).
Apply eqM_trans with y := a; Auto.
Apply zeroP_comp_eqTerm with a := (minusTerm a b); Auto.
Apply eqM_trans with y := (plusTerm a (invTerm b)); Auto.
Apply eqM_sym; Auto.
Apply eqM_trans with y := a; Auto.
Apply eqM_trans with y := b; Auto.
Apply eqM_sym; Auto.
Apply eqM_trans with y := b; Auto.
Qed.
Hints Unfold minuspf.

Theorem minusTerm_zeroP_r:
  (a, b:Term) (zeroP a) -> (eqM a b) ->(eqTerm (minusTerm a b) (invTerm b)).
Intros a b H' H0; Apply eqTerm_trans with y := (plusTerm a (invTerm b)); Auto.
Apply eqTerm_sym; Apply zeroP_plusTerml; Auto.
Change (eqM a (invTerm b)); Apply eqM_trans with y := b; Auto.
Qed.

Theorem minusTerm_zeroP:
  (a, b:Term) (eqM a b) -> (zeroP b) ->(eqTerm (minusTerm a b) a).
Intros a b H' H'0.
Apply eqTerm_trans with y := (plusTerm a (invTerm b)); Auto.
Apply eqTerm_sym; Auto.
Apply zeroP_plusTermr; Auto.
Change (eqM a (invTerm b)); Apply eqM_trans with y := b; Auto.
Qed.
Hints Resolve minusTerm_zeroP minusTerm_zeroP_r.

Theorem minusP_pO_is_eqP:
  (p, q, r:(list Term)) (minusP p q r) -> (eqP r pO) ->(eqP p q).
Intros p q r H'; Elim H'; Auto.
Intros l1; Case l1; Simpl; Auto.
Intros a l H'0; Inversion H'0.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3; Inversion H'3.
2:Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3 H'4; Inversion H'4.
2:Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3; Inversion H'3.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3 H'4; Auto.
Apply eqpP1; Auto.
Apply zerop_is_eqTerm; Auto.
Qed.

Lemma minusP_inv:
  (p, q, l:(list Term)) (a, b:Term) (minusP (pX a p) (pX b q) l) ->
  (Ex [l1:(list Term)]
  (order b a) /\ ((minusP p (pX b q) l1) /\ l=(pX a l1)) \/
  ((order a b) /\ ((minusP (pX a p) q l1) /\ l=(pX (invTerm b) l1)) \/
   (eqM a b) /\
   ((zeroP (minusTerm a b)) /\ (minusP p q l) \/
    ~ (zeroP (minusTerm a b)) /\ ((minusP p q l1) /\ l=(pX (minusTerm a b) l1))))).
Intros p q l a b H'; Simple Inversion H'.
Discriminate H.
Discriminate H0.
Rewrite <- H3; Rewrite (pX_invl a2 b l2 q H2); Rewrite (pX_invr l2 q a2 b H2);
 Rewrite (pX_invl a1 a l1 p H1); Rewrite (pX_invr l1 p a1 a H1).
Intros H'0 H'1; Exists l3; Left; Split; [Idtac | Split]; Auto.
Rewrite <- H4.
Intros H'0 H'1 H'2; Exists l3; Right; Right.
Rewrite <- (pX_invl a2 b l2 q); Try Rewrite <- (pX_invl a1 a l1 p); Auto.
Rewrite <- (pX_invr l2 q a2 b); Try Rewrite <- (pX_invr l1 p a1 a); Auto.
Intros H'0 H'1 H'2; Exists l3; Right; Right.
Rewrite <- H4.
Rewrite <- (pX_invl a2 b l2 q); Try Rewrite <- (pX_invl a1 a l1 p); Auto.
Rewrite <- (pX_invr l2 q a2 b); Try Rewrite <- (pX_invr l1 p a1 a); Auto.
Intros H'0 H'1; Exists l3; Right; Left.
Rewrite <- (pX_invl a2 b l2 q); Try Rewrite <- (pX_invl a1 a l1 p); Auto.
Rewrite <- (pX_invr l2 q a2 b); Try Rewrite <- (pX_invr l1 p a1 a); Auto.
Qed.

Theorem uniq_minusp:
  (l:(list Term) * (list Term))
  (l3, l4:(list Term))
  (minusP (Fst l) (Snd l) l3) -> (minusP (Fst l) (Snd l) l4) ->l3=l4.
Unfold pX pX.
Intros l; Pattern l.
Apply well_founded_ind
     with A := (list Term) * (list Term) R := lessP 1 := wf_lessP.
Intros x; Case x; Clear x.
Intros l1 l2; Case l1; Clear l1.
Intros H' l3 l4 H'0 H'2; Inversion H'2; Inversion H'0; Auto.
Simpl; Simpl in H1; Rewrite <- H1; Auto.
Case l2; Clear l2.
Simpl; Intros n0 l0 H' l3 l4 H'0 H'2.
Inversion H'2; Inversion H'0; Auto.
Simpl; Intros n2 l2 n1 l1 Induc l3 l4 Hl3 Hl4.
Case (minusP_inv l1 l2 l4 n1 n2); Auto.
Intros x H'; Elim H'; Intros H'0; [Idtac | Elim H'0; Clear H'0; Intros H'0];
 Clear H';
 (Case (minusP_inv l1 l2 l3 n1 n2); Auto; Intros x1 H'; Elim H'; Intros H'1;
   [Idtac | Elim H'1; Clear H'1; Intros H'1]; Clear H').
Elim H'1; Intros H' H'2; Elim H'2; Intros H'3 H'4; Rewrite H'4; Clear H'2 H'1.
Elim H'0; Intros H'1 H'2; Elim H'2; Intros H'5 H'6; Rewrite H'6; Clear H'2 H'0.
Apply pX_inj; Auto.
Apply Induc with y := (l1, (pX n2 l2)); Auto.
Red; Red; Simpl; Auto.
Elim H'1; Intros H' H'2; Clear H'1.
Elim H'0; Intros H'1 H'3; Clear H'0.
Absurd (order n1 n2); Auto.
Elim H'1; Intros H' H'2; Clear H'1.
Elim H'0; Intros H'1 H'3; Clear H'0.
Absurd (eqM n2 n1); Auto.
Apply eqM_sym; Auto.
Elim H'1; Intros H' H'2; Clear H'1.
Elim H'0; Intros H'1 H'3; Clear H'0.
Absurd (order n1 n2); Auto.
Elim H'1; Intros H' H'2; Elim H'2; Intros H'3 H'4; Rewrite H'4; Clear H'2 H'1.
Elim H'0; Intros H'1 H'2; Elim H'2; Intros H'5 H'6; Rewrite H'6; Clear H'2 H'0.
Apply pX_inj; Auto.
Apply Induc with y := ((pX n1 l1), l2); Auto; Red; Simpl; Auto.
Red; Red; Simpl; Rewrite <- plus_n_Sm; Auto.
Elim H'1; Intros H' H'2; Clear H'1.
Elim H'0; Intros H'1 H'3; Clear H'0.
Absurd (eqM n1 n2); Auto.
Elim H'1; Intros H' H'2; Clear H'1.
Elim H'0; Intros H'1 H'3; Clear H'0.
Absurd (eqM n2 n1); Auto.
Apply eqM_sym; Auto.
Elim H'1; Intros H' H'2; Clear H'1.
Elim H'0; Intros H'1 H'3; Clear H'0.
Absurd (eqM n1 n2); Auto.
Elim H'1; Intros H' H'2; Elim H'2;
 [Intros H'3; Clear H'2 H'1 |
   Intros H'3; Elim H'3; Intros H'4 H'5; Elim H'5; Intros H'6 H'7; Rewrite H'7;
    Clear H'5 H'3 H'2 H'1].
Elim H'0; Intros H'1 H'2; Elim H'2;
 [Intros H'4; Clear H'2 H'0 |
   Intros H'4; Elim H'4; Intros H'5 H'6; Apply H'5 Orelse Elim H'5;
    Try Assumption; Clear H'4 H'2 H'0].
Elim H'4; Intros H'0 H'2; Clear H'4.
Elim H'3; Intros H'4 H'5; Clear H'3.
Apply Induc with y := (l1, l2); Auto.
Red; Red; Simpl; Rewrite <- plus_n_Sm; Auto.
Elim H'3; Intros H'0 H'2; Clear H'3; Auto.
Elim H'0; Intros H'1 H'2; Elim H'2;
 [Intros H'3; Clear H'2 H'0 |
   Intros H'3; Elim H'3; Intros H'5 H'8; Elim H'8; Intros H'9 H'10;
    Rewrite H'10; Clear H'8 H'3 H'2 H'0].
Elim H'3; Intros H'0 H'2; Clear H'3.
Apply H'4 Orelse Elim H'4; Auto.
Apply pX_inj; Auto.
Apply Induc with y := (l1, l2); Auto.
Red; Red; Simpl; Rewrite <- plus_n_Sm; Auto.
Qed.

Theorem minuspf_is_minusP: (l1, l2:(list Term))(minusP l1 l2 (minuspf l1 l2)).
Intros l1 l2; Try Assumption.
Unfold minuspf; Case (minuspp <(list Term), (list Term)> (l1, l2)); Simpl; Auto.
Qed.
Hints Resolve minuspf_is_minusP.

Theorem minuspf_pO_is_eqP:
  (p, q:(list Term)) (eqP (minuspf p q) pO) ->(eqP p q).
Intros p q H'.
Apply minusP_pO_is_eqP with r := (minuspf p q); Auto.
Qed.

Theorem minusTerm_eqM1: (m1, m2:Term) (eqM m1 m2) ->(eqM (minusTerm m1 m2) m1).
Exact minusTerm_eq.
Qed.
Hints Resolve minusTerm_eqM1.

Theorem nZero_invTerm_nZero: (a:Term) ~ (zeroP a) ->~ (zeroP (invTerm a)).
Intros a H'; Red; Intros H'0; Absurd (zeroP a); Auto.
Apply zeroP_comp_eqTerm with a := (invTerm (invTerm a)); Auto.
Qed.
Hints Resolve nZero_invTerm_nZero.

Theorem order_minusP:
  (l1, l2, l3:(list Term))
  (a:Term)
  (minusP l1 l2 l3) ->
  (canonical (pX a l1)) -> (canonical (pX a l2)) -> (canonical l3) ->
  (canonical (pX a l3)).
Intros l1 l2 l3 a H'; Elim H'; Auto.
Intros l4 H'0 H'1 H'2.
Cut (canonical l4); Try Apply canonical_imp_canonical with a := a; Auto;
 Intros C0.
Apply canonical_pX_eqM with a := (multTerm (invTerm T1) a); Auto.
Apply eqM_sym; Apply eqM_trans with y := (multTerm T1 a); Auto.
Apply canonical_nzeroP with p := l4; Auto.
Intros a1 a2 l4 l5 l6 H'0 H'1 H'2 H'3 H'4 H'5.
Apply canonical_cons; Auto.
Apply canonical_imp_order with l := l4; Auto.
Apply canonical_nzeroP with p := (pX a1 l4); Auto.
Intros a1 a2 l4 l5 l6 H'0 H'1 H'2 H'3 H'4 H'5 H'6.
Apply H'1; Auto.
Apply canonical_skip_fst with b := a1; Auto.
Apply canonical_skip_fst with b := a2; Auto.
Intros a1 a2 l4 l5 l6 H'0 H'1 H'2 H'3 H'4 H'5 H'6.
Apply canonical_cons; Auto.
Apply minusTerm_order_l; Auto.
Apply canonical_imp_order with l := l4; Auto.
Apply canonical_nzeroP with p := (pX a1 l4); Auto.
Intros a1 a2 l4 l5 l6 H'0 H'1 H'2 H'3 H'4 H'5.
Apply canonical_cons; Auto.
Apply invTerm_order_l; Auto.
Apply canonical_imp_order with l := l5; Auto.
Apply canonical_nzeroP with p := (pX a1 l4); Auto.
Qed.

Theorem canonical_minusP:
  (l1, l2, l3:(list Term))
  (minusP l1 l2 l3) -> (canonical l1) -> (canonical l2) ->(canonical l3).
Intros l1 l2 l3 H'; Elim H'; Auto.
Intros a1 a2 l4 l5 l6 H'0 H'1 H'2 H'3 H'4.
Apply order_minusP with l1 := l4 l2 := (pX a2 l5); Auto.
Apply canonical_cons; Auto.
Apply canonical_nzeroP with p := l4; Auto.
Apply H'2; Auto.
Apply canonical_imp_canonical with a := a1; Auto.
Intros a1 a2 l4 l5 l6 H'0 H'1 H'2 H'3 H'4 H'5.
Apply H'1; Auto.
Apply canonical_imp_canonical with a := a1; Auto.
Apply canonical_imp_canonical with a := a2; Auto.
Intros a1 a2 l4 l5 l6 H'0 H'1 H'2 H'3 H'4 H'5.
Apply order_minusP with l1 := l4 l2 := l5; Auto.
Apply canonical_pX_eqM with a := a1; Auto.
Apply eqM_sym; Auto.
Apply canonical_pX_eqM with a := a2; Auto; Auto.
Apply eqM_trans with y := a1; Apply eqM_sym; Auto.
Apply H'1.
Apply canonical_imp_canonical with a := a1; Auto.
Apply canonical_imp_canonical with a := a2; Auto.
Intros a1 a2 l4 l5 l6 H'0 H'1 H'2 H'3 H'4.
Apply order_minusP with l1 := (pX a1 l4) l2 := l5; Auto.
Apply canonical_pX_eqM with a := a2; Auto.
Apply canonical_pX_eqM with a := a2; Auto.
Apply canonical_cons; Auto.
Apply canonical_nzeroP with p := l5; Auto.
Apply canonical_nzeroP with p := l5; Auto.
Apply nZero_invTerm_nZero; Auto.
Apply canonical_nzeroP with p := l5; Auto.
Apply canonical_pX_eqM with a := a2; Auto.
Apply nZero_invTerm_nZero; Auto.
Apply canonical_nzeroP with p := l5; Auto.
Apply H'2; Auto.
Apply canonical_imp_canonical with a := a2; Auto.
Qed.

Theorem canonical_minuspf:
  (l1, l2:(list Term)) (canonical l1) -> (canonical l2) ->
  (canonical (minuspf l1 l2)).
Intros l1 l2 H' H'0; Generalize (minuspf_is_minusP l1 l2); Intros u1.
Apply canonical_minusP with l1 := l1 l2 := l2; Auto.
Qed.

Lemma invTerm_eqM_comp: (a, b:Term) (eqM a b) ->(eqM a (invTerm b)).
Intros a b H'.
Apply eqM_trans with y := b; Auto.
Qed.

Lemma invTerm_T1_eqM_comp:
  (a, b:Term) (eqM a b) ->(eqM a (invTerm (multTerm T1 b))).
Intros a b H'.
Apply eqM_trans with y := b; Auto.
Apply eqM_trans with y := (multTerm T1 b); Auto.
Qed.

Lemma multTerm_invTerm_T1_eqM_comp:
  (a, b:Term) (eqM a b) ->(eqM a (multTerm (invTerm T1) b)).
Intros a b H'.
Apply eqM_trans with y := b; Auto.
Apply eqM_trans with y := (multTerm T1 b); Auto.
Qed.
Hints Resolve invTerm_eqM_comp invTerm_T1_eqM_comp multTerm_invTerm_T1_eqM_comp
.

Lemma minusP_is_plusP_multm_lm:
  (p, q, r:(list Term)) (minusP p q r) ->
  (eqP r (pluspf p (multm_lm (invTerm T1) q))).
Intros p q r H'; Elim H'; Simpl; Auto.
Intros; Apply eqp_sym; Auto.
Intros; Apply eqp_sym; Auto.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2.
Apply eqp_trans
     with y :=
          (pX
             a1
             (pluspf
                l1 (pX (multTerm (invTerm T1) a2) (multm_lm (invTerm T1) l2))));
 Auto.
Apply pluspf_inv1; Auto.
Apply order_eqM_r with a := a2; Auto.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3.
Apply eqp_trans with y := (pluspf l1 (multm_lm (invTerm T1) l2)); Auto.
Apply pluspf_inv3a; Auto.
Apply zeroP_comp_eqTerm with a := (minusTerm a1 a2); Auto.
Apply eqTerm_trans with y := (plusTerm a1 (invTerm a2)); Auto.
Apply eqTerm_sym; Auto.
Apply plusTerm_comp_r; Auto.
Change (eqM a1 (multTerm (invTerm T1) a2)); Auto.
Change (eqM a1 (invTerm a2)); Auto.
Apply eqTerm_trans with y := (invTerm (multTerm T1 a2)); Auto.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3.
Apply eqp_trans
     with y :=
          (pX
             (plusTerm a1 (multTerm (invTerm T1) a2))
             (pluspf l1 (multm_lm (invTerm T1) l2))); Auto.
Apply eqpP1; Auto.
Apply eqTerm_trans with y := (plusTerm a1 (invTerm a2)); Auto.
Apply eqTerm_plusTerm_comp; Auto.
Change (eqM a1 (invTerm a2)); Auto.
Change (eqM a1 (multTerm (invTerm T1) a2)); Auto.
Apply eqTerm_trans with y := (invTerm (multTerm T1 a2)); Auto.
Apply pluspf_inv3b; Auto.
Apply nzeroP_comp_eqTerm with a := (minusTerm a1 a2); Auto.
Apply eqTerm_trans with y := (plusTerm a1 (invTerm a2)); Auto.
Apply eqTerm_plusTerm_comp; Auto.
Change (eqM a1 (invTerm a2)); Auto.
Change (eqM a1 (multTerm (invTerm T1) a2)); Auto.
Apply eqTerm_trans with y := (invTerm (multTerm T1 a2)); Auto.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2.
Apply eqp_trans
     with y :=
          (pX
             (multTerm (invTerm T1) a2)
             (pluspf (pX a1 l1) (multm_lm (invTerm T1) l2))); Auto.
Apply eqpP1; Auto.
Apply eqTerm_trans with y := (invTerm (multTerm T1 a2)); Auto.
Apply pluspf_inv2; Auto.
Apply order_eqM_l with a := a2; Auto.
Qed.

Theorem minuspf_is_pluspf_multm_lm:
  (p, q:(list Term))(eqP (minuspf p q) (pluspf p (multm_lm (invTerm T1) q))).
Intros p q; Try Assumption.
Apply minusP_is_plusP_multm_lm with p := p q := q; Auto.
Qed.
Hints Resolve minuspf_is_pluspf_multm_lm.

Theorem pO_minusP_inv1:
  (p, q:(list Term)) (minusP pO p q) ->q=(multm_lm (invTerm T1) p).
Intros p; Elim p.
Intros q H'; Inversion H'; Auto.
Intros a l H' q H'0; Inversion H'0; Auto.
Qed.

Theorem pO_minusP_inv2: (p, q:(list Term)) (minusP p pO q) ->p=q.
Intros p; Elim p.
Intros q H'; Inversion H'; Auto.
Intros a l H' q H'0; Inversion H'0; Auto.
Qed.

Theorem minusP_inv1:
  (a, b:Term)
  (p, q, s:(list Term)) (minusP (pX a p) (pX b q) s) -> (order b a) ->
  s=(pX a (minuspf p (pX b q))).
Intros a b p q s H'; Simple Inversion H'.
Inversion H.
Inversion H0.
Rewrite <- H3; Rewrite <- (pX_invl a1 a l1 p);
 Try Rewrite <- (pX_invl a2 b l2 q); Auto.
Rewrite <- (pX_invr l2 q a2 b); Try Rewrite <- (pX_invr l1 p a1 a); Auto.
Intros H'0 H'1 H'2; Apply pX_inj; Auto.
Apply uniq_minusp with l := (l1, (pX a2 l2)); Simpl; Auto.
Rewrite <- (pX_invl a1 a l1 p); Try Rewrite <- (pX_invl a2 b l2 q); Auto.
Intros H'0 H'1 H'2 H'3; Absurd (order a2 a1); Auto.
Apply order_not_eqM; Auto; Apply eqM_sym; Auto.
Rewrite <- (pX_invl a1 a l1 p); Try Rewrite <- (pX_invl a2 b l2 q); Auto.
Intros H'0 H'1 H'2 H'3; Absurd (order a2 a1); Auto.
Apply order_not_eqM; Auto; Apply eqM_sym; Auto.
Intros H'0 H'1 H'2; Absurd (order a2 a1); Auto.
Rewrite (pX_invl a1 a l1 p); Try Rewrite (pX_invl a2 b l2 q); Auto.
Qed.

Theorem minusP_inv2:
  (a, b:Term)
  (p, q, s:(list Term)) (minusP (pX a p) (pX b q) s) -> (order a b) ->
  s=(pX (invTerm b) (minuspf (pX a p) q)).
Intros a b p q s H'; Simple Inversion H'.
Inversion H.
Inversion H0.
Rewrite <- (pX_invl a1 a l1 p); Try Rewrite <- (pX_invl a2 b l2 q); Auto.
Intros H'0 H'1 H'2; Absurd (order a2 a1); Auto.
Rewrite <- (pX_invl a1 a l1 p); Try Rewrite <- (pX_invl a2 b l2 q); Auto.
Intros H'0 H'1 H'2 H'3; Absurd (order a1 a2); Auto.
Rewrite <- (pX_invl a1 a l1 p); Try Rewrite <- (pX_invl a2 b l2 q); Auto.
Intros H'0 H'1 H'2 H'3; Absurd (order a1 a2); Auto.
Rewrite <- H3; Intros H'0 H'1 H'2; Apply pX_inj; Auto.
Rewrite <- (pX_invl a2 b l2 q); Auto.
Apply uniq_minusp with l := ((pX a1 l1), l2); Simpl; Auto.
Rewrite H1; Rewrite (pX_invr l2 q a2 b); Auto.
Qed.

Theorem minusP_inv3a:
  (a, b:Term)
  (p, q, s:(list Term))
  (eqM a b) -> (zeroP (minusTerm a b)) -> (minusP (pX a p) (pX b q) s) ->
  s=(minuspf p q).
Intros a b p q s Eqd Z0 H'; Simple Inversion H'.
Inversion H.
Inversion H0.
Rewrite (pX_invl a1 a l1 p); Try Rewrite (pX_invl a2 b l2 q); Auto.
Intros H'0; Absurd (order b a); Auto.
Apply order_not_eqM; Apply eqM_sym; Auto.
Rewrite <- H4; Rewrite <- (pX_invr l2 q a2 b);
 Try Rewrite <- (pX_invr l1 p a1 a); Auto.
Intros H'0 H'1 H'2; Apply uniq_minusp with l := (l1, l2); Auto.
Rewrite (pX_invl a1 a l1 p); Try Rewrite (pX_invl a2 b l2 q); Auto.
Intros H'0 H'1 H'2; Elim H'2; Try Assumption.
Intros H'0; Absurd (order a b); Auto.
Rewrite <- (pX_invl a1 a l1 p); Try Rewrite <- (pX_invl a2 b l2 q); Auto.
Qed.

Theorem minusP_inv3b:
  (a, b:Term)
  (p, q, s:(list Term))
  (eqM a b) -> ~ (zeroP (minusTerm a b)) -> (minusP (pX a p) (pX b q) s) ->
  s=(pX (minusTerm a b) (minuspf p q)).
Intros a b p q s Eqd Z0 H'; Simple Inversion H'.
Inversion H.
Inversion H0.
Rewrite (pX_invl a1 a l1 p); Try Rewrite (pX_invl a2 b l2 q); Auto.
Intros H'0; Absurd (order b a); Auto.
Apply order_not_eqM; Apply eqM_sym; Auto.
Try Rewrite <- H3; Try Rewrite <- (pX_invr l2 q a2 b);
 Try Rewrite <- (pX_invr l1 p a1 a); Auto.
Rewrite (pX_invl a1 a l1 p); Try Rewrite (pX_invl a2 b l2 q); Auto.
Intros H'0 H'1 H'2.
Elim Z0; Try Assumption.
Intros H'0 H'1 H'2; Rewrite <- H4.
Intros; Apply pX_inj; Auto.
Rewrite (pX_invl a1 a l1 p); Try Rewrite (pX_invl a2 b l2 q); Auto.
Apply uniq_minusp with l := (l1, l2); Auto.
Rewrite <- (pX_invr l2 q a2 b); Try Rewrite <- (pX_invr l1 p a1 a); Auto.
Intros H'0; Absurd (order a b); Auto.
Rewrite <- (pX_invl a1 a l1 p); Try Rewrite <- (pX_invl a2 b l2 q); Auto.
Qed.

Theorem minuspf_inv1_eq:
  (a, b:Term) (p, q:(list Term)) (order b a) ->
  (pX a (minuspf p (pX b q)))=(minuspf (pX a p) (pX b q)).
Intros a b p q H'; Try Assumption.
Rewrite (minusP_inv1 a b p q (minuspf (pX a p) (pX b q))); Auto.
Qed.

Theorem minuspf_inv2_eq:
  (a, b:Term) (p, q:(list Term)) (order a b) ->
  (pX (invTerm b) (minuspf (pX a p) q))=(minuspf (pX a p) (pX b q)).
Intros a b p q H'; Try Assumption.
Rewrite (minusP_inv2 a b p q (minuspf (pX a p) (pX b q))); Auto.
Qed.

Theorem minuspf_inv3a_eq:
  (a, b:Term) (p, q:(list Term)) (eqM a b) -> (zeroP (minusTerm a b)) ->
  (minuspf p q)=(minuspf (pX a p) (pX b q)).
Intros a b p q H' Z; Try Assumption.
Rewrite (minusP_inv3a a b p q (minuspf (pX a p) (pX b q))); Auto.
Qed.

Theorem minuspf_inv3b_eq:
  (a, b:Term) (p, q:(list Term)) (eqM a b) -> ~ (zeroP (minusTerm a b)) ->
  (pX (minusTerm a b) (minuspf p q))=(minuspf (pX a p) (pX b q)).
Intros a b p q H' Z; Try Assumption.
Rewrite (minusP_inv3b a b p q (minuspf (pX a p) (pX b q))); Auto.
Qed.

Theorem minuspf_inv1:
  (a, b:Term) (p, q:(list Term)) (order b a) ->
  (eqP (pX a (minuspf p (pX b q))) (minuspf (pX a p) (pX b q))).
Intros a b p q H'; Try Assumption.
Rewrite (minusP_inv1 a b p q (minuspf (pX a p) (pX b q))); Auto.
Qed.

Theorem minuspf_inv2:
  (a, b:Term) (p, q:(list Term)) (order a b) ->
  (eqP (pX (invTerm b) (minuspf (pX a p) q)) (minuspf (pX a p) (pX b q))).
Intros a b p q H'; Try Assumption.
Rewrite (minusP_inv2 a b p q (minuspf (pX a p) (pX b q))); Auto.
Qed.

Theorem minuspf_inv3a:
  (a, b:Term) (p, q:(list Term)) (eqM a b) -> (zeroP (minusTerm a b)) ->
  (eqP (minuspf p q) (minuspf (pX a p) (pX b q))).
Intros a b p q H' Z; Try Assumption.
Rewrite (minusP_inv3a a b p q (minuspf (pX a p) (pX b q))); Auto.
Qed.

Theorem minuspf_inv3b:
  (a, b:Term) (p, q:(list Term)) (eqM a b) -> ~ (zeroP (minusTerm a b)) ->
  (eqP (pX (minusTerm a b) (minuspf p q)) (minuspf (pX a p) (pX b q))).
Intros a b p q H' Z; Try Assumption.
Rewrite (minusP_inv3b a b p q (minuspf (pX a p) (pX b q))); Auto.
Qed.
Hints Resolve pluspf_inv1 pluspf_inv2 pluspf_inv3a pluspf_inv3b.
Hints Resolve minuspf_inv1 minuspf_inv2 minuspf_inv3a minuspf_inv3b.

Theorem minuspf_comp:
  (p, q, r, s:(list Term))
  (canonical p) ->
  (canonical q) -> (canonical r) -> (canonical s) -> (eqP p r) -> (eqP q s) ->
  (eqP (minuspf p q) (minuspf r s)).
Intros p q r s H' H'0 H'1 H'2 H'3 H'4;
 Apply eqp_trans with y := (pluspf p (multm_lm (invTerm T1) q)).
Apply minuspf_is_pluspf_multm_lm; Auto.
Apply eqp_trans with y := (pluspf r (multm_lm (invTerm T1) s)); Auto.
Apply eqp_sym; Auto.
Qed.

Theorem multlm_lm_dist_minuspf:
  (p, q:(list Term)) (a:Term) (canonical p) -> (canonical q) -> ~ (zeroP a) ->
  (eqP (multm_lm a (minuspf p q)) (minuspf (multm_lm a p) (multm_lm a q))).
Intros p q a H' H'0 H'1.
Apply eqp_trans with y := (multm_lm a (pluspf p (multm_lm (invTerm T1) q)));
 Auto.
Apply eqp_trans
     with y := (pluspf (multm_lm a p) (multm_lm a (multm_lm (invTerm T1) q)));
 Auto.
Apply eqp_trans
     with y := (pluspf (multm_lm a p) (multm_lm (multTerm a (invTerm T1)) q));
 Auto.
Apply eqp_sym; Auto.
Apply eqp_trans
     with y := (pluspf (multm_lm a p) (multm_lm (multTerm (invTerm T1) a) q));
 Auto.
Apply eqp_trans
     with y := (pluspf (multm_lm a p) (multm_lm (invTerm T1) (multm_lm a q)));
 Auto.
Apply eqp_sym; Auto.
Qed.
Hints Resolve multlm_lm_dist_minuspf.

Theorem minuspf_pO_refl: (p:(list Term))(eqP (minuspf p pO) p).
Intros p; Apply eqp_trans with y := (pluspf p (multm_lm (invTerm T1) pO)); Auto;
 Simpl; Auto.
Qed.
Hints Resolve minuspf_pO_refl.

Theorem minuspf_pOmultm_lm:
  (p:(list Term))(eqP (minuspf pO p) (multm_lm (invTerm T1) p)).
Intros p; Apply eqp_trans with y := (pluspf pO (multm_lm (invTerm T1) p)); Auto;
 Simpl; Auto.
Qed.
Hints Resolve minuspf_pOmultm_lm.

Theorem multlm_lm_pO:
  (p:(list Term)) (a, b:Term) (eqM a b) -> (zeroP (minusTerm a b)) ->
  (eqP pO (minuspf (multm_lm a p) (multm_lm b p))).
Intros p; Elim p.
Simpl; Auto.
Intros a b H' H'0; Apply eqp_sym; Auto.
Intros a l H' a0 b H'0 H'1; Simpl.
Apply eqp_trans with y := (minuspf (multm_lm a0 l) (multm_lm b l)); Auto.
Apply minuspf_inv3a; Auto.
Apply zeroP_comp_eqTerm with a := (multTerm (minusTerm a0 b) a); Auto.
Qed.

Theorem multlm_lm_minusTerm:
  (p:(list Term))
  (a, b:Term) (eqM a b) -> ~ (zeroP (minusTerm a b)) -> (canonical p) ->
  (eqP (multm_lm (minusTerm a b) p) (minuspf (multm_lm a p) (multm_lm b p))).
Intros p; Elim p.
Simpl; Auto.
Intros a b H' H'0 H'1; Apply eqp_sym; Auto.
Intros a l H' a0 b H'0 H'1 H'2; Simpl; Auto.
Cut (canonical l); Try Apply canonical_imp_canonical with a := a; Auto;
 Intros Z0; Auto.
Apply eqp_trans
     with y :=
          (pX
             (minusTerm (multTerm a0 a) (multTerm b a))
             (minuspf (multm_lm a0 l) (multm_lm b l))); Auto.
Apply minuspf_inv3b; Auto.
Apply nzeroP_comp_eqTerm with a := (multTerm (minusTerm a0 b) a); Auto.
Apply nzeroP_nonZerop_imp_zeroPl; Auto.
Apply canonical_nzeroP with p := l; Auto.
Qed.

Theorem order_pluspf:
  (l1, l2:(list Term))
  (a:Term) (canonical (pX a l1)) -> (canonical (pX a l2)) ->
  (canonical (pX a (pluspf l1 l2))).
Intros l1 l2 a H' H'0.
Apply (order_plusP
         ? ? T2M zeroP zeroP_dec ltM ltM_trans plusTerm plusTerm_eqM1 l1 l2
         (pluspf l1 l2)); Auto.
Apply (pluspf_is_plusP ? ? T2M zeroP zeroP_dec ltM ltM_dec plusTerm); Auto.
Apply canonical_pluspf; Auto.
Apply canonical_imp_canonical with a := a; Auto.
Apply canonical_imp_canonical with a := a; Auto.
Qed.
Hints Resolve order_pluspf.

Theorem order_minuspf:
  (l1, l2:(list Term))
  (a:Term) (canonical (pX a l1)) -> (canonical (pX a l2)) ->
  (canonical (pX a (minuspf l1 l2))).
Intros l1 l2 a H' H'0.
Apply eqp_imp_canonical with p := (pX a (pluspf l1 (multm_lm (invTerm T1) l2)));
 Auto.
Apply eqp_sym; Auto.
Apply order_pluspf; Auto.
Apply canonical_pX_eqM with a := (multTerm (invTerm T1) a); Auto.
Apply eqM_sym; Auto.
Apply canonical_nzeroP with p := l1; Auto.
Qed.

Theorem minusP_refl: (p, q, r:(list Term)) (minusP p q r) -> p=q ->r=pO.
Intros p q r H'; Elim H'; Auto.
Intros l1 H'0; Rewrite <- H'0; Simpl; Auto.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3; Generalize H'0.
Rewrite (pX_invl a1 a2 l1 l2); Auto; Intros Ord.
Absurd (order a2 a2); Auto.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3 H'4.
Apply H'1; Auto.
Apply pX_invr with a := a1 b := a2; Auto.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3 H'4; Elim H'3; Auto.
Rewrite (pX_invl a1 a2 l1 l2); Auto.
Apply zeroP_comp_eqTerm with a := (plusTerm a2 (invTerm a2)); Auto.
Intros a1 a2 l1 l2 l3 H'0 H'1 H'2 H'3; Generalize H'0.
Rewrite (pX_invl a1 a2 l1 l2); Auto; Intros Ord.
Absurd (order a2 a2); Auto.
Qed.

Theorem minuspf_refl_eq: (p:(list Term))(minuspf p p)=pO.
Intros p; Rewrite (minusP_refl p p (minuspf p p)); Auto.
Qed.

Theorem minuspf_refl: (p:(list Term))(eqP (minuspf p p) pO).
Intros p.
Rewrite (minusP_refl p p (minuspf p p)); Auto.
Qed.

Theorem multm_lm_comp_minuspf:
  (a:Term) (p, q:(list Term)) (canonical p) -> (canonical q) -> ~ (zeroP a) ->
  (eqP (minuspf (multm_lm a p) (multm_lm a q)) (multm_lm a (minuspf p q))).
Intros a p q H' H'0 H'1.
Apply eqp_trans
     with y := (pluspf (multm_lm a p) (multm_lm (invTerm T1) (multm_lm a q)));
 Auto.
Apply eqp_trans
     with y := (pluspf (multm_lm a p) (multm_lm (multTerm (invTerm T1) a) q));
 Auto.
Apply eqp_sym; Auto.
Apply eqp_trans
     with y := (pluspf (multm_lm a p) (multm_lm (multTerm a (invTerm T1)) q));
 Auto.
Apply eqp_trans
     with y := (pluspf (multm_lm a p) (multm_lm a (multm_lm (invTerm T1) q)));
 Auto.
Apply eqp_trans with y := (multm_lm a (pluspf p (multm_lm (invTerm T1) q)));
 Auto.
Apply eqp_sym; Auto.
Apply eqp_sym; Auto.
Qed.

Theorem minuspf_zero:
  (a:Term) (p, q:(list Term))(eqP (minuspf (pX a p) (pX a q)) (minuspf p q)).
Intros a p q; Try Assumption.
Apply eqp_trans with y := (minuspf p q); Auto.
Apply eqp_sym.
Apply minuspf_inv3a; Auto.
Apply zeroP_comp_eqTerm with a := (plusTerm a (invTerm a)); Auto.
Qed.
Hints Resolve canonical_minuspf.

Theorem pluspf_minuspf_id:
  (p, q:(list Term)) (canonical p) -> (canonical q) ->
  (eqP (pluspf (minuspf p q) q) p).
Intros p q H' H'0.
Apply eqp_trans with y := (pluspf (pluspf p (multm_lm (invTerm T1) q)) q); Auto.
Apply eqp_trans with y := (pluspf p (pluspf (multm_lm (invTerm T1) q) q)); Auto.
Apply eqp_trans with y := (pluspf p (pluspf q (multm_lm (invTerm T1) q))); Auto.
Apply eqp_trans with y := (pluspf p pO); Auto.
Qed.

Theorem minusP_pO_refl_eq: (p, q:(list Term)) (minusP p pO q) ->p=q.
Intros p q H'; Inversion H'; Simpl; Auto.
Qed.

Theorem minuspf_pO_refl_eq: (p:(list Term))(minuspf p pO)=p.
Intros p.
Rewrite <- (minusP_pO_refl_eq p (minuspf p pO)); Auto.
Qed.

Theorem Opm_ind:
  (P:(list Term) -> (list Term) ->Prop)
  (p, q:(list Term))
  ((p:(list Term))(P pO p)) ->
  ((p:(list Term))(P p pO)) ->
  ((a, b:Term) (p, q:(list Term)) (P (pX a p) q) -> (order a b) ->
   (P (pX a p) (pX b q))) ->
  ((a, b:Term) (p, q:(list Term)) (P p (pX b q)) -> (order b a) ->
   (P (pX a p) (pX b q))) ->
  ((a, b:Term) (p, q:(list Term)) (P p q) -> (eqM a b) ->(P (pX a p) (pX b q))) ->
  (p, q:(list Term))(P p q).
Intros P H' H'0 H'1 H'2 H'3 H'4 H'5 p; Elim p; Auto.
Intros a l H'6 q; Elim q; Auto.
Intros a0 l0 H'7;
 (Case (order_dec a a0); [Intros temp; Case temp; Clear temp | Idtac];
   Intros test); Auto.
Qed.

Theorem minuspf_eq_inv1:
  (a:Term) (p, q:(list Term)) (canonical (pX a p)) -> (canonical (pX a q)) ->
  (eqP (pX a (minuspf p q)) (minuspf (pX a p) q)).
Intros a p q; Case q; Simpl; Auto.
Intros H' H'0; Rewrite minuspf_pO_refl_eq; Rewrite minuspf_pO_refl_eq; Auto.
Intros a0 l H' H'0.
Apply minuspf_inv1; Auto.
Apply canonical_imp_order with l := l; Auto.
Qed.

Theorem minuspf_pOmultm_lm_eq:
  (p:(list Term))(minuspf pO p)=(multm_lm (invTerm T1) p).
Intros p; Apply uniq_minusp with l := (pO, p); Auto.
Qed.

Theorem minuspf_eq_inv2:
  (a:Term) (p, q:(list Term)) (canonical (pX a p)) -> (canonical (pX a q)) ->
  (eqP (pX (invTerm a) (minuspf p q)) (minuspf p (pX a q))).
Intros a p; Elim p; Auto.
Intros q H' H'0; Rewrite minuspf_pOmultm_lm_eq.
Rewrite minuspf_pOmultm_lm_eq; Simpl.
Apply eqpP1; Auto.
Apply eqTerm_trans with y := (invTerm (multTerm T1 a)); Auto.
Intros a0 l H' q H'0 H'1.
Change (eqP (pX (invTerm a) (minuspf (pX a0 l) q)) (minuspf (pX a0 l) (pX a q))).
Rewrite <- (minuspf_inv2_eq a0 a l q); Auto.
Apply canonical_imp_order with l := l; Auto.
Qed.

Definition inv: (list Term) -> Term ->Term.
Intros p; Case p.
Intros a; Exact (multTerm (invTerm T1) a).
Intros a1 p1 a; Exact (invTerm a).
Defined.

Theorem inv_prop:
  (a:Term) (p, q:(list Term)) (canonical (pX a p)) ->
  (minuspf p (pX a q))=(pX (inv p a) (minuspf p q)).
Intros a p q; Case p; Simpl; Auto.
Intros H'.
Change <(list Term)>
         (minuspf pO (pX a q))=(pX (multTerm (invTerm T1) a) (minuspf pO q)).
Rewrite (minuspf_pOmultm_lm_eq (pX a q)); Simpl; Auto.
Rewrite (minuspf_pOmultm_lm_eq q); Simpl; Auto.
Intros a0 l H'.
Change <(list Term)>
         (minuspf (pX a0 l) (pX a q))=(pX (invTerm a) (minuspf (pX a0 l) q)).
Rewrite <- (minuspf_inv2_eq a0 a l q); Auto.
Apply canonical_imp_order with l := l; Auto.
Qed.
Hints Resolve inv_prop.

Theorem multm_T1: (p:(list Term))(eqP p (multm_lm T1 p)).
Intros p; Elim p; Simpl; Auto.
Qed.
Hints Resolve multm_T1.

Theorem invTerm_T1_multTerm_T1:
  (eqTerm (multTerm (invTerm T1) (invTerm T1)) T1).
Apply eqTerm_trans with y := (invTerm (multTerm T1 (invTerm T1)));
 [Auto | Idtac].
Apply eqTerm_trans with y := (invTerm (invTerm T1)); Auto.
Qed.
Hints Resolve invTerm_T1_multTerm_T1.

Theorem pluspf_is_minuspf:
  (p, q:(list Term)) (canonical p) -> (canonical q) ->
  (eqP (pluspf p q) (minuspf p (multm_lm (invTerm T1) q))).
Intros p q Opp Opq;
 Apply eqp_trans
      with y := (pluspf p (multm_lm (invTerm T1) (multm_lm (invTerm T1) q)));
 Auto.
Apply eqp_trans
     with y := (pluspf p (multm_lm (multTerm (invTerm T1) (invTerm T1)) q));
 Auto.
Apply eqp_trans
     with y := (pluspf p (multm_lm (invTerm (multTerm T1 (invTerm T1))) q));
 Auto.
Apply eqp_trans with y := (pluspf p (multm_lm (invTerm (invTerm T1)) q)); Auto.
Apply eqp_trans with y := (pluspf p (multm_lm T1 q)); Auto.
Apply eqp_pluspf_com; Auto; Apply multm_lm_comp; Auto.
Apply eqp_pluspf_com; Auto; Apply multm_lm_comp; Auto.
Apply eqp_sym; Auto.
Qed.

Definition sminus: poly -> poly ->poly.
Intros sp1 sp2.
Case sp1; Case sp2.
Intros p1 H'1 p2 H'2; Exists (minuspf p1 p2); Auto.
Defined.
End SMinus.
